R News

CHANGES IN R VERSION 2.15.2:

  NEW FEATURES:

    * The X11() window gains an icon: the latter may be especially
      useful on Ubuntu's 'Unity' interface.

      The WM_CLASS should be set in circumstances where the Window
      Manager failed to make use of X11 resource settings.

      (Contributed by Philip Johnson.)

    * The "Date" and "POSIXt" methods for cut() will accept an unsorted
      breaks argument (as the default method does, although this was
      undocumented).  (Wish of PR#14961.)

    * Reference class methods (in the methods package) that use other
      methods in an indirect way (e.g., by sapply()) must tell the code
      analysis to include that method.  They can now do so by invoking
      $usingMethods().

    * More Polish translations are available: for the RGui menus and
      for several recommended packages.

    * Multistratum MANOVA works. In fact, it seems to have done so for
      years in spite of the help page claiming it did not.

    * qqline() has new optional arguments distribution, probs and
      qtype, following the example of lattice's panel.qqmathline().

    * The handling of single quotes in the en@quot pseudo-language has
      been slightly improved.  Double quotes are no longer converted.

    * New functions checkPoFiles() and checkPoFile() have been added to
      the tools package to check for consistency of format strings in
      translation files.

    * model.matrix(~1, ...) now also contains the same rownames that
      less trivial formulae produce.  (Wish of PR#14992, changes the
      output of several packages.)

    * Misuse of rep() on undocumented types of objects (e.g. calls) is
      now reported as an error.

    * The included LAPACK has been updated to 3.4.1, with some patches
      from the current SVN sources.  (_Inter alia_, this resolves
      PR#14692.)

    * file.copy(recursive = TRUE) has some additional checks on user
      error leading to attempted infinite recursion (and on some
      platforms to crashing R).

    * PCRE has been updated to version 8.31, a bug-fix release.

    * The included version of liblzma has been updated to version
      5.0.4, a minor bug-fix release.

    * New function .bincode(), a 'bare-bones' version of
      cut.default(labels = FALSE) for use in packages with image()
      methods.

    * The HTML manuals now use directional single quotes.

    * maintainer() now converts embedded new lines to spaces.  It no
      longer gives a non-obvious error for non-installed packages.

    * The X11() device has some protection against being used with
      forked processes _via_ package parallel.

    * Setting the environment variable R_OSX_VALGRIND (to any value)
      allows R to be run under valgrind on Mac OS 10.6 and 10.7
      (valgrind currently has very limited support for 10.8), provided
      system() is not used (directly or indirectly).  This should not
      be needed for valgrind >= 3.8.1.

    * The model.frame() method for "lm" uses xlevels: this is safer if
      data was supplied or model = FALSE was used and the levels of
      factors used in the fit had been re-ordered since fitting.

      Similarly, model.frame(fm, data=<data>) copies across the
      variables used for safe prediction from the fit.

    * Functions such as parLapply() in package parallel can make use of
      a default cluster if one is set.  (Reported by Martin Morgan.)

    * chol(pivot = TRUE, LINPACK = FALSE) is now available using LAPACK
      3.2 subroutine DPSTRF.

    * The functions .C(), .Call(), .External() and .Fortran() now check
      that they are called with an unnamed first argument: the formal
      arguments were changed from name= to .NAME= in R 2.13.0, but some
      packages were still using the old name.  This is currently a
      warning, but will be an error in future.

    * step() no longer tries to improve a model with AIC of -Inf (a
      perfect fit).

    * spline() and splinefun() gain a new method "hyman", an
      implementation of Hyman's method of constructing monotonic
      interpolation splines.  (Based on contributions of Simon Wood and
      Rob Hyndman.)

    * On Windows, the C stack size has been increased to 64MB (it has
      been 10MB since the days of 32MB RAM systems).

  PERFORMANCE IMPROVEMENTS:

    * array() is now implemented in C code (for speed) when data is
      atomic or an unclassed list (so it is known that as.vector(data)
      will have no class to be used by rep()).

    * rep() is faster and uses less memory, substantially so in some
      common cases (e.g. if times is of length one or length.out is
      given, and each = 1).

    * findInterval(), tabulate(), cut(), hist() and image.default() all
      use .Call() and are more efficient.

    * duplicated(), unique() and similar now support vectors of lengths
      above 2^29 on 64-bit platforms.

    * Omitting PACKAGE in .C() etc calls was supposed to make use of
      the DLL from the namespace within which the enclosing function
      was defined.  It was less successful in doing so than it might
      be, and gave no indication it had failed.

      A new search strategy is very successful and gives a warning when
      it fails.  In most cases this is because the entry point is not
      actually provided by that package (and so PACKAGE should be used
      to indicate which package is intended) but in some the namespace
      does not have a DLL specified by a useDynLib() directive so
      PACKAGE is required.

  UTILITIES:

    * R CMD check now checks if a package can be loaded by
      library(pkgname, lib.loc = "somewhere") without being on the
      library search path (unless it is already installed in .Library,
      when it always will be).

    * R CMD check --as-cran notes 'hidden' files and directories (with
      names starting with a dot) that are not needed for the operation
      of R CMD INSTALL or R CMD build: such files should be excluded
      from the published tarball.

    * R CMD check (if checking subdirectories) checks that the R code
      in any demos is ASCII and can be parsed, and warns if not.

    * When R CMD Rd2pdf is used with inputenx.sty, it allows further
      characters (mainly for Eastern European languages) by including
      ix-utf8enc.dfu (if available).  (Wish of PR#14989.)

    * R CMD build now omits several types of hidden files/directories,
      including inst/doc/.Rinstignore, vignettes/.Rinstignore,
      (.Rinstignore should be at top level), .deps under src,
      .Renviron, .Rprofile, .Rproj.user, .backups, .cvsignore,
      .cproject, .directory, .dropbox, .exrc, .gdb.history,
      .gitattributes, .gitignore, .gitmodules, .hgignore, .hgtags,
      .htaccess, .latex2html-init, .project, .seed, .settings,
      .tm_properties and various leftovers.

    * R CMD check now checks for .C(), .Call(), .External() and
      .Fortran() calls in other packages, and gives a warning on those
      found from R itself (which are not part of the API and change
      without notice: many will changed for R 2.16.0).

  C-LEVEL FACILITIES:

    * The limit for R_alloc on 64-bit platforms has been raised to just
      under 32GB (from just under 16GB).

    * The misuse of .C("name", ..., PACKAGE = foo) where foo is an
      arbitrary R object is now an error.

      The misuse .C("name",..., PACKAGE = "") is now warned about in R
      CMD check, and will be an error in future.

  DEPRECATED AND DEFUNCT:

    * Use of array() with a 0-length dim argument is deprecated with a
      warning (and was contrary to the documentation).

    * Use of tapply() with a 0-length INDEX list is deprecated with a
      warning.

    * Translation packages are deprecated.

    * Calling rep() or rep.int() on a pairlist is deprecated and will
      give a warning.  In any case, rep() converted a pairlist to a
      list so you may as well do that explicitly.

    * Entry point rcont2 is no longer part of the API, and will move to
      package stats in R 2.16.0.

    * The 'internal' graphics device invoked by
      .Call("R_GD_nullDevice", package = "grDevices") is about to be
      removed: use pdf(file = NULL) instead.

    * eigen(EISPACK = TRUE), chol(pivot = FALSE, LINPACK = TRUE),
      chol2inv(LINPACK = TRUE), solve(LINPACK = TRUE) and svd(LINPACK =
      TRUE) are deprecated and give a warning.

      They were provided for compatibility with R 1.7.0 (Mar 2003)!

    * The 'internal function' kappa.tri() has been renamed to
      .kappa_tri() so it is not inadvertently called as a method for
      class "tri".

    * Functions sessionData() and browseAll() in package methods are on
      a help page describing them as 'deprecated' and are now formally
      deprecated.

  PACKAGE INSTALLATION:

    * For a Windows or Mac OS X binary package install,
      install.packages() will check if a source package is available on
      the same repositories, and report if it is a later version or
      there is a source package but no binary package available.

      This check can be suppressed: see the help page.

    * install.packages(type = "both") has been enhanced.  In
      interactive use it will ask whether to choose the source version
      of a package if the binary version is older and contains compiled
      code, and also asks if source packages with no binary version
      should be installed).

  INSTALLATION:

    * There is a new configure option --with-libtiff (mainly in case
      the system installation needs to be avoided).

    * LAPACK 3.4.1 does use some Fortran 90 features, so g77 no longer
      suffices.

    * If an external LAPACK is used, it must be version 3.2 or later.

  BUG FIXES:

    * On Windows, starting Rterm via R.exe caused Ctrl-C to misbehave.
      (PR#14948)

    * The tools::latexToUtf8() function missed conversions that were
      contained within braces.

    * Long timezone specifications (such as a file name preceded by :)
      could crash as.POSIXlt.  (PR#14945)

    * R CMD build --resave-data could fail if there was no data
      directory but there was an R/sysdata.rda file.  (PR#14947)

    * is.na() misbehaved on a 0-column data frame.  (PR#14959)

    * anova.lmlist() failed if test was supplied.  (PR#14960)

      It was unable to compute Cp tests for object of class "lm" (it
      assumed class "glm").

    * The formula method for sunflowerplot() now allows xlab and ylab
      to be set.  (Reported by Gerrit Eichner.)

    * The "POSIXt" and "Date" methods for hist() could fail on Windows
      where adjustments to the right-hand boundary crossed a DST
      transition time.

    * On Windows, the code in as.POSIXct() to handle incorrectly
      specified isdst fields might have resulted in NA being returned.

    * aov() and manova() gave spurious warning about singular error
      model in the multiresponse case.

    * In ns() and bs(), specifying knots = NULL is now equivalent to
      omitting it, also when df is specified.  (PR#14970)

    * sprintf() did not accept numbered arguments ending in zero.
      (PR#14975)

    * rWishart() could overflow the C stack and maybe crash the R
      process for dimensions of several hundreds or more.  (Reported by
      Michael Braun on R-sig-mac.)

    * Base package vignettes (e.g. vignette("Sweave")) were not fully
      installed in builds of R from the tarball.

    * lchoose() and choose() could overflow the C stack and crash R.

    * When given a 0-byte file and asked to keep source references,
      parse() read input from stdin() instead.

    * pdf(compress = TRUE) did not delete temporary files it created
      until the end of the R session.  (PR#14991)

    * logLik() did not detect the error of applying it to a
      multiple-response linear model.  (PR#15000)

    * file.copy(recursive = TRUE) did not always report FALSE for a
      failure two or more directories deep.

    * qgeom() could return -1 for extremely small q. (PR#14967.)

    * smooth.spline() used DUP = FALSE which allowed its compiled C
      code to change the function: this was masked by the default
      byte-compilation. (PR#14965.)

    * In Windows, the GUI preferences for foreground color were not
      always respected.  (Reported by Benjamin Wells.)

    * On OS X, the Quartz versions of the bitmap devices did not
      respect antialias = "none".  (PR#15006.)

    * unique() and similar would infinite-loop if called on a vector of
      length > 2^29 (but reported that the vector was too long for 2^30
      or more).

    * parallel::stopCluster() now works with MPI clusters without snow
      being on the search path.

    * terms.formula() could exhaust the stack, and the stack check did
      not always catch this before the segfault.  (PR#15013)

    * sort.list(method = "radix") could give incorrect results on
      certain compilers (seen with clang on Mac OS 10.7 and Xcode
      4.4.1).

    * backsolve(T, b) gave incorrect results when nrows(b) > ncols(T)
      and b had more than one column.

      It could segfault or give nonsense if k was specified as more
      than ncols(T).

    * smooth.spline() did not check that a specified numeric spar was
      of length 1, and gave corrupt results if it was of length 0.

    * Protection added to do_system. (PR#15025)

    * Printing of vectors with names > 1000 characters now works
      correctly rather than truncating. (PR#15028)

    * qr() for a complex matrix did not pivot the column names.

    * --with-blas='-framework vecLib' now also works on OS X 10.8.

    * R CMD check no longer fails with an error if a DESCRIPTION file
      incorrectly contains a blank line.  (Reported by Bill Dunlap.)

    * install.packages(type = "both") could call chooseCRANmirror()
      twice.

    * lm.wfit() could segfault in R 2.15.1 if all the weights were
      zero. (PR#15044)

    * A malformed package name could cause R CMD INSTALL to write
      outside the target library.

    * Some of the quality control functions (e.g. tools::checkFF())
      were wrongly identifying the source of S4 methods in a package
      and so not checking them.

    * The default type of display by browseEnv() when using R.app on
      Mac OS X has been incorrect for a long time.

    * The implementation of importMethodsFrom in a NAMESPACE file could
      be confused and fail to find generics when importing from
      multiple packages (reported and fixed by Michael Lawrence).

    * The detection of the C stack direction is better protected
      against compiler optimization. (PR#15011.)

    * Long custom line types would sometimes segfault on the
      cairographics-based devices. (PR#15055.)

    * tools::checkPoFile() unprotected too early in its C code and so
      segfaulted from time to time.

    * The Fortran code underlying nlminb() could infinite-loop if any
      of the input functions returned NA or NaN.  This is now an error
      for the gradient or Hessian, and a warning for the function (with
      the value replaced by Inf).  (In part, PR#15052.)

    * The code for creating coerce() methods could generate false notes
      about ambiguous selection; the notes have been suppressed for
      this function.

    * arima.sim() could give too long an output in some corner cases
      (in part, PR#15068).

    * anova.glm() with test = "Rao" didn't work when models included an
      offset. (Reported by Soren Feodor Nielsen.)

    * as.data.frame.matrix() could return invalid data frame with no
      row.names attribute for 0-row matrix. (Reported by Herve Pages.)

    * Compilation with the vecLib or Accelerate frameworks on OS X
      without using that also for LAPACK is more likely to be
      successful.

CHANGES IN R VERSION 2.15.1:

  NEW FEATURES:

    * source() now uses withVisible() rather than
      .Internal(eval.with.vis).  This sometimes alters tracebacks
      slightly.

    * install.packages("pkg_version.tgz") on Mac OS X now has sanity
      checks that this is actually a binary package (as people have
      tried it with incorrectly named source packages).

    * splineDesign() and spline.des() in package splines have a new
      option sparse which can be used for efficient construction of a
      sparse B-spline design matrix (_via_ Matrix).

    * norm() now allows type = "2" (the 'spectral' or 2-norm) as well,
      mainly for didactical completeness.

    * pmin() and pmax()) now also work when one of the inputs is of
      length zero and others are not, returning a zero-length vector,
      analogously to, say, +.

    * colorRamp() (and hence colorRampPalette()) now also works for the
      boundary case of just one color when the ramp is flat.

    * .C() gains some protection against the misuse of character vector
      arguments.  (An all too common error is to pass character(N),
      which initializes the elements to "", and then attempt to edit
      the strings in-place, sometimes forgetting to terminate them.)

    * Calls to the new function globalVariables() in package utils
      declare that functions and other objects in a package should be
      treated as globally defined, so that CMD check will not note
      them.

    * print(packageDescription(*)) trims the Collate field by default.

    * The included copy of zlib has been updated to version 1.2.7.

    * A new option "show.error.locations" has been added.  When set to
      TRUE, error messages will contain the location of the most recent
      call containing source reference information. (Other values are
      supported as well; see ?options.)

    * The NA warning messages from e.g. pchisq() now report the call to
      the closure and not that of the .Internal.

    * Added Polish translations by Lukasz Daniel.

  PERFORMANCE IMPROVEMENTS:

    * In package parallel, makeForkCluster() and the multicore-based
      functions use native byte-order for serialization (deferred from
      2.15.0).

    * lm.fit(), lm.wfit(), glm.fit() and lsfit() do less copying of
      objects, mainly by using .Call() rather than .Fortran().

    * .C() and .Fortran() do less copying: arguments which are raw,
      logical, integer, real or complex vectors and are unnamed are not
      copied before the call, and (named or not) are not copied after
      the call.  Lists are no longer copied (they are supposed to be
      used read-only in the C code).

    * tabulate() makes use of .C(DUP = FALSE) and hence does not copy
      bin.  (Suggested by Tim Hesterberg.)  It also avoids making a
      copy of a factor argument bin.

    * Other functions (often or always) doing less copying include
      cut(), dist(), the complex case of eigen(), hclust(), image(),
      kmeans(), loess(), stl() and svd(LINPACK = TRUE).

    * There is less copying when using primitive replacement functions
      such as names(), attr() and attributes().

  DEPRECATED AND DEFUNCT:

    * The converters for use with .C() (see ?getCConverterDescriptions)
      are deprecated: use the .Call() interface instead.  There are no
      known examples (they were never fully documented).

  UTILITIES:

    * For R CMD check, a few people have reported problems with
      junctions on Windows (although they were tested on Windows 7, XP
      and Server 2008 machines and it is unknown under what
      circumstances the problems occur).  Setting the environment
      variable R_WIN_NO_JUNCTIONS to a non-empty value (e.g. in
      ~/.R/check.Renviron) will force copies to be used instead.

  INSTALLATION:

    * R CMD INSTALL with _R_CHECK_INSTALL_DEPENDS_ set to a true value
      (as done by R CMD check --as-cran) now restricts the packages
      available when lazy-loading as well as when test-loading (since
      packages such as ETLUtils and agsemisc had top-level calls to
      library() for undeclared packages).

      This check is now also available on Windows.

  C-LEVEL FACILITIES:

    * C entry points mkChar and mkCharCE now check that the length of
      the string they are passed does not exceed 2^31-1 bytes: they
      used to overflow with unpredictable consequences.

    * C entry points R_GetCurrentSrcref and R_GetSrcFilename have been
      added to the API to allow debuggers access to the source
      references on the stack.

  WINDOWS-SPECIFIC CHANGES:

    * Windows-specific changes will now be announced in this file
      (NEWS).  Changes up and including R 2.15.0 remain in the CHANGES
      file.

    * There are two new environment variables which control the
      defaults for command-line options.

      If R_WIN_INTERNET2 is set to a non-empty value, it is as if
      --internet2 was used.

      If R_MAX_MEM_SIZE is set, it gives the default memory limit if
      --max-mem-size is not specified: invalid values being ignored.

  BUG FIXES:

    * lsfit() lost the names from the residuals.

    * More cases in which merge() could create a data frame with
      duplicate column names now give warnings.  Cases where names
      specified in by match multiple columns are errors.

    * Nonsense uses such as seq(1:50, by = 5) (from package plotrix)
      and seq.int(1:50, by = 5) are now errors.

    * The residuals in the 5-number summary printed by summary() on an
      "lm" object are now explicitly labelled as weighted residuals
      when non-constant weights are present.  (Wish of PR#14840.)

    * tracemem() reported that all objects were copied by .C() or
      .Fortran() whereas only some object types were ever copied.

      It also reported and marked as copies _some_ transformations such
      as rexp(n, x): it no longer does so.

    * The plot() method for class "stepfun" only used the optional xval
      argument to compute xlim and not the points at which to plot (as
      documented).  (PR#14864)

    * Names containing characters which need to be escaped were not
      deparsed properly.  (PR#14846)

    * Trying to update (recommended) packages in R_HOME/library without
      write access is now dealt with more gracefully.  Further, such
      package updates may be skipped (with a warning), when a newer
      installed version is already going to be used from .libPaths().
      (PR#14866)

    * hclust() is now fast again (as up to end of 2003), with a
      different fix for the "median"/"centroid" problem.  (PR#4195).

    * get_all_vars() failed when the data came entirely from vectors in
      the global environment. (PR#14847)

    * R CMD check with _R_CHECK_NO_RECOMMENDED_ set to a true value (as
      done by the --as-cran option) could issue false errors if there
      was an indirect dependency on a recommended package.

    * formatC() uses the C entry point str_signif which could write
      beyond the length allocated for the output string.

    * Missing default argument added to implicit S4 generic for
      backsolve(). (PR#14883)

    * Some bugs have been fixed in handling load actions that could
      fail to export assigned items or generate spurious warnings in
      CMD check on loading.

    * For tiff(type = "windows"), the numbering of per-page files
      except the last was off by one.

    * On Windows, loading package stats (which is done for a default
      session) would switch line endings on stdout and stderr from CRLF
      to LF.  This affected Rterm and R CMD BATCH.

    * On Windows, the compatibility function x11() had not kept up with
      changes to windows(), and issued warnings about bad parameters.
      (PR#14880)

    * On Windows, the Sys.glob() function did not handle UNC paths as
      it was designed to try to do. (PR#14884)

    * In package parallel, clusterApply() and similar failed to handle
      a (pretty pointless) length-1 argument. (PR#14898)

    * Quartz Cocoa display reacted asynchronously to dev.flush() which
      means that the redraw could be performed after the plot has been
      already modified by subsequent code. The redraw is now done
      synchronously in dev.flush() to allow animations without sleep
      cycles.

    * Source locations reported in traceback() were incorrect when
      byte-compiled code was on the stack.

    * plogis(x, lower = FALSE, log.p = TRUE) no longer underflows early
      for large x (e.g. 800).

    * ?Arithmetic's "1 ^ y and y ^ 0 are 1, _always_" now also applies
      for integer vectors y.

    * X11-based pixmap devices like png(type = "Xlib") were trying to
      set the cursor style, which triggered some warnings and hangs.

    * Code executed by the built-in HTTP server no longer allows other
      HTTP clients to re-enter R until the current worker evaluation
      finishes, to prevent cascades.

    * The plot() and Axis() methods for class "table" now respect
      graphical parameters such as cex.axis.  (Reported by Martin
      Becker.)

    * Under some circumstances package.skeleton() would give out
      progress reports that could not be translated and so were
      displayed by question marks.  Now they are always in English.
      (This was seen for CJK locales on Windows, but may have occurred
      elsewhere.)

    * The evaluator now keeps track of source references outside of
      functions, e.g. when source() executes a script.

    * The replacement method for window() now works correctly for
      multiple time series of class "mts".  (PR#14925)

    * is.unsorted() gave incorrect results on non-atomic objects such
      as data frames.  (Reported by Matthew Dowle.)

    * The value returned by tools::psnice() for invalid pid values was
      not always NA as documented.

    * Closing an X11() window while locator() was active could abort
      the R process.

    * getMethod(f, sig) produced an incorrect error message in some
      cases when f was not a string).

    * Using a string as a "call" in an error condition with
      options(showErrorCalls=TRUE) could cause a segfault.  (PR#14931)

    * The string "infinity" allowed by C99 was not accepted as a
      numerical string value by e.g. scan() and as.numeric().
      (PR#14933)

    * In legend(), setting some entries of lwd to NA was inconsistent
      (depending on the graphics device) in whether it would suppress
      those lines; now it consistently does so.  (PR#14926)

    * by() failed for a zero-row data frame.  (Reported by Weiqiang
      Qian.)

    * The Yates' correction in chisq.test() could be bigger than the
      terms it corrected, previously leading to an infinite test
      statistic in some corner cases which are now reported as NaN.

    * xgettext() and related functions sometimes returned items that
      were not strings for translation. (PR#14935)

    * plot(<lm>, which=5) now correctly labels the factor level
      combinations for the special case where all h[i,i] are the same.
      (PR#14837)

    * Sys.glob() caused a segfault if the first element of path was
      NA_character. (PR#14990)

CHANGES IN R VERSION 2.15.0:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * The behaviour of unlink(recursive = TRUE) for a symbolic link to
      a directory has changed: it now removes the link rather than the
      directory contents (just as rm -r does).

      On Windows it no longer follows reparse points (including
      junctions and symbolic links).

  NEW FEATURES:

    * Environment variable RD2DVI_INPUTENC has been renamed to
      RD2PDF_INPUTENC.

    * .Deprecated() becomes a bit more flexible, getting an old
      argument.

    * Even data-only packages without R code need a namespace and so
      may need to be installed under R 2.14.0 or later.

    * assignInNamespace() has further restrictions on use apart from at
      top-level, as its help page has warned.  Expect it to be disabled
      from programmatic use in the future.

    * system() and system2() when capturing output report a non-zero
      status in the new "status" attribute.

    * kronecker() now has an S4 generic in package methods on which
      packages can set methods.  It will be invoked by X %x% Y if
      either X or Y is an S4 object.

    * pdf() accepts forms like file = "|lpr" in the same way as
      postscript().

    * pdf() accepts file = NULL.  This means that the device does NOT
      create a PDF file (but it can still be queried, e.g., for font
      metric info).

    * format() (and hence print()) on "bibentry" objects now uses
      options("width") to set the output width.

    * legend() gains a text.font argument. (Suggested by Tim Paine,
      PR#14719.)

    * nchar() and nzchar() no longer accept factors (as integer
      vectors).  (Wish of PR#6899.)

    * summary() behaves slightly differently (or more precisely, its
      print() method does).  For numeric inputs, the number of NAs is
      printed as an integer and not a real.  For dates and datetimes,
      the number of NAs is included in the printed output (the latter
      being the wish of PR#14720).

      The "data.frame" method is more consistent with the default
      method: in particular it now applies zapsmall() to
      numeric/complex summaries.

    * The number of items retained with options(warn = 0) can be set by
      options(nwarnings=).

    * There is a new function assignInMyNamespace() which uses the
      namespace of the function it is called from.

    * attach() allows the default name for an attached file to be
      overridden.

    * bxp(), the work horse of boxplot(), now uses a more sensible
      default xlim in the case where at is specified differently from
      1:n, see the discussion on R-devel, <URL:
      https://stat.ethz.ch/pipermail/r-devel/2011-November/062586.html>.

    * New function paste0(), an efficient version of paste(*, sep=""),
      to be used in many places for more concise (and slightly more
      efficient) code.

    * Function setClass() in package methods now returns, invisibly, a
      generator function for the new class, slightly preferred to
      calling new(), as explained on the setClass help page.

    * The "dendrogram" method of str() now takes its default for
      last.str from option str.dendrogram.last.

    * New simple fitted() method for "kmeans" objects.

    * The traceback() function can now be called with an integer
      argument, to display a current stack trace. (Wish of PR#14770.)

    * setGeneric() calls can be simplified when creating a new generic
      function by supplying the default method as the def argument.
      See ?setGeneric.

    * serialize() has a new option xdr = FALSE which will use the
      native byte-order for binary serializations.  In scenarios where
      only little-endian machines are involved (these days, close to
      universal) and (un)serialization takes an appreciable amount of
      time this may speed up noticeably transferring data between
      systems.

    * The internal (un)serialization code is faster for long vectors,
      particularly with XDR on some platforms.  (Based on a suggested
      patch by Michael Spiegel.)

    * For consistency, circles with zero radius are omitted by points()
      and grid.circle().  Previously this was device-dependent, but
      they were usually invisible.

    * NROW(x) and NCOL(x) now work whenever dim(x) looks appropriate,
      e.g., also for more generalized matrices.

    * PCRE has been updated to version 8.30.

    * The internal R_Srcref variable is now updated before the browser
      stops on entering a function.  (Suggestion of PR#14818.)

    * There are 'bare-bones' functions .colSums(), .rowSums(),
      .colMeans() and .rowMeans() for use in programming where ultimate
      speed is required.

    * The formerly internal function .package_dependencies() from
      package tools for calculating (recursive) (reverse) dependencies
      on package databases has been renamed to package_dependencies()
      and is now exported.

    * There is a new function optimHess() to compute the (approximate)
      Hessian for an optim() solution if hessian = TRUE was forgotten.

    * .filled.contour() is a 'bare-bones' function to add a
      filled-contour rectangular plot to an already prepared plot
      region.

    * The stepping in debugging and single-step browsing modes has
      changed slightly: now left braces at the start of the body are
      stepped over for if statements as well as for for and while
      statements.  (Wish of PR#14814.)

    * library() no longer warns about a conflict with a function from
      package:base if the function has the same code as the base one
      but with a different environment.  (An example is Matrix::det().)

    * When deparsing very large language objects, as.character() now
      inserts newlines after each line of approximately 500 bytes,
      rather than truncating to the first line.

    * New function rWishart() generates Wishart-distributed random
      matrices.

    * Packages may now specify actions to be taken when the package is
      loaded (setLoadActions()).

    * options(max.print = Inf) and similar now give an error (instead
      of warnings later).

    * The "difftime" replacement method of units tries harder to
      preserve other attributes of the argument.  (Wish of PR#14839.)

    * poly(raw = TRUE) no longer requires more unique points than the
      degree.  (Requested by John Fox.)

  PACKAGE parallel:

    * There is a new function mcmapply(), a parallel version of
      mapply(), and a wrapper mcMap(), a parallel version of Map().

    * A default cluster can be registered by the new function
      setDefaultCluster(): this will be used by default in functions
      such as parLapply().

    * clusterMap() has a new argument .scheduling to allow the use of
      load-balancing.

    * There are new load-balancing functions parLapplyLB() and
      parSapplyLB().

    * makePSOCKCluster() has a new option useXDR = FALSE which can be
      used to avoid byte-shuffling for serialization when all the nodes
      are known to be little-endian (or all big-endian).

  PACKAGE INSTALLATION:

    * Non-ASCII vignettes without a declared encoding are no longer
      accepted.

    * C/C++ code in packages is now compiled with -NDEBUG to mitigate
      against the C/C++ function assert being called in production use.
      Developers can turn this off during package development with
      PKG_CPPFLAGS = -UNDEBUG.

    * R CMD INSTALL has a new option --dsym which on Mac OS X (Darwin)
      dumps the symbols alongside the .so file: this is helpful when
      debugging with valgrind (and especially when installing packages
      into R.framework).  [This can also be enabled by setting the
      undocumented environment variable PKG_MAKE_DSYM, since R 2.12.0.]

    * R CMD INSTALL will test loading under all installed
      sub-architectures even for packages without compiled code, unless
      the flag --no-multiarch is used.  (Pure R packages can do things
      which are architecture-dependent: in the case which prompted
      this, looking for an icon in a Windows R executable.)

    * There is a new option install.packages(type = "both") which tries
      source packages if binary packages are not available, on those
      platforms where the latter is the default.

    * The meaning of install.packages(dependencies = TRUE) has changed:
      it now means to install the essential dependencies of the named
      packages plus the Suggests, but only the essential dependencies
      of dependencies.  To get the previous behaviour, specify
      dependencies as a character vector.

    * R CMD INSTALL --merge-multiarch is now supported on OS X and
      other Unix-alikes using multiple sub-architectures.

    * R CMD INSTALL --libs-only now by default does a test load on
      Unix-alikes as well as on Windows: suppress with --no-test-load.

  UTILITIES:

    * R CMD check now gives a warning rather than a note if it finds
      inefficiently compressed datasets.  With bzip2 and xz compression
      having been available since R 2.10.0, it only exceptionally makes
      sense to not use them.

      The environment variable _R_CHECK_COMPACT_DATA2_ is no longer
      consulted: the check is always done if _R_CHECK_COMPACT_DATA_ has
      a true value (its default).

    * Where multiple sub-architectures are to be tested, R CMD check
      now runs the examples and tests for all the sub-architectures
      even if one fails.

    * R CMD check can optionally report timings on various parts of the
      check: this is controlled by environment variable
      _R_CHECK_TIMINGS_ documented in 'Writing R Extensions'.  Timings
      (in the style of R CMD BATCH) are given at the foot of the output
      files from running each test and the R code in each vignette.

    * There are new options for more rigorous testing by R CMD check
      selected by environment variables - see the 'Writing R
      Extensions' manual.

    * R CMD check now warns (rather than notes) on undeclared use of
      other packages in examples and tests: increasingly people are
      using the metadata in the DESCRIPTION file to compute information
      about packages, for example reverse dependencies.

    * The defaults for some of the options in R CMD check (described in
      the 'R Internals' manual) have changed: checks for unsafe and
      .Internal() calls and for partial matching of arguments in R
      function calls are now done by default.

    * R CMD check has more comprehensive facilities for checking
      compiled code and so gives fewer reports on entry points linked
      into .so/.dll files from libraries (including C++ and Fortran
      runtimes).

      Checking compiled code is now done on FreeBSD (as well as the
      existing supported platforms of Linux, Mac OS X, Solaris and
      Windows).

    * R CMD build has more options for --compact-vignettes: see R CMD
      build --help.

    * R CMD build has a new option --md5 to add an MD5 file (as done by
      CRAN): this is used by R CMD INSTALL to check the integrity of
      the distribution.

      If this option is not specified, any existing (and probably
      stale) MD5 file is removed.

  DEPRECATED AND DEFUNCT:

    * R CMD Rd2dvi is now defunct: use R CMD Rd2pdf.

    * Options such --max-nsize, --max-vsize and the function
      mem.limits() are now defunct.  (Options --min-nsize and
      --min-vsize remain available.)

    * Use of library.dynam() without specifying all the first three
      arguments is now disallowed.

      Use of an argument chname in library.dynam() including the
      extension .so or .dll (which was never allowed according to the
      help page) is defunct.  This also applies to
      library.dynam.unload() and to useDynLib directives in NAMESPACE
      files.

    * The internal functions .readRDS() and .saveRDS() are now defunct.

    * The off-line help() types "postscript" and "ps" are defunct.

    * Sys.putenv(), replaced and deprecated in R 2.5.0, is finally
      removed.

    * Some functions/objects which have been defunct for five or more
      years have been removed completely.  These include .Alias(),
      La.chol(), La.chol2inv(), La.eigen(), Machine(), Platform(),
      Version, codes(), delay(), format.char(), getenv(), httpclient(),
      loadURL(), machine(), parse.dcf(), printNoClass(), provide(),
      read.table.url(), restart(), scan.url(), symbol.C(), symbol.For()
      and unix().

    * The ENCODING argument to .C() is deprecated.  It was intended to
      smooth the transition to multi-byte character strings, but can be
      replaced by the use of iconv() in the rare cases where it is
      still needed.

  INSTALLATION:

    * Building with a positive value of --with-valgrind-instrumentation
      now also instruments logical, complex and raw vectors.

  C-LEVEL FACILITIES:

    * Passing R objects other than atomic vectors, functions, lists and
      environments to .C() is now deprecated and will give a warning.
      Most cases (especially NULL) are actually coding errors.  NULL
      will be disallowed in future.

      .C() now passes a pairlist as a SEXP to the compiled code.  This
      is as was documented, but pairlists were in reality handled
      differently as a legacy from the early days of R.

    * call_R and call_S are deprecated.  They still exist in the
      headers and as entry points, but are no longer documented and
      should not be used for new code.

  BUG FIXES:

    * str(x, width) now obeys its width argument also for function
      headers and other objects x where deparse() is applied.

    * The convention for x %/% 0L for integer-mode x has been changed
      from 0L to NA_integer_.  (PR#14754)

    * The exportMethods directive in a NAMESPACE file now exports S4
      generics as necessary, as the extensions manual said it does.
      The manual has also been updated to be a little more informative
      on this point.

      It is now required that there is an S4 generic (imported or
      created in the package) when methods are to be exported.

    * Reference methods cannot safely use non-exported entries in the
      namespace.  We now do not do so, and warn in the documentation.

    * The namespace import code was warning when identical S4 generic
      functions were imported more than once, but should not (reported
      by Brian Ripley, then Martin Morgan).

    * merge() is no longer allowed (in some ways) to create a data
      frame with duplicate column names (which confused PR#14786).

    * Fixes for rendering raster images on X11 and Windows devices when
      the x-axis or y-axis scale is reversed.

    * getAnywhere() found S3 methods as seen from the utils namespace
      and not from the environment from which it was called.

    * selectMethod(f, sig) would not return inherited group methods
      when caching was off (as it is by default).

    * dev.copy2pdf(out.type = "cairo") gave an error.  (PR#14827)

    * Virtual classes (e.g., class unions) had a NULL prototype even if
      that was not a legal subclass.  See ?setClassUnion.

    * The C prototypes for zdotc and zdotu in R_ext/BLAS.h have been
      changed to the more modern style rather than that used by f2c.
      (Patch by Berwin Turlach.)

    * isGeneric() produced an error for primitives that can not have
      methods.

    * .C() or .Fortran() had a lack-of-protection error if the
      registration information resulted in an argument being coerced to
      another type.

    * boxplot(x=x, at=at) with non finite elements in x and non integer
      at could not generate a warning but failed.

    * heatmap(x, symm=TRUE, RowSideColors=*) no longer draws the colors
      in reversed order.

    * predict(<ar>) was incorrect in the multivariate case, for p >= 2.

    * print(x, max=m) is now consistent when x is a "Date"; also the
      "reached ... max.print .." messages are now consistently using
      single brackets.

    * Closed the <li> tag in pages generated by Rd2HTML(). (PR#14841.)

    * Axis tick marks could go out of range when a log scale was used.
      (PR#14833.)

    * Signature objects in methods were not allocated as S4 objects
      (caused a problem with trace() reported by Martin Morgan).

CHANGES IN R VERSION 2.14.2:

  NEW FEATURES:

    * The internal untar() (as used by default by R CMD INSTALL) now
      knows about some pax headers which bsdtar (e.g., the default tar
      for Mac OS >= 10.6) can incorrectly include in tar files, and
      will skip them with a warning.

    * PCRE has been upgraded to version 8.21: as well as bug fixes and
      greater Perl compatibility, this adds a JIT pattern compiler,
      about which PCRE's news says 'large performance benefits can be
      had in many situations'.  This is supported on most but not all R
      platforms.

    * Function compactPDF() in package tools now takes the default for
      argument gs_quality from environment variable GS_QUALITY: there
      is a new value "none", the ultimate default, which prevents
      GhostScript being used in preference to qpdf just because
      environment variable R_GSCMD is set.  If R_GSCMD is unset or set
      to "", the function will try to find a suitable GhostScript
      executable.

    * The included version of zlib has been updated to 1.2.6.

    * For consistency with the logLik() method, nobs() for "nls" files
      now excludes observations with zero weight.  (Reported by Berwin
      Turlach.)

  UTILITIES:

    * R CMD check now reports by default on licenses not according to
      the description in 'Writing R Extensions'.

    * R CMD check has a new option --as-cran to turn on most of the
      customizations that CRAN uses for its incoming checks.

  PACKAGE INSTALLATION:

    * R CMD INSTALL will now no longer install certain file types from
      inst/doc: these are almost certainly mistakes and for some
      packages are wasting a lot of space.  These are Makefile, files
      generated by running LaTeX, and unless the package uses a
      vignettes directory, PostScript and image bitmap files.

      Note that only PDF vignettes have ever been supported: some of
      these files come from DVI/PS output from the Sweave defaults
      prior to R 2.13.0.

  BUG FIXES:

    * R configured with --disable-openmp would mistakenly set
      HAVE_OPENMP (internal) and SUPPORT_OPENMP (in Rconfig.h) even
      though no OpenMP flags were populated.

    * The getS3method() implementation had an old computation to find
      an S4 default method.

    * readLines() could overflow a buffer if the last line of the file
      was not terminated.  (PR#14766)

    * R CMD check could miss undocumented S4 objects in packages which
      used S4 classes but did not Depends: methods in their DESCRIPTION
      file.

    * The HTML Help Search page had malformed links.  (PR#14769)

    * A couple of instances of lack of protection of SEXPs have been
      squashed. (PR#14772, PR#14773)

    * image(x, useRaster=TRUE) misbehaved on single-column x.
      (PR#14774)

    * Negative values for options("max.print") or the max argument to
      print.default() caused crashes.  Now the former are ignored and
      the latter trigger an error.  (PR#14779)

    * The text of a function body containing more than 4096 bytes was
      not properly saved by the parser when entered at the console.

    * Forgetting the #endif tag in an Rd file could cause the parser to
      go into a loop.  (Reported by Hans-Jorg Bibiko.)

    * str(*, ....., strict.width="cut") now also obeys list.len = n.
      (Reported by Soren Vogel.)

    * Printing of arrays did not have enough protection (C level),
      e.g., in the context of capture.output().  (Reported by Herve
      Pages and Martin Morgan.)

    * pdf(file = NULL) would produce a spurious file named NA.
      (PR#14808)

    * list2env() did not check the type of its envir argument.
      (PR#14807)

    * svg() could segfault if called with a non-existent file path.
      (PR#14790)

    * make install can install to a path containing + characters.
      (PR#14798)

    * The edit() function did not respect the options("keep.source")
      setting. (Reported by Cleridy Lennert.)

    * predict.lm(*, type="terms", terms=*, se.fit=TRUE) did not work.
      (PR#14817)

    * There is a partial workaround for errors in the TRE
      regular-expressions engine with named classes and repeat counts
      of at least 2 in a MBCS locale (PR#14408): these are avoided when
      TRE is in 8-bit mode (e.g. for useBytes = TRUE and when all the
      data are ASCII).

    * The C function R_ReplDLLdo1() did not call top-level handlers.

    * The Quartz device was unable to detect window sessions on Mac OS
      X 10.7 (Lion) and higher and thus it was not used as the default
      device on the console.  Since Lion any application can use window
      sessions, so Quartz will now be the default device if the user's
      window session is active and R is not run via ssh which is at
      least close to the behavior in prior OS X versions.

    * mclapply() would fail in code assembling the translated error
      message if some (but not all) cores encountered an error.

    * format.POSIXlt(x) raised an arithmetic exception when x was an
      invalid object of class "POSIXlt" and parts were empty.

    * installed.packages() has some more protection against package
      installs going on in parallel.

    * .Primitive() could be mis-used to call .Internal() entry points.

CHANGES IN R VERSION 2.14.1:

  NEW FEATURES:

    * parallel::detectCores() is now able to find the number of
      physical cores (rather than CPUs) on Sparc Solaris.

      It can also do so on most versions of Windows; however the
      default remains detectCores(logical = TRUE) on that platform.

    * Reference classes now keep a record of which fields are locked.
      $lock() with no arguments returns the names of the locked fields.

    * HoltWinters() reports a warning rather than an error for some
      optimization failures (where the answer might be a reasonable
      one).

    * tools::dependsOnPkg() now accepts the shorthand dependencies =
      "all".

    * parallel::clusterExport() now allows specification of an
      environment from which to export.

    * The quartz() device now does tilde expansion on its file
      argument.

    * tempfile() on a Unix-alike now takes the process ID into account.
      This is needed with multicore (and as part of parallel) because
      the parent and all the children share a session temporary
      directory, and they can share the C random number stream used to
      produce the unique part.  Further, two children can call
      tempfile() simultaneously.

    * Option print in Sweave's RweaveLatex() driver now emulates
      auto-printing rather than printing (which can differ for an S4
      object by calling show() rather than print()).

    * filled.contour() now accepts infinite values: previously it might
      have generated invalid graphics files (e.g. containing NaN
      values).

  INSTALLATION:

    * On 64-bit Linux systems, configure now only sets LIBnn to lib64
      if /usr/lib64 exists.  This may obviate setting LIBnn explicitly
      on Debian-derived systems.

      It is still necessary to set LIBnn = lib (or lib32) for 32-bit
      builds of R on a 64-bit OS on those Linux distributions capable
      for supporting that concept.

    * configure looks for inconsolata.sty, and if not found adjusts the
      default R_RD4PDF to not use it (with a warning, since it is
      needed for high-quality rendering of manuals).

  PACKAGE INSTALLATION:

    * R CMD INSTALL will now do a test load for all sub-architectures
      for which code was compiled (rather than just the primary
      sub-architecture).

  UTILITIES:

    * When checking examples under more than one sub-architecture, R
      CMD check now uses a separate directory examples_arch for each
      sub-architecture, and leaves the output in file
      pkgname-Ex_arch.Rout.  Some packages expect their examples to be
      run in a clean directory ....

  BUG FIXES:

    * stack() now gives an error if no vector column is selected,
      rather than returning a 1-column data frame (contrary to its
      documentation).

    * summary.mlm() did not handle objects where the formula had been
      specified by an expression.  (Reported by Helios de Rosario
      Martinez).

    * tools::deparseLatex(dropBraces=TRUE) could drop text as well as
      braces.

    * colormodel = "grey" (new in R 2.14.0)) did not always work in
      postscript() and pdf().

    * file.append() could return TRUE for failures.  (PR#14727)

    * gzcon() connections are no longer subject to garbage collection:
      it was possible for this to happen when unintended (e.g. when
      calling load()).

    * nobs() does not count zero-weight observations for glm() fits,
      for consistency with lm().  This affects the BIC() values
      reported for such glm() fits.  (Spotted by Bill Dunlap.)

    * options(warn = 0) failed to end a (C-level) context with more
      than 50 accumulated warnings.  (Spotted by Jeffrey Horner.)

    * The internal plot.default() code did not do sanity checks on a
      cex argument, so invalid input could cause problems.  (Reported
      by Ben Bolker.)

    * anyDuplicated(<array>, MARGIN=0) no longer fails.  (Reported by
      Herve Pages.)

    * read.dcf() removes trailing blanks: unfortunately on some
      platforms this included \xa0 (non-breaking space) which is the
      trailing byte of a UTF-8 character.  It now only considers ASCII
      space and tab to be 'blank'.

    * There was a sign error in part of the calculations for the
      variance returned by KalmanSmooth().  (PR#14738)

    * pbinom(10, 1e6, 0.01, log.p = TRUE) was NaN thanks to the buggy
      fix to PR#14320 in R 2.11.0.  (PR#14739)

    * RweaveLatex() now emulates auto-printing rather than printing, by
      calling methods::show() when auto-printing would.

    * duplicated() ignored fromLast for a one-column data frame.
      (PR#14742)

    * source() and related functions did not put the correct timestamp
      on the source references; srcfilecopy() has gained a new argument
      timestamp to support this fix. (PR#14750)

    * srcfilecopy() has gained a new argument isFile and now records
      the working directory, to allow debuggers to find the original
      source file.  (PR#14826)

    * LaTeX conversion of Rd files did not correctly handle
      preformatted backslashes.  (PR#14751)

    * HTML conversion of Rd files did not handle markup within tabular
      cells properly.  (PR#14708)

    * source() on an empty file with keep.source = TRUE tried to read
      from stdin(), in R 2.14.0 only.  (PR#14753)

    * The code to check Rd files in packages would abort if duplicate
      description sections were present.

CHANGES IN R VERSION 2.14.0:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * All packages must have a namespace, and one is created on
      installation if not supplied in the sources.  This means that any
      package without a namespace must be re-installed under this
      version of R (but previously-installed data-only packages without
      R code can still be used).

    * The yLineBias of the X11() and windows() families of devices has
      been changed from 0.1 to 0.2: this changes slightly the vertical
      positioning of text in the margins (including axis annotations).
      This is mainly for consistency with other devices such as
      quartz() and pdf().  (Wish of PR#14538.)

      There is a new graphics parameter "ylbias" which allows the
      y-line bias of the graphics device to be tweaked, including to
      reproduce output from earlier versions of R.

    * Labeling of the p-values in various anova tables has been
      rationalized to be either "Pr(>F)" or "Pr(>Chi)" (i.e. the
      "Pr(F)", "Pr(Chi)" and "P(>|Chi|)" variants have been
      eliminated).  Code which extracts the p value _via_ indexing by
      name may need adjustment.

    * :: can now be used for datasets made available for lazy-loading
      in packages with namespaces (which makes it consistent with its
      use for data-only packages without namespaces in earlier versions
      of R).

    * There is a new package parallel.

      It incorporates (slightly revised) copies of packages multicore
      and snow (excluding MPI, PVM and NWS clusters).  Code written to
      use the higher-level API functions in those packages should work
      unchanged (apart from changing any references to their namespaces
      to a reference to parallel, and links explicitly to multicore or
      snow on help pages).

      It also contains support for multiple RNG streams following
      L'Ecuyer _et al_ (2002), with support for both mclapply and snow
      clusters.  This replaces functions like clusterSetupRNG() from
      snow (which are not in parallel).

      The version released for R 2.14.0 contains base functionality:
      higher-level convenience functions are planned (and some are
      already available in the 'R-devel' version of R).

    * Building PDF manuals (for R itself or packages, e.g. _via_ R CMD
      check) by default requires the LaTeX package inconsolata: see the
      section on 'Making the manuals' in the 'R Installation and
      Administration Manual'.

    * axTicks(*, log=TRUE) has changed in some cases to satisfy the
      documented behavior and be consistent.

  NEW FEATURES:

    * txtProgressBar() can write to an open connection instead of the
      console.

    * Non-portable package names ending in . are no longer allowed.
      Nor are single-character package names (R was already
      disallowed).

    * regexpr() and gregexpr() with perl = TRUE allows Python-style
      named captures.  (Wish and contribution of PR#14518.)

    * The placement of 'plotmath' text in the margins of plots done by
      base graphics now makes the same vertical adjustment as ordinary
      text, so using ordinary and plotmath text on the same margin line
      will seem better aligned (but not exactly aligned, since ordinary
      text has descenders below the baseline and plotmath places them
      on the baseline).  (Related to PR#14537.)

    * sunflowerplot() now has a formula interface.  (Wish of PR#14541.)

    * iconv() has a new argument toRaw to handle encodings such as
      UTF-16 with embedded nuls (as was possible before the CHARSXP
      cache was introduced).

      It will also accept as input the type of list generated with
      toRaw = TRUE.

    * Garbage-collecting an unused input text connection no longer
      gives a warning (since it 'connects' to nothing outside R).

    * read.table() and scan() have gained a text argument, to allow
      reading data from a (possibly literal) character string.

    * optim(*, method = .) now allows method = "Brent" as an interface
      to optimize(), for use in cases such as mle() where optim() is
      used internally.

    * mosaicplot() gains a border argument.  (Wish of PR#14550.)

    * smooth.spline() gains a tol argument which controls how different
      x values need to be to be treated as distinct.  The default has
      been changed to be more reliable for inputs whose range is small
      compared to their maximum absolute value.  (Wish of PR#14452.)

    * gl() runs faster by avoiding calling factor().

    * The print() method for object.size() accepts B as well as b as an
      abbreviation for 'bytes'.

    * unlink() gains a force argument to work like rm -f and if
      possible override restrictive permissions.

    * pbirthday() and qbirthday() now use exact calculations for
      coincident = 2.

    * unzip() and unz() connections have been updated with support for
      more recent Zip64 features (including large file sizes and bzip2
      compression, but not UTF-8 file names).

      unzip() has a new option to restore file times from those
      recorded (in an unknown timezone) in the zip file.

    * update.packages() now accepts a character vector of package names
      for the oldPkgs argument.  (Suggestion of Tal Galili.)

    * The special reference class fields .self and .refClassDef are now
      read-only to prevent corrupting the object.

    * decompose() now returns the original series as part of its value,
      so it can be used (rather than reconstructed) when plotting.
      (Suggestion of Rob Hyndman.)

    * Rao's efficient score test has been implemented for glm objects.
      Specifically, the add1, drop1, and anova methods now allow test =
      "Rao".

    * If a saved workspace (e.g. .RData) contains objects that cannot
      be loaded, R will now start with an warning message and an empty
      workspace, rather than failing to start.

    * strptime() now accepts times such as 24:00 for midnight at the
      end of the day, for although these are disallowed by POSIX
      1003.1-2008, ISO 8601:2004 allows them.

    * Assignment of names() to S4 objects now checks for a
      corresponding "names" slot, and generates a warning or an error
      if that slot is not defined.  See the section on slots in
      ?Classes.

    * The default methods for is.finite(), is.infinite() and is.nan()
      now signal an error if their argument is not an atomic vector.

    * The formula method for plot() no longer places package stats on
      the search path (it loads the namespace instead).

    * There now is a genuine "function" method for plot() rather than
      the generic dispatching internally to graphics::plot.function().
      It is now exported, so can be called directly as plot.function().

    * The one-sided ks.test() allows exact = TRUE to be specified in
      the presence of ties (but the approximate calculation remains the
      default: the 'exact' computation makes assumptions known to be
      invalid in the presence of ties).

    * The behaviour of curve(add = FALSE) has changed: it now no longer
      takes the default x limits from the previous plot (if any):
      rather they default to c(0, 1) just as the "function" method for
      plot().  To get the previous behaviour use curve(add = NA), which
      also takes the default for log-scaling of the x-axis from the
      previous plot.

    * Both curve() and the plot() method for functions have a new
      argument xname to facilitate plots such as sin(t) _vs_ t.

    * The local argument to source() can specify an environment as well
      as TRUE (parent.env()) and FALSE (.GlobalEnv).  It gives better
      error messages for other values, such as NA.

    * vcov() gains methods for classes "summary.lm" and "summary.glm".

    * The plot() method for class "profile.nls" gains ylab and lty
      arguments, and passes ... on to plot.default.

    * Character-string arguments such as the mode argument of vector(),
      as.vector() and is.vector() and the description argument of
      file() are required to be of length exactly one, rather than any
      further elements being silently discarded.  This helps catch
      incorrect usage in programming.

    * The length argument of vector() and its wrappers such as
      numeric() is required to be of length exactly one (other values
      are now an error rather than giving a warning as previously).

    * vector(len) and length(x) <- len no longer accept TRUE/FALSE for
      len (not that they were ever documented to, but there was
      special-casing in the C code).

    * There is a new function Sys.setFileTime() to set the time of a
      file (including a directory).  See its help for exactly which
      times it sets on various OSes.

    * The file times reported by file.info() are reported to sub-second
      resolution on systems which support it.  (Currently the POSIX
      2008 and FreeBSD/Darwin/NetBSD methods are detected.)

    * New function getCall(m) as an abstraction for m$call, enabling
      update()'s default method to apply more universally.  (NB: this
      can be masked by existing functions in packages.)

    * Sys.info() gains a euser component to report the 'effective' user
      on OSes which have that concept.

    * The result returned by try() now contains the original error
      condition object as the "condition" attribute.

    * All packages with R code are lazy-loaded irrespective of the
      LazyLoad field in the DESCRIPTION file.  A warning is given if
      the LazyLoad field is overridden.

    * Rd markup has a new \figure tag so that figures can be included
      in help pages when converted to HTML or LaTeX.  There are
      examples on the help pages for par() and points().

    * The built-in httpd server now allows access to files in the
      session temporary directory tempdir(), addressed as the /session
      directory on the httpd server.

    * Development versions of R are no longer referred to by the number
      under which they might be released, e.g. in the startup banner, R
      --version and sessionUtils().  The correct way to refer to a
      development version of R is 'R-devel', preferably with the date
      and SVN version number.
      E.g. R-devel (2011-07-04 r56266)

    * There is a new function texi2pdf() in package tools, currently a
      convenience wrapper for texi2dvi(pdf = TRUE).

    * There are two new options for typesetting PDF manuals from Rd
      files.  These are beramono and inconsolata, and used the named
      font for monospaced output. They are intended to be used in
      combination with times, and times,inconsolata,hyper is now the
      default for the reference manual and package manuals.  If you do
      not have that font installed, you can set R_RD4PF to one of the
      other options: see the 'R Installation and Administration
      Manual'.

    * Automatic printing for reference classes is now done by the
      $show() method.  A method is defined for class envRefClass and
      may be overridden for user classes (see the ?ReferenceClasses
      example).  S4 show() methods should no longer be needed for
      reference classes.

    * tools::Rdiff (by default) and R CMD Rdiff now ignore differences
      in pointer values when comparing printed environments, compiled
      byte code, etc.

    * The "source" attribute on functions created with keep.source=TRUE
      has been replaced with a "srcref" attribute.  The "srcref"
      attribute references an in-memory copy of the source file using
      the "srcfilecopy" class or the new "srcfilealias" class.

      *NB:* This means that functions sourced with keep.source = TRUE
      and saved (e.g., by save() or readRDS()) in earlier versions of R
      will no longer show the original sources (including comments).

    * New items User Manuals and Technical Papers have been added to
      the HTML help main page.  These link to vignettes in the base and
      recommended packages and to a collection of papers about R
      issues, respectively.

    * Documentation and messages have been standardized to use
      "namespace" rather than "name space".

    * setGeneric() now looks in the default packages for a non-generic
      version of a function if called from a package with a namespace.
      (It always did for packages without a namespace.)

    * Setting the environment variable _R_WARN_ON_LOCKED_BINDINGS_ will
      give a warning if an attempt is made to change a locked binding.

    * \SweaveInput is now supported when generating concordances in
      Sweave().

    * findLineNum() and setBreakpoint() now allow the environment to be
      specified indirectly; the latter gains a clear argument to allow
      it to call untrace().

    * The body of a closure can be one of further types of R objects,
      including environments and external pointers.

    * The Rd2HTML() function in package tools now has a stylesheet
      argument, allowing pages to be displayed in alternate formats.

    * New function requireNamespace() analogous to require(), returning
      a logical value after attempting to load a namespace.

    * There is a new type of RNG, "L'Ecuyer-CMRG", implementing
      L'Ecuyer (1999)'s 'combined multiple-recursive generator'
      MRG32k3a.  See the comments on ?RNG.

    * help.search() and ?? can now display vignettes and demos as well
      as help pages.  The new option "help.search.types" controls the
      types of documentation and the order of their display.

      This also applies to HTML searches, which now give results in all
      of help pages, vignettes and demos.

    * socketConnection() now has a timeout argument.  It is now
      documented that large values (package snow used a year) do not
      work on some OSes.

    * The initialization of the random-number generator now uses the
      process ID as well as the current time, just in case two R
      processes are launched very rapidly on a machine with
      low-resolution wall clock (some have a resolution of a second;
      modern systems have microsecond-level resolution).

    * New function pskill() in the tools package to send a terminate
      signal to one or more processes, plus constants such as SIGTERM
      to provide a portable way to refer to signals (since the numeric
      values are OS-dependent).

    * New function psnice() in the tools package to return or change
      the 'niceness' of a process.  (Refers to the 'priority class' on
      Windows.)

    * list.dirs() gains a recursive argument.

    * An Authors@R field in a package DESCRIPTION file can now be used
      to generate Author and Maintainer fields if needed, and to
      auto-generate package citations.

    * New utility getElement() for accessing either a list component or
      a slot in an S4 object.

    * stars() gains a col.lines argument, thanks to Dustin Sallings.
      (Wish of PR#14657.)

    * New function regmatches() for extracting or replacing matched or
      non-matched substrings from match data obtained by regexpr(),
      gregexpr() and regexec().

    * help(package = "pkg_name", help_type = "HTML") now gives HTML
      help on the package rather than text help.  (This gives direct
      access to the HTML version of the package manual shown _via_
      help.start()'s 'Packages' menu.)

    * agrep() gains a fixed argument to optionally allow approximate
      regular expression matching, and a costs argument to specify
      possibly different integer match costs for insertions, deletions
      and substitutions.

    * read.dcf() and write.dcf() gain a keep.white argument to indicate
      fields where whitespace should be kept as is.

    * available.packages() now works around servers that fail to return
      an error code when PACKAGES.gz does not exist.  (Patch submitted
      by Seth Schommer.)

    * readBin() can now read more than 2^31 - 1 bytes in a single call
      (the previously documented limitation).

    * New function regexec() for finding the positions of matches as
      well as all substrings corresponding to parenthesized
      subexpressions of the given regular expression.

    * New function adist() in package utils for computing 'edit'
      (generalized Levenshtein) distances between strings.

    * Class "raster" gains an is.na method to avoid confusion from the
      misuse of the matrix method (such as PR#14618).

    * The identical() function gains an ignore.bytecode argument to
      control comparison of compiled functions.

    * pmin and pmax now warn if an argument is partially recycled (wish
      of PR#14638).

    * The default for image(useRaster=) is now taken from option
      "preferRaster": for the small print see ?image.

    * str() now displays reference class objects and their fields,
      rather than treating them as classical S4 classes.

    * New function aregexec() in package utils for finding the
      positions of approximate string matches as well as all substrings
      corresponding to parenthesized subexpressions of the given
      regular expression.

    * download.file() has an extra argument to pass additional
      command-line options to the non-default methods using
      command-line utilities.

      cacheOK = FALSE is now supported for method = "curl".

    * interaction.plot(*, type = .) now also allows type "o" or "c".

    * axTicks(*, log=TRUE) did sometimes give more values than the
      ticks in the corresponding graphics::axis().  By default, it now
      makes use of the new (graphics-package independent) axisTicks()
      which can make use of a new utility .axisPars().  Further, it now
      returns a decreasing sequence (as for log=FALSE) when usr is
      decreasing.

    * Using fix() or edit() on a R object (except perhaps a matrix or
      data frame) writes its temporary file with extension .R so
      editors which select their mode based on the extension will
      select a suitable mode.

  GRAPHICS DEVICES:

    * The pdf() device makes use of Flate compression: this is
      controlled by the new logical argument compress, and is enabled
      by default.

    * Devices svg(), cairo_pdf() and cairo_ps() gain a family argument.

      On a Unix-alike X11() gains a family argument.  This is one of
      the x11.options() and so can be passed as an argument to the
      bmp(), jpeg(), png() and tiff() devices.

      Analogous changes have been made on Windows, so all built-in R
      graphics devices now have a family argument except pictex()
      (which has no means to change fonts).

    * The bmp(), jpeg(), png() and tiff() devices now make use of the
      antialias argument for type = "quartz".

    * There are several new built-in font mappings for X11(type =
      "Xlib"): see the help on X11Fonts().

    * There is a new type X11(type = "dbcairo") which updates the
      screen less frequently: see its help page.

    * The X11() device now makes use of cursors to distinguish its
      states.  The normal cursor is an arrow (rather than a crosshair);
      the crosshair is used when the locator is in use, and a watch
      cursor is shown when plotting computations are being done.
      (These are the standard names for X11 cursors: how they are
      actually displayed depends on the window manager.)

    * New functions dev.hold() and dev.flush() for use with graphics
      devices with buffering.  These are used for most of the
      high-level graphics functions such as boxplot(), so that the plot
      is only displayed when the page is complete.

      Currently implemented for windows(buffered = TRUE), quartz() and
      the cairographics-based X11() types with buffering (which are the
      default on-screen devices).

    * New function dev.capture() for capture of bitmap snapshots of
      image-based devices (a superset of the functionality provided by
      grid.cap() in grid).

    * The default colormodel for pdf() and postscript() is now called
      "srgb" to more accurately describe it.  (Instead of "rgb", and in
      the case of postscript() it no longer switches to and from the
      gray colorspace, by default.)

      The colormodel for postscript() which does use both gray and sRGB
      colorspaces is now called "srgb+gray".

      Plots which are known to use only black/white/transparent can
      advantageously use colormodel = "gray" (just as before, but there
      is now slightly more advantage in doing so).

    * postscript() with values colormodel = "rgb" and colormodel =
      "rgb-nogray" give the behaviour prior to R 2.13.0 of uncalibrated
      RGB, which under some circumstances can be rendered much faster
      by a viewer.

      pdf(colormodel = "rgb") gives the behaviour prior to R 2.13.0 of
      uncalibrated RGB, which under some circumstances can be rendered
      faster by a viewer, and the files will be smaller (by about 9KB
      if compression is not used).

    * The postscript() device only includes the definition of the sRGB
      colorspace in the output file for the colormodels which use it.

    * The postscript() and pdf() devices now output greyscale raster
      images (and not RGB) when colormodel = "gray".

    * postscript(colormodel = "gray") now accepts non-grey colours and
      uses their luminance (as pdf() long has).

    * colormodel = "grey" is allowed as an alternative name for
      postscript() and pdf().

    * pdf() in the default sRGB colorspace outputs many fewer changes
      of colorspace, which may speed up rendering in some viewing
      applications.

    * There is a new function dev.capabilities() to query the
      capabilities of the current device.  The initial set of
      capabilities are support for semi-transparent colours, rendering
      and capturing raster images, the locator and for interactive
      events.

    * For pdf(), maxRasters is increased as needed so the argument is
      no longer used.

  SWEAVE & VIGNETTES:

    * Options keep.source = TRUE, figs.only = FALSE are now the
      default.

    * The way the type of user-defined options is determined has
      changed.  Previously they were all regarded as logical: now the
      type is determined by the value given at first use.

    * The allowed values of logical options are now precisely those
      allowed for character inputs to as.logical(): this means that t
      and f are no longer allowed (although T and F still are).

    * The preferred location for vignette sources is now the directory
      vignettes and not inst/doc: R CMD build will now re-build
      vignettes in directory vignettes and copy the .Rnw (etc) files
      and the corresponding PDFs to inst/doc.  Further files to be
      copied to inst/doc can be specified _via_ the file
      vignettes/.install_extras.

    * R CMD Sweave now supports a --driver option to select the Sweave
      driver: the default is equivalent to --driver=RweaveLatex.

    * R CMD Sweave and R CMD Stangle support options --encoding and
      --options.

    * The Rtangle() driver allows output = "stdout" or output =
      "stderr" to select the output or message connection.  This is
      convenient for scripting using something like
      
          R CMD Stangle --options='output="stdout"' foo.Rnw > foo2.R

    * There is a new option pdf.compress controlling whether PDF
      figures are generated using Flate compression (they are by
      default).

    * R CMD Sweave now has a --pdf option to produce a PDF version of
      the processed Sweave document.

    * It is no longer allowed to have two vignettes with the same
      vignette basename (e.g. vig.Rnw and vig.Snw).  (Previously one
      vignette hid the other in the vignette() function.)

  C-LEVEL FACILITIES:

    * Function R_tmpnam2 has been added to the API to allow a temporary
      filename to include a specified extension.

  PACKAGE INSTALLATION:

    * Package DESCRIPTION file field KeepSource forces the package to
      be installed with keep.source = TRUE (or FALSE).  (Suggestion of
      Greg Snow.  Note that as all packages are lazy-loaded, this is
      now only relevant at installation.)

      There are corresponding options --with-keep.source and
      --without-keep.source for R CMD INSTALL.

    * R CMD INSTALL has a new option --byte-compile to byte-compile the
      packages during installation (since all packages are now
      lazy-loaded).  This can be controlled on a per-package basis by
      the optional field ByteCompile in the DESCRIPTION file.

    * A package R code but without a NAMESPACE file will have a default
      one created at R CMD build or R CMD INSTALL time, so all packages
      will be installed with namespaces.  A consequence of this is that
      .First.lib() functions need to be copied to .onLoad() (usually)
      or .onAttach().  For the time being, if there is an
      auto-generated NAMESPACE file and no .onLoad() nor .onAttach()
      function is found but .First.lib() is, it will be run as the
      attach hook (unless the package is one of a list of known
      exceptions, when it will be run as the load hook).

    * A warning is given if test-loading a package changes a locked
      binding in a package other than itself.  It is likely that this
      will be disallowed in future releases.  (There are _pro tem_ some
      exceptions to the warning.)

    * A dependency on SVN revision is allowed for R, e.g. R (>=
      r56550).  This should be used in conjunction with a version
      number, e.g. R (>= 2.14.0), R (>= r56550) to distinguish between
      R-patched and R-devel versions with the same SVN revision.

    * installed.packages() now hashes the names of its cache files to
      avoid very rare problems with excessively long path names.
      (PR#14669)

    * A top-level COPYING file in a package is no longer installed
      (file names LICENSE or LICENCE having long been preferred).

  UTILITIES:

    * R CMD check now gives an error if the R code in a vignette fails
      to run, unless this is caused by a missing package.

    * R CMD check now unpacks tarballs in the same way as R CMD
      INSTALL, including making use of the environment variable
      R_INSTALL_TAR to override the default behaviour.

    * R CMD check performs additional code analysis of package startup
      functions, and notifies about incorrect argument lists and
      (incorrect) calls to functions which modify the search path or
      inappropriately generate messages.

    * R CMD check now also checks compiled code for symbols
      corresponding to functions which might terminate R or write to
      stdout/stderr instead of the console.

    * R CMD check now uses a pdf() device when checking examples
      (rather than postscript()).

    * R CMD check now checks line-endings of makefiles and
      C/C++/Fortran sources in subdirectories of src as well as in src
      itself.

    * R CMD check now reports as a NOTE what look like methods
      documented with their full names even if there is a namespace and
      they are exported.  In almost all cases they are intended to be
      used only as methods and should use the \method markup.  In the
      other rare cases the recommended form is to use a function such
      as coefHclust which would not get confused with a method,
      document that and register it in the NAMESPACE file by
      s3method(coef, hclust, coefHclust).

    * The default for the environment variable _R_CHECK_COMPACT_DATA2_
      is now true: thus if using the newer forms of compression
      introduced in R 2.10.0 would be beneficial is now checked (by
      default).

    * Reference output for a vignette can be supplied when checking a
      package by R CMD check: see 'Writing R Extensions'.

    * R CMD Rd2dvi allows the use of LaTeX package inputenx rather than
      inputenc: the value of the environment variable RD2DVI_INPUTENC
      is used.  (LaTeX package inputenx is an optional install which
      provides greater coverage of the UTF-8 encoding.)

    * Rscript on a Unix-alike now accepts file names containing spaces
      (provided these are escaped or quoted in the shell).

    * R CMD build on a Unix-alike (only) now tries to preserve dates on
      files it copies from its input directory.  (This was the
      undocumented behaviour prior to R 2.13.0.)

  DEPRECATED AND DEFUNCT:

    * require() no longer has a save argument.

    * The gamma argument to hsv(), rainbow(), and rgb2hsv() has been
      removed.

    * The --no-docs option for R CMD build --binary is defunct: use
      --install-args instead.

    * The option --unsafe to R CMD INSTALL is defunct: use the
      identical option --no-lock instead.

    * The entry point pythag formerly in Rmath.h is defunct: use
      instead the C99 function hypot.

    * R CMD build --binary is formally defunct: R CMD INSTALL --build
      has long been the preferred alternative.

    * zip.file.extract() is now defunct: use unzip() or unz() instead.

    * R CMD Rd2dvi without the --pdf option is now deprecated: only PDF
      output will be supported in future releases (since this allows
      the use of fonts only supported for PDF), and only R CMD Rd2pdf
      will be available.

    * Options such as --max-nsize and the function mem.limits() are now
      deprecated: these limits are nowadays almost never used, and are
      reported by gc() when they are in use.

    * Forms like binomial(link = "link") for GLM families deprecated
      since R 2.4.0 are now defunct.

    * The declarativeOnly argument to loadNamespace() (not relevant
      since R 2.13.0) has been removed.

    * Use of library.dynam() without specifying all the first three
      arguments is deprecated.  (It is often called from a namespace,
      and the defaults are only appropriate to a package.)

      Use of chname in library.dynam() with the extension .so or .dll
      (which is clearly not allowed according to the help page) is
      deprecated.  This also applies to library.dynam.unload() and
      useDynLib directives in NAMESPACE files.

    * It is deprecated to use mean(x) and sd(x) directly on data frames
      (or also matrices, for sd) x, instead of simply using sapply.

      In the same spirit, median(x) now gives an error for a data frame
      x (it often gave nonsensical results).

    * The keep.source argument to library() and require() is
      deprecated: it was only used for packages installed without
      lazy-loading, and now all packages are lazy-loaded.

    * Using a false value for the DESCRIPTION field LazyLoad is
      deprecated.

  INSTALLATION:

    * The base and recommended packages are now byte-compiled
      (equivalent to make bytecode in R 2.13.x).

    * Configure option --with-system-zlib now only makes use of the
      basic interface of zlib and not the C function gzseek which has
      shown erroneous behaviour in zlib 1.2.4 and 1.2.5.

    * The zlib in the R sources is now version 1.2.5.  (This is safe
      even on 32-bit Linux systems because only the basic interface is
      now used.)

    * The .afm files in package grDevices are now installed as
      compressed files (as long done on Windows), saving ca 2MB on the
      installed size.

    * The non-screen cairo-based devices are no longer in the X11
      module and so can be installed without X11.  (We have never seen
      a Unix-alike system with cairographics installed but not X11, but
      a user might select --without-x.)

    * Configure will try to use -fobjc-exceptions for the Objective-C
      compiler (if present) to ensure that even compilers that do not
      enable exceptions by default (such as vanilla gcc) can be used.
      (Objective-C is currently only used on Mac OS X.)

    * The system call times is required.

    * The C99 functions acosh, asinh, atanh, snprintf and vsnprintf are
      now required.

    * There is no longer support for making DVI manuals _via_ make dvi,
      make install-dvi and similar.  Only PDF manuals are supported (to
      allow the use of fonts which are only available for PDF.)

    * The configure arguments used during configuration of R are
      included as a comment in Makeconf for informative purposes on
      Unix-alikes in a form suitable for shell execution.  Note that
      those are merely command-line arguments, they do not include
      environment variables (one more reason to use configure variables
      instead) or site configuration settings.

    * Framework installation now supports DESTDIR (Mac OS X only).

    * Java detection (R CMD javareconf) works around bogus
      java.library.path property in recent Oracle Java binaries.

  BUG FIXES:

    * The locale category LC_MONETARY was only being set on startup on
      Windows: that is now done on Unix-alikes where supported.

    * Reference class utilities will detect an attempt to modify
      methods or fields in a locked class definition (e.g., in a
      namespace) and generate an error.

    * The formula methods for lines(), points() and text() now work
      even if package stats is not on the search path.

    * In principle, S4 classes from different packages could have the
      same name.  This has not previously worked.  Changes have now
      been installed that should allow such classes and permit methods
      to use them.  New functions className() and multipleClasses() are
      related tools for programming.

    * Work around an issue in Linux (a system select call resetting tv)
      which prevented internet operations from timing out properly.

    * Several stack trampling and overflow issues have been fixed in
      TRE, triggered by agrep and friends with long patterns.
      (PR#14627)

    * ("design infelicity") Field assignments in reference classes are
      now consistent with slots in S4 classes: the assigned value must
      come from the declared class (if any) for the field or from a
      subclass.

    * The methods objects constructed for "coerce" and "coerce<-" were
      lacking some essential information in the generic, defined and
      target slots; as() did not handle duplicate class definitions
      correctly.

    * The parser no longer accepts the digit 8 in an octal character
      code in a string, nor does it accept unterminated strings in a
      file.  (Reported by Bill Dunlap.)

    * The print() method for class "summary.aov" did not pass on
      argument digits when summary() was called on a single object, and
      hence used more digits than documented.

    * The X11() device's cairo back-end produced incorrect capture
      snapshot images on big-endian machines.

    * loglin() gave a spurious error when argument margin consisted of
      a single element of length one.  (PR#14690)

    * loess() is better protected against misuse, e.g. zero-length
      span.  (PR#14691)

    * HoltWinters() checks that the optimization succeeded. (PR#14694)

    * The (undocumented) inclusion of superclass objects in default
      initializing of reference classes overwrote explicit field
      arguments. The bug is fixed, the feature documented and a test
      added.

    * round(x, -Inf) now does something sensible (return zero rather
      than NA).

    * signif(x, -Inf) now behaves as documented (signif(x, 1)) rather
      than giving zero.

    * The "table" method for Axis() hardcoded side = 1, hence calls to
      plot(<vector>, <table>) labelled the wrong axis. (PR#14699)

    * Creating a connection might fail under gctorture(TRUE).

    * stack() and unstack() converted character columns to factors.

      unstack() sometimes produced incorrect results (a list or a
      vector) if the factor on which to un-split had only one level.

    * On some systems help(".C", help_type = "pdf") and similar
      generated file names that TeX was unable to handle.

    * Non-blocking listening socket connections continued to report
      isIncomplete() as true even when the peer had closed down and all
      available input had been read.

    * The revised HTML search system now generates better hyperlinks to
      help topics found: previously it gave problems with help pages
      with names containing e.g. spaces and slashes.

    * A late change in R 2.13.2 broke \Sexpr expressions in Rd files.

    * The creation of ticks on log axes (including by axTicks())
      sometimes incorrectly omitted a tick at one end of the range by
      rounding error in a platform-dependent way.  This could be seen
      in the examples for axTicks(), where with axis limits c(0.2, 88)
      the tick for 0.2 was sometimes omitted.

    * qgamma() for small shape underflows to 0 rather than sometimes
      giving NaN.  (PR#8528, PR#14710)

    * mapply() now gives an explicit error message (rather than an
      obscure one) if inputs of zero and positive length are mixed.

    * Setting a Hershey font family followed by string height query
      would crash R.

    * R CMD javareconf -e would fail for some shells due to a shift
      error. Also the resulting paths will no longer contain
      $(JAVA_HOME) as that can result in an unintended substitution
      based on Makeconf instead of the shell setting.

CHANGES IN R VERSION 2.13.2:

  NEW FEATURES:

    * mem.limits() now reports values larger than the maximum integer
      (previously documented to be reported as NA), and allows larger
      values to be set, including Inf to remove the limit.

    * The print() methods for classes "Date", "POSIXct" and "POSIXlt"
      respect the option "max.print" and so are much faster for very
      long datetime vectors.  (Suggestion of Yohan Chalabi.)

    * untar2() now works around errors generated with tar files that
      use more than the standard 6 digits for the checksum. (PR#14654)

    * install.packages() with Ncpus > 1 guards against simultaneous
      installation of indirect dependencies as well as direct ones.

    * Sweave now knows about a few more Windows' encodings (including
      cp1250 and cp1257) and some inputenx encodings such as koi8-r.

    * postscript(colormodel = "rgb-nogray") no longer sets the sRGB
      colorspace for each colour and so some viewers may render its
      files much faster than the default colormodel ="rgb".

    * The default for pdf(maxRasters=) has been increased from 64 to
      1000.

    * readBin() now warns if signed = FALSE is used inappropriately
      (rather than being silently ignored).

      It enforces the documented limit of 2^31-1 bytes in a single
      call.

    * PCRE has been updated to version 8.13, a bug-fix release with
      updated Unicode tables (version 6.0.0).  An additional patch
      (r611 from PCRE 8.20-to-be) has been added to fix a collation
      symbol recognition issue.

  INSTALLATION:

    * It is possible to build in src/extra/xdr on more platforms.
      (Needed since glibc 2.14 hides its RPC implementation.)

    * configure will find the Sun TI-RPC implementation of xdr (in
      libtirpc) provided its header files are in the search path: see
      the 'R Installation and Administration Manual'.

  PACKAGE INSTALLATION:

    * Using a broad exportPattern directive in a NAMESPACE file is no
      longer allowed to export internal objects such as .onLoad and
      .__S3MethodsTable__. .

      These are also excluded from imports, along with .First.lib.

  BUG FIXES:

    * fisher.test() had a buglet: If arguments were factors with unused
      levels, levels were dropped and you would get an error saying
      that there should be at least two levels, inconsistently with
      pre-tabulated data.  (Reported by Michael Fay).

    * package.skeleton() will no longer dump S4 objects supplied
      directly rather than in a code file.  These cannot be restored
      correctly from the dumped version.

    * Build-time expressions in help files did not have access to
      functions in the package being built (with R CMD build).

    * Because quote() did not mark its result as being in use,
      modification of the result could in some circumstances modify the
      original call.

    * Plotting pch = '.' now guarantees at least a one-pixel dot if cex
      > 0.

    * The very-rarely-used command-line option --max-vsize was
      incorrectly interpreted as a number of Vcells and not in bytes as
      documented.  (Spotted by Christophe Rhodes.)

    * The HTML generated by Rd2HTML() comes closer to being standards
      compliant.

    * filter(x, recursive = TRUE) gave incorrect results on a series
      containing NAs.  (Spotted by Bill Dunlap.)

    * Profiling stats::mle() fits with a fixed parameter was not
      supported.  (PR#14646)

    * retracemem() was still using positional matching.  (PR#14650)

    * The quantile method for "ecdf" objects now works and is
      documented.

    * xtabs(~ .., ..., sparse=TRUE) now also works together with an
      exclude = .. specification.

    * decompose() computed an incorrect seasonal component for time
      series with odd frequencies.

    * The pdf() device only includes the definition of the sRGB
      colorspace in the output file for the "rgb" colormodel (and not
      for "gray" nor "cmyk"): this saves ca 9KB in the output file.

    * .hasSlot() wrongly gave FALSE in some cases.

    * Sweave() with keep.source=TRUE could generate spurious NA lines
      when a chunk reference appeared last in a code chunk.

    * \Sexpr[results=rd] in an .Rd file now first tries
      parse_Rd(fragment=FALSE) to allow Rd section-level macros to be
      inserted.

    * The print() method for class "summary.aov" did not pass on
      arguments such as signif.stars when summary() was called on a
      single object.  (PR#14684)

    * In rare cases ks.test() could return a p-value very slightly less
      than 0 by rounding error.  (PR#14671)

    * If trunc() was called on a "POSIXlt" vector and the result was
      subsetted, all but the first element was converted to NA.
      (PR#14679)

    * cbind() and rbind() could cause memory corruption when used on a
      combination of raw and logical/integer vectors.

CHANGES IN R VERSION 2.13.1:

  NEW FEATURES:

    * iconv() no longer translates NA strings as "NA".

    * persp(box = TRUE) now warns if the surface extends outside the
      box (since occlusion for the box and axes is computed assuming
      the box is a bounding box). (PR#202)

    * RShowDoc() can now display the licences shipped with R, e.g.
      RShowDoc("GPL-3").

    * New wrapper function showNonASCIIfile() in package tools.

    * nobs() now has a "mle" method in package stats4.

    * trace() now deals correctly with S4 reference classes and
      corresponding reference methods (e.g., $trace()) have been added.

    * xz has been updated to 5.0.3 (very minor bugfix release).

    * tools::compactPDF() gets more compression (usually a little,
      sometimes a lot) by using the compressed object streams of PDF
      1.5.

    * cairo_ps(onefile = TRUE) generates encapsulated EPS on platforms
      with cairo >= 1.6.

    * Binary reads (e.g. by readChar() and readBin()) are now supported
      on clipboard connections.  (Wish of PR#14593.)

    * as.POSIXlt.factor() now passes ... to the character method
      (suggestion of Joshua Ulrich).  [Intended for R 2.13.0 but
      accidentally removed before release.]

    * vector() and its wrappers such as integer() and double() now warn
      if called with a length argument of more than one element.  This
      helps track down user errors such as calling double(x) instead of
      as.double(x).

  INSTALLATION:

    * Building the vignette PDFs in packages grid and utils is now part
      of running make from an SVN checkout on a Unix-alike: a separate
      make vignettes step is no longer required.

      These vignettes are now made with keep.source = TRUE and hence
      will be laid out differently.

    * make install-strip failed under some configuration options.

    * Packages can customize non-standard installation of compiled code
      via a src/install.libs.R script. This allows packages that have
      architecture-specific binaries (beyond the package's shared
      objects/DLLs) to be installed in a multi-architecture setting.

  SWEAVE & VIGNETTES:

    * Sweave() and Stangle() gain an encoding argument to specify the
      encoding of the vignette sources if the latter do not contain a
      \usepackage[]{inputenc} statement specifying a single input
      encoding.

    * There is a new Sweave option figs.only = TRUE to run each figure
      chunk only for each selected graphics device, and not first using
      the default graphics device.  This will become the default in R
      2.14.0.

    * Sweave custom graphics devices can have a custom function
      foo.off() to shut them down.

    * Warnings are issued when non-portable filenames are found for
      graphics files (and chunks if split = TRUE).  Portable names are
      regarded as alphanumeric plus hyphen, underscore, plus and hash
      (periods cause problems with recognizing file extensions).

    * The Rtangle() driver has a new option show.line.nos which is by
      default false; if true it annotates code chunks with a comment
      giving the line number of the first line in the sources (the
      behaviour of R >= 2.12.0).

    * Package installation tangles the vignette sources: this step now
      converts the vignette sources from the vignette/package encoding
      to the current encoding, and records the encoding (if not ASCII)
      in a comment line at the top of the installed .R file.

  LICENCE:

    * No parts of R are now licensed solely under GPL-2.  The licences
      for packages rpart and survival have been changed, which means
      that the licence terms for R as distributed are GPL-2 | GPL-3.

  DEPRECATED AND DEFUNCT:

    * The internal functions .readRDS() and .saveRDS() are now
      deprecated in favour of the public functions readRDS() and
      saveRDS() introduced in R 2.13.0.

    * Switching off lazy-loading of code _via_ the LazyLoad field of
      the DESCRIPTION file is now deprecated.  In future all packages
      will be lazy-loaded.

    * The off-line help() types "postscript" and "ps" are deprecated.

  UTILITIES:

    * R CMD check on a multi-architecture installation now skips the
      user's .Renviron file for the architecture-specific tests (which
      do read the architecture-specific Renviron.site files).  This is
      consistent with single-architecture checks, which use
      --no-environ.

    * R CMD build now looks for DESCRIPTION fields BuildResaveData and
      BuildKeepEmpty for per-package overrides.  See 'Writing R
      Extensions'.

  BUG FIXES:

    * plot.lm(which = 5) was intended to order factor levels in
      increasing order of mean standardized residual.  It ordered the
      factor labels correctly, but could plot the wrong group of
      residuals against the label.  (PR#14545)

    * mosaicplot() could clip the factor labels, and could overlap them
      with the cells if a non-default value of cex.axis was used.
      (Related to PR#14550.)

    * dataframe[[row,col]] now dispatches on [[ methods for the
      selected column.  (Spotted by Bill Dunlap).

    * sort.int() would strip the class of an object, but leave its
      object bit set.  (Reported by Bill Dunlap.)

    * pbirthday() and qbirthday() did not implement the algorithm
      exactly as given in their reference and so were unnecessarily
      inaccurate.

      pbirthday() now solves the approximate formula analytically
      rather than using uniroot() on a discontinuous function.

      The description of the problem was inaccurate: the probability is
      a tail probability ('2 _or more_ people share a birthday')

    * Complex arithmetic sometimes warned incorrectly about producing
      NAs when there were NaNs in the input.

    * seek(origin = "current") incorrectly reported it was not
      implemented for a gzfile() connection.

    * c(), unlist(), cbind() and rbind() could silently overflow the
      maximum vector length and cause a segfault.  (PR#14571)

    * The fonts argument to X11(type = "Xlib") was being ignored.

    * Reading (e.g. with readBin()) from a raw connection was not
      advancing the pointer, so successive reads would read the same
      value.  (Spotted by Bill Dunlap.)

    * Parsed text containing embedded newlines was printed incorrectly
      by as.character.srcref().  (Reported by Hadley Wickham.)

    * decompose() used with a series of a non-integer number of periods
      returned a seasonal component shorter than the original series.
      (Reported by Rob Hyndman.)

    * fields = list() failed for setRefClass().  (Reported by Michael
      Lawrence.)

    * Reference classes could not redefine an inherited field which had
      class "ANY". (Reported by Janko Thyson.)

    * Methods that override previously loaded versions will now be
      installed and called.  (Reported by Iago Mosqueira.)

    * addmargins() called numeric(apos) rather than
      numeric(length(apos)).

    * The HTML help search sometimes produced bad links.  (PR#14608)

    * Command completion will no longer be broken if tail.default() is
      redefined by the user. (Problem reported by Henrik Bengtsson.)

    * LaTeX rendering of markup in titles of help pages has been
      improved; in particular, \eqn{} may be used there.

    * isClass() used its own namespace as the default of the where
      argument inadvertently.

    * Rd conversion to latex mishandled multi-line titles (including
      cases where there was a blank line in the \title section).  (It
      seems this happened only in 2.13.0 patched.)

    * postscript() with an sRGB colormodel now uses sRGB for raster
      images (in R 2.13.[01] it used uncalibrated RGB).

      There is no longer an undocumented 21845-pixel limit on raster
      images.

CHANGES IN R VERSION 2.13.0:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * replicate() (by default) and vapply() (always) now return a
      higher-dimensional array instead of a matrix in the case where
      the inner function value is an array of dimension >= 2.

    * Printing and formatting of floating point numbers is now using
      the correct number of digits, where it previously rarely differed
      by a few digits. (See "scientific" entry below.)  This affects
      _many_ *.Rout.save checks in packages.

  NEW FEATURES:

    * normalizePath() has been moved to the base package (from utils):
      this is so it can be used by library() and friends.

      It now does tilde expansion.

      It gains new arguments winslash (to select the separator on
      Windows) and mustWork to control the action if a canonical path
      cannot be found.

    * The previously barely documented limit of 256 bytes on a symbol
      name has been raised to 10,000 bytes (a sanity check).  Long
      symbol names can sometimes occur when deparsing expressions (for
      example, in model.frame).

    * reformulate() gains a intercept argument.

    * cmdscale(add = FALSE) now uses the more common definition that
      there is a representation in n-1 or less dimensions, and only
      dimensions corresponding to positive eigenvalues are used.
      (Avoids confusion such as PR#14397.)

    * Names used by c(), unlist(), cbind() and rbind() are marked with
      an encoding when this can be ascertained.

    * R colours are now defined to refer to the sRGB color space.

      The PDF, PostScript, and Quartz graphics devices record this
      fact.  X11 (and cairo) and Windows just assume that your screen
      conforms.

    * system.file() gains a mustWork argument (suggestion of Bill
      Dunlap).

    * new.env(hash = TRUE) is now the default.

    * list2env(envir = NULL) defaults to hashing (with a suitably sized
      environment) for lists of more than 100 elements.

    * text() gains a formula method.

    * IQR() now has a type argument which is passed to quantile().

    * as.vector(), as.double() etc duplicate less when they leave the
      mode unchanged but remove attributes.

      as.vector(mode = "any") no longer duplicates when it does not
      remove attributes.  This helps memory usage in matrix() and
      array().

      matrix() duplicates less if data is an atomic vector with
      attributes such as names (but no class).

      dim(x) <- NULL duplicates less if x has neither dimensions nor
      names (since this operation removes names and dimnames).

    * setRepositories() gains an addURLs argument.

    * chisq.test() now also returns a stdres component, for
      standardized residuals (which have unit variance, unlike the
      Pearson residuals).

    * write.table() and friends gain a fileEncoding argument, to
      simplify writing files for use on other OSes (e.g. a spreadsheet
      intended for Windows or Mac OS X Excel).

    * Assignment expressions of the form foo::bar(x) <- y and
      foo:::bar(x) <- y now work; the replacement functions used are
      foo::`bar<-` and foo:::`bar<-`.

    * Sys.getenv() gains a names argument so Sys.getenv(x, names =
      FALSE) can replace the common idiom of as.vector(Sys.getenv()).
      The default has been changed to not name a length-one result.

    * Lazy loading of environments now preserves attributes and locked
      status. (The locked status of bindings and active bindings are
      still not preserved; this may be addressed in the future).

    * options("install.lock") may be set to FALSE so that
      install.packages() defaults to --no-lock installs, or (on
      Windows) to TRUE so that binary installs implement locking.

    * sort(partial = p) for large p now tries Shellsort if quicksort is
      not appropriate and so works for non-numeric atomic vectors.

    * sapply() gets a new option simplify = "array" which returns a
      "higher rank" array instead of just a matrix when FUN() returns a
      dim() length of two or more.

      replicate() has this option set by default, and vapply() now
      behaves that way internally.

    * aperm() becomes S3 generic and gets a table method which
      preserves the class.

    * merge() and as.hclust() methods for objects of class "dendrogram"
      are now provided.

    * The character method of as.POSIXlt() now tries to find a format
      that works for all non-NA inputs, not just the first one.

    * str() now has a method for class "Date" analogous to that for
      class "POSIXt".

    * New function file.link() to create hard links on those file
      systems (POSIX, NTFS but not FAT) that support them.

    * New Summary() group method for class "ordered" implements min(),
      max() and range() for ordered factors.

    * mostattributes<-() now consults the "dim" attribute and not the
      dim() function, making it more useful for objects (such as data
      frames) from classes with methods for dim().  It also uses
      attr<-() in preference to the generics name<-(), dim<-() and
      dimnames<-().  (Related to PR#14469.)

    * There is a new option "browserNLdisabled" to disable the use of
      an empty (e.g. via the 'Return' key) as a synonym for c in
      browser() or n under debug().  (Wish of PR#14472.)

    * example() gains optional new arguments character.only and
      give.lines enabling programmatic exploration.

    * serialize() and unserialize() are no longer described as
      'experimental'.  The interface is now regarded as stable,
      although the serialization format may well change in future
      releases.  (serialize() has a new argument version which would
      allow the current format to be written if that happens.)

      New functions saveRDS() and readRDS() are public versions of the
      'internal' functions .saveRDS() and .readRDS() made available for
      general use.  The dot-name versions remain available as several
      package authors have made use of them, despite the documentation.
      readRDS() no longer wraps non-file connections in a call to
      gzcon(), for efficiency (see its documentation).

      saveRDS() supports compress = "xz".

    * Many functions when called with a not-open connection will now
      ensure that the connection is left not-open in the event of
      error.  These include read.dcf(), dput(), dump(), load(),
      parse(), readBin(), readChar(), readLines(), save(), writeBin(),
      writeChar(), writeLines(), .readRDS(), .saveRDS() and
      tools::parse_Rd(), as well as functions calling these.

    * Public functions find.package() and path.package() replace the
      internal dot-name versions.

    * The default method for terms() now looks for a "terms" attribute
      if it does not find a "terms" component, and so works for model
      frames.

    * httpd() handlers receive an additional argument containing the
      full request headers as a raw vector (this can be used to parse
      cookies, multi-part forms etc.). The recommended full signature
      for handlers is therefore function(url, query, body, headers,
      ...).

    * file.edit() gains a fileEncoding argument to specify the encoding
      of the file(s).

    * The format of the HTML package listings has changed.  If there is
      more than one library tree , a table of links to libraries is
      provided at the top and bottom of the page.  Where a library
      contains more than 100 packages, an alphabetic index is given at
      the top of the section for that library.  (As a consequence,
      package names are now sorted case-insensitively whatever the
      locale.)

    * isSeekable() now returns FALSE on connections which have
      non-default encoding.  Although documented to record if 'in
      principle' the connection supports seeking, it seems safer to
      report FALSE when it may not work.

    * R CMD REMOVE and remove.packages() now remove file R.css when
      removing all remaining packages in a library tree.  (Related to
      the wish of PR#14475: note that this file is no longer
      installed.)

    * unzip() now has a unzip argument like zip.file.extract().  This
      allows an external unzip program to be used, which can be useful
      to access features supported by Info-ZIP's unzip version 6 which
      is now becoming more widely available.

    * There is a simple zip() function, as wrapper for an external zip
      command.

    * bzfile() connections can now read from concatenated bzip2 files
      (including files written with bzfile(open = "a")) and files
      created by some other compressors (such as the example of
      PR#14479).

    * The primitive function c() is now of type BUILTIN.

    * plot(<dendrogram>, .., nodePar=*) now obeys an optional xpd
      specification (allowing clipping to be turned off completely).

    * nls(algorithm="port") now shares more code with nlminb(), and is
      more consistent with the other nls() algorithms in its return
      value.

    * xz has been updated to 5.0.1 (very minor bugfix release).

    * image() has gained a logical useRaster argument allowing it to
      use a bitmap raster for plotting a regular grid instead of
      polygons. This can be more efficient, but may not be supported by
      all devices. The default is FALSE.

    * list.files()/dir() gains a new argument include.dirs() to include
      directories in the listing when recursive = TRUE.

    * New function list.dirs() lists all directories, (even empty
      ones).

    * file.copy() now (by default) copies read/write/execute
      permissions on files, moderated by the current setting of
      Sys.umask().

    * Sys.umask() now accepts mode = NA and returns the current umask
      value (visibly) without changing it.

    * There is a ! method for classes "octmode" and "hexmode": this
      allows xor(a, b) to work if both a and b are from one of those
      classes.

    * as.raster() no longer fails for vectors or matrices containing
      NAs.

    * New hook "before.new.plot" allows functions to be run just before
      advancing the frame in plot.new, which is potentially useful for
      custom figure layout implementations.

    * Package tools has a new function compactPDF() to try to reduce
      the size of PDF files _via_ qpdf or gs.

    * tar() has a new argument extra_flags.

    * dotchart() accepts more general objects x such as 1D tables which
      can be coerced by as.numeric() to a numeric vector, with a
      warning since that might not be appropriate.

    * The previously internal function create.post() is now exported
      from utils, and the documentation for bug.report() and
      help.request() now refer to that for create.post().

      It has a new method = "mailto" on Unix-alikes similar to that on
      Windows: it invokes a default mailer via open (Mac OS X) or
      xdg-open or the default browser (elsewhere).

      The default for ccaddress is now getOption("ccaddress") which is
      by default unset: using the username as a mailing address
      nowadays rarely works as expected.

    * The default for options("mailer") is now "mailto" on all
      platforms.

    * unlink() now does tilde-expansion (like most other file
      functions).

    * file.rename() now allows vector arguments (of the same length).

    * The "glm" method for logLik() now returns an "nobs" attribute
      (which stats4::BIC() assumed it did).

      The "nls" method for logLik() gave incorrect results for zero
      weights.

    * There is a new generic function nobs() in package stats, to
      extract from model objects a suitable value for use in BIC
      calculations.  An S4 generic derived from it is defined in
      package stats4.

    * Code for S4 reference-class methods is now examined for possible
      errors in non-local assignments.

    * findClasses, getGeneric, findMethods and hasMethods are revised
      to deal consistently with the package= argument and be consistent
      with soft namespace policy for finding objects.

    * tools::Rdiff() now has the option to return not only the status
      but a character vector of observed differences (which are still
      by default sent to stdout).

    * The startup environment variables R_ENVIRON_USER, R_ENVIRON,
      R_PROFILE_USER and R_PROFILE are now treated more consistently.
      In all cases an empty value is considered to be set and will stop
      the default being used, and for the last two tilde expansion is
      performed on the file name.  (Note that setting an empty value is
      probably impossible on Windows.)

    * Using R --no-environ CMD, R --no-site-file CMD or R
      --no-init-file CMD sets environment variables so these settings
      are passed on to child R processes, notably those run by INSTALL,
      check and build. R --vanilla CMD sets these three options (but
      not --no-restore).

    * smooth.spline() is somewhat faster.  With cv=NA it allows some
      leverage computations to be skipped,

    * The internal (C) function scientific(), at the heart of R's
      format.info(x), format(x), print(x), etc, for numeric x, has been
      re-written in order to provide slightly more correct results,
      fixing PR#14491, notably in border cases including when digits >=
      16, thanks to substantial contributions (code and experiments)
      from Petr Savicky.  This affects a noticeable amount of numeric
      output from R.

    * A new function grepRaw() has been introduced for finding subsets
      of raw vectors. It supports both literal searches and regular
      expressions.

    * Package compiler is now provided as a standard package.  See
      ?compiler::compile for information on how to use the compiler.
      This package implements a byte code compiler for R: by default
      the compiler is not used in this release.  See the 'R
      Installation and Administration Manual' for how to compile the
      base and recommended packages.

    * Providing an exportPattern directive in a NAMESPACE file now
      causes classes to be exported according to the same pattern, for
      example the default from package.skeleton() to specify all names
      starting with a letter.  An explicit directive to
      exportClassPattern will still over-ride.

    * There is an additional marked encoding "bytes" for character
      strings.  This is intended to be used for non-ASCII strings which
      should be treated as a set of bytes, and never re-encoded as if
      they were in the encoding of the current locale: useBytes = TRUE
      is automatically selected in functions such as writeBin(),
      writeLines(), grep() and strsplit().

      Only a few character operations are supported (such as substr()).

      Printing, format() and cat() will represent non-ASCII bytes in
      such strings by a \xab escape.

    * The new function removeSource() removes the internally stored
      source from a function.

    * "srcref" attributes now include two additional line number
      values, recording the line numbers in the order they were parsed.

    * New functions have been added for source reference access:
      getSrcFilename(), getSrcDirectory(), getSrcLocation() and
      getSrcref().

    * Sys.chmod() has an extra argument use_umask which defaults to
      true and restricts the file mode by the current setting of umask.
      This means that all the R functions which manipulate
      file/directory permissions by default respect umask, notably R
      CMD INSTALL.

    * tempfile() has an extra argument fileext to create a temporary
      filename with a specified extension.  (Suggestion and initial
      implementation by Dirk Eddelbuettel.)

      There are improvements in the way Sweave() and Stangle() handle
      non-ASCII vignette sources, especially in a UTF-8 locale: see
      'Writing R Extensions' which now has a subsection on this topic.

    * factanal() now returns the rotation matrix if a rotation such as
      "promax" is used, and hence factor correlations are displayed.
      (Wish of PR#12754.)

    * The gctorture2() function provides a more refined interface to
      the GC torture process.  Environment variables R_GCTORTURE,
      R_GCTORTURE_WAIT, and R_GCTORTURE_INHIBIT_RELEASE can also be
      used to control the GC torture process.

    * file.copy(from, to) no longer regards it as an error to supply a
      zero-length from: it now simply does nothing.

    * rstandard.glm() gains a type argument which can be used to
      request standardized Pearson residuals.

    * A start on a Turkish translation, thanks to Murat Alkan.

    * .libPaths() calls normalizePath(winslash = "/") on the paths:
      this helps (usually) to present them in a user-friendly form and
      should detect duplicate paths accessed via different symbolic
      links.

    * download.file() can be now used with external methods even if
      there are spaces in the URL or the target filename.

    * The first formal argument of .C(), .Fortran(), .Call() and
      .External() is now referred to a .NAME rather than name: however
      actual calls should have an unnamed first argument.

  SWEAVE CHANGES:

    * Sweave() has options to produce PNG and JPEG figures, and to use
      a custom function to open a graphics device (see ?RweaveLatex).
      (Based in part on the contribution of PR#14418.)

    * The default for Sweave() is to produce only PDF figures (rather
      than both EPS and PDF).

    * Environment variable SWEAVE_OPTIONS can be used to supply
      defaults for existing or new options to be applied after the
      Sweave driver setup has been run.

    * The Sweave manual is now included as a vignette in the utils
      package.

    * Sweave() handles keep.source=TRUE much better: it could duplicate
      some lines and omit comments. (Reported by John Maindonald and
      others.)

  C-LEVEL FACILITIES:

    * Because they use a C99 interface which a C++ compiler is not
      required to support, Rvprintf and REvprintf are only defined by
      R_ext/Print.h in C++ code if the macro R_USE_C99_IN_CXX is
      defined when it is included.

    * pythag duplicated the C99 function hypot.  It is no longer
      provided, but is used as a substitute for hypot in the very
      unlikely event that the latter is not available.

    * R_inspect(obj) and R_inspect3(obj, deep, pvec) are (hidden)
      C-level entry points to the internal inspect function and can be
      used for C-level debugging (e.g., in conjunction with the p
      command in gdb).

    * Compiling R with --enable-strict-barrier now also enables
      additional checking for use of unprotected objects. In
      combination with gctorture() or gctorture2() and a C-level
      debugger this can be useful for tracking down memory protection
      issues.

  UTILITIES:

    * R CMD Rdiff is now implemented in R on Unix-alikes (as it has
      been on Windows since R 2.12.0).

    * R CMD build no longer does any cleaning in the supplied package
      directory: all the cleaning is done in the copy.

      It has a new option --install-args to pass arguments to R CMD
      INSTALL for --build (but not when installing to rebuild
      vignettes).

      There is new option, --resave-data, to call
      tools::resaveRdaFiles() on the data directory, to compress
      tabular files (.tab, .csv etc) and to convert .R files to .rda
      files.  The default, --resave-data=gzip, is to do so in a way
      compatible even with years-old versions of R, but better
      compression is given by --resave-data=best, requiring R >=
      2.10.0.

      It now adds a datalist file for data directories of more than
      1Mb.

      Patterns in .Rbuildignore are now also matched against all
      directory names (including those of empty directories).

      There is a new option, --compact-vignettes, to try reducing the
      size of PDF files in the inst/doc directory.  Currently this
      tries qpdf: other options may be used in future.

      When re-building vignettes and a inst/doc/Makefile file is found,
      make clean is run if the makefile has a clean: target.

      After re-building vignettes the default clean-up operation will
      remove any directories (and not just files) created during the
      process: e.g. one package created a .R_cache directory.

      Empty directories are now removed unless the option
      --keep-empty-dirs is given (and a few packages do deliberately
      include empty directories).

      If there is a field BuildVignettes in the package DESCRIPTION
      file with a false value, re-building the vignettes is skipped.

    * R CMD check now also checks for filenames that are
      case-insensitive matches to Windows' reserved file names with
      extensions, such as nul.Rd, as these have caused problems on some
      Windows systems.

      It checks for inefficiently saved data/*.rda and data/*.RData
      files, and reports on those large than 100Kb.  A more complete
      check (including of the type of compression, but potentially much
      slower) can be switched on by setting environment variable
      _R_CHECK_COMPACT_DATA2_ to TRUE.

      The types of files in the data directory are now checked, as
      packages are _still_ misusing it for non-R data files.

      It now extracts and runs the R code for each vignette in a
      separate directory and R process: this is done in the package's
      declared encoding.  Rather than call tools::checkVignettes(), it
      calls tools::buildVignettes() to see if the vignettes can be
      re-built as they would be by R CMD build.  Option --use-valgrind
      now applies only to these runs, and not when running code to
      rebuild the vignettes.  This version does a much better job of
      suppressing output from successful vignette tests.

      The 00check.log file is a more complete record of what is output
      to stdout: in particular contains more details of the tests.

      It now checks all syntactically valid Rd usage entries, and warns
      about assignments (unless these give the usage of replacement
      functions).

      .tar.xz compressed tarballs are now allowed, if tar supports them
      (and setting environment variable TAR to internal ensures so on
      all platforms).

    * R CMD check now warns if it finds inst/doc/makefile, and R CMD
      build renames such a file to inst/doc/Makefile.

  INSTALLATION:

    * Installing R no longer tries to find perl, and R CMD no longer
      tries to substitute a full path for awk nor perl - this was a
      legacy from the days when they were used by R itself.  Because a
      couple of packages do use awk, it is set as the make (rather than
      environment) variable AWK.

    * make check will now fail if there are differences from the
      reference output when testing package examples and if environment
      variable R_STRICT_PACKAGE_CHECK is set to a true value.

    * The C99 double complex type is now required.

      The C99 complex trigonometric functions (such as csin) are not
      currently required (FreeBSD lacks most of them): substitutes are
      used if they are missing.

    * The C99 system call va_copy is now required.

    * If environment variable R_LD_LIBRARY_PATH is set during
      configuration (for example in config.site) it is used unchanged
      in file etc/ldpaths rather than being appended to.

    * configure looks for support for OpenMP and if found compiles R
      with appropriate flags and also makes them available for use in
      packages: see 'Writing R Extensions'.

      This is currently experimental, and is only used in R with a
      single thread for colSums() and colMeans().  Expect it to be more
      widely used in later versions of R.

      This can be disabled by the --disable-openmp flag.

  PACKAGE INSTALLATION:

    * R CMD INSTALL --clean now removes copies of a src directory which
      are created when multiple sub-architectures are in use.
      (Following a comment from Berwin Turlach.)

    * File R.css is now installed on a per-package basis (in the
      package's html directory) rather than in each library tree, and
      this is used for all the HTML pages in the package.  This helps
      when installing packages with static HTML pages for use on a
      webserver.  It will also allow future versions of R to use
      different stylesheets for the packages they install.

    * A top-level file .Rinstignore in the package sources can list (in
      the same way as .Rbuildignore) files under inst that should not
      be installed.  (Why should there be any such files?  Because all
      the files needed to re-build vignettes need to be under inst/doc,
      but they may not need to be installed.)

    * R CMD INSTALL has a new option --compact-docs to compact any PDFs
      under the inst/doc directory.  Currently this uses qpdf, which
      must be installed (see 'Writing R Extensions').

    * There is a new option --lock which can be used to cancel the
      effect of --no-lock or --pkglock earlier on the command line.

    * Option --pkglock can now be used with more than one package, and
      is now the default if only one package is specified.

    * Argument lock of install.packages() can now be use for Mac binary
      installs as well as for Windows ones.  The value "pkglock" is now
      accepted, as well as TRUE and FALSE (the default).

    * There is a new option --no-clean-on-error for R CMD INSTALL to
      retain a partially installed package for forensic analysis.

    * Packages with names ending in . are not portable since Windows
      does not work correctly with such directory names.  This is now
      warned about in R CMD check, and will not be allowed in R 2.14.x.

    * The vignette indices are more comprehensive (in the style of
      browseVignetttes()).

  DEPRECATED & DEFUNCT:

    * require(save = TRUE) is defunct, and use of the save argument is
      deprecated.

    * R CMD check --no-latex is defunct: use --no-manual instead.

    * R CMD Sd2Rd is defunct.

    * The gamma argument to hsv(), rainbow(), and rgb2hsv() is
      deprecated and no longer has any effect.

    * The previous options for R CMD build --binary (--auto-zip,
      --use-zip-data and --no-docs) are deprecated (or defunct): use
      the new option --install-args instead.

    * When a character value is used for the EXPR argument in switch(),
      only a single unnamed alternative value is now allowed.

    * The wrapper utils::link.html.help() is no longer available.

    * Zip-ing data sets in packages (and hence R CMD INSTALL options
      --use-zip-data and --auto-zip, as well as the ZipData: yes field
      in a DESCRIPTION file) is defunct.

      Installed packages with zip-ed data sets can still be used, but a
      warning that they should be re-installed will be given.

    * The 'experimental' alternative specification of a namespace via
      .Export() etc is now defunct.

    * The option --unsafe to R CMD INSTALL is deprecated: use the
      identical option --no-lock instead.

    * The entry point pythag in Rmath.h is deprecated in favour of the
      C99 function hypot.  A wrapper for hypot is provided for R 2.13.x
      only.

    * Direct access to the "source" attribute of functions is
      deprecated; use deparse(fn, control="useSource") to access it,
      and removeSource(fn) to remove it.

    * R CMD build --binary is now formally deprecated: R CMD INSTALL
      --build has long been the preferred alternative.

    * Single-character package names are deprecated (and R is already
      disallowed to avoid confusion in Depends: fields).

  BUG FIXES:

    * drop.terms and the [ method for class "terms" no longer add back
      an intercept.  (Reported by Niels Hansen.)

    * aggregate preserves the class of a column (e.g. a date) under
      some circumstances where it discarded the class previously.

    * p.adjust() now always returns a vector result, as documented.  In
      previous versions it copied attributes (such as dimensions) from
      the p argument: now it only copies names.

    * On PDF and PostScript devices, a line width of zero was recorded
      verbatim and this caused problems for some viewers (a very thin
      line combined with a non-solid line dash pattern could also cause
      a problem).  On these devices, the line width is now limited at
      0.01 and for very thin lines with complex dash patterns the
      device may force the line dash pattern to be solid.  (Reported by
      Jari Oksanen.)

    * The str() method for class "POSIXt" now gives sensible output for
      0-length input.

    * The one- and two-argument complex maths functions failed to warn
      if NAs were generated (as their numeric analogues do).

    * Added .requireCachedGenerics to the dont.mind list for library()
      to avoid warnings about duplicates.

    * $<-.data.frame messed with the class attribute, breaking any S4
      subclass.  The S4 data.frame class now has its own $<- method,
      and turns dispatch on for this primitive.

    * Map() did not look up a character argument f in the correct
      frame, thanks to lazy evaluation.  (PR#14495)

    * file.copy() did not tilde-expand from and to when to was a
      directory.  (PR#14507)

    * It was possible (but very rare) for the loading test in R CMD
      INSTALL to crash a child R process and so leave around a lock
      directory and a partially installed package.  That test is now
      done in a separate process.

    * plot(<formula>, data=<matrix>,..) now works in more cases;
      similarly for points(), lines() and text().

    * edit.default() contained a manual dispatch for matrices (the
      "matrix" class didn't really exist when it was written).  This
      caused an infinite recursion in the no-GUI case and has now been
      removed.

    * data.frame(check.rows = TRUE) sometimes worked when it should
      have detected an error.  (PR#14530)

    * scan(sep= , strip.white=TRUE) sometimes stripped trailing spaces
      from within quoted strings.  (The real bug in PR#14522.)

    * The rank-correlation methods for cor() and cov() with use =
      "complete.obs" computed the ranks before removing missing values,
      whereas the documentation implied incomplete cases were removed
      first.  (PR#14488)

      They also failed for 1-row matrices.

    * The perpendicular adjustment used in placing text and expressions
      in the margins of plots was not scaled by par("mex"). (Part of
      PR#14532.)

    * Quartz Cocoa device now catches any Cocoa exceptions that occur
      during the creation of the device window to prevent crashes.  It
      also imposes a limit of 144 ft^2 on the area used by a window to
      catch user errors (unit misinterpretation) early.

    * The browser (invoked by debug(), browser() or otherwise) would
      display attributes such as "wholeSrcref" that were intended for
      internal use only.

    * R's internal filename completion now properly handles filenames
      with spaces in them even when the readline library is used.  This
      resolves PR#14452 provided the internal filename completion is
      used (e.g., by setting rc.settings(files = TRUE)).

    * Inside uniroot(f, ...), -Inf function values are now replaced by
      a maximally *negative* value.

    * rowsum() could silently over/underflow on integer inputs
      (reported by Bill Dunlap).

    * as.matrix() did not handle "dist" objects with zero rows.

CHANGES IN R VERSION 2.12.2 patched:

  NEW FEATURES:

    * max() and min() work harder to ensure that NA has precedence over
      NaN, so e.g. min(NaN, NA) is NA.  (This was not previously
      documented except for within a single numeric vector, where
      compiler optimizations often defeated the code.)

  BUG FIXES:

    * A change to the C function R_tryEval had broken error messages in
      S4 method selection; the error message is now printed.

    * PDF output with a non-RGB color model used RGB for the line
      stroke color.  (PR#14511)

    * stats4::BIC() assumed without checking that an object of class
      "logLik" has an "nobs" attribute: glm() fits did not and so BIC()
      failed for them.

    * In some circumstances a one-sided mantelhaen.test() reported the
      p-value for the wrong tail.  (PR#14514)

    * Passing the invalid value lty = NULL to axis() sent an invalid
      value to the graphics device, and might cause the device to
      segfault.

    * Sweave() with concordance=TRUE could lead to invalid PDF files;
      Sweave.sty has been updated to avoid this.

    * Non-ASCII characters in the titles of help pages were not
      rendered properly in some locales, and could cause errors or
      warnings.

    * checkRd() gave a spurious error if the \href macro was used.

CHANGES IN R VERSION 2.12.2:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * Complex arithmetic (notably z^n for complex z and integer n) gave
      incorrect results since R 2.10.0 on platforms without C99 complex
      support.  This and some lesser issues in trigonometric functions
      have been corrected.

      Such platforms were rare (we know of Cygwin and FreeBSD).
      However, because of new compiler optimizations in the way complex
      arguments are handled, the same code was selected on x86_64 Linux
      with gcc 4.5.x at the default -O2 optimization (but not at -O).

    * There is a workaround for crashes seen with several packages on
      systems using zlib 1.2.5: see the INSTALLATION section.

  NEW FEATURES:

    * PCRE has been updated to 8.12 (two bug-fix releases since 8.10).

    * rep(), seq(), seq.int() and seq_len() report more often when the
      first element is taken of an argument of incorrect length.

    * The Cocoa back-end for the quartz() graphics device on Mac OS X
      provides a way to disable event loop processing temporarily
      (useful, e.g., for forked instances of R).

    * kernel()'s default for m was not appropriate if coef was a set of
      coefficients.  (Reported by Pierre Chausse.)

    * bug.report() has been updated for the current R bug tracker,
      which does not accept emailed submissions.

    * R CMD check now checks for the correct use of $(LAPACK_LIBS) (as
      well as $(BLAS_LIBS)), since several CRAN recent submissions have
      ignored 'Writing R Extensions'.

  INSTALLATION:

    * The zlib sources in the distribution are now built with all
      symbols remapped: this is intended to avoid problems seen with
      packages such as XML and rggobi which link to zlib.so.1 on
      systems using zlib 1.2.5.

    * The default for FFLAGS and FCFLAGS with gfortran on x86_64 Linux
      has been changed back to -g -O2: however, setting -g -O may still
      be needed for gfortran 4.3.x.

  PACKAGE INSTALLATION:

    * A LazyDataCompression field in the DESCRIPTION file will be used
      to set the value for the --data-compress option of R CMD INSTALL.

    * Files R/sysdata.rda of more than 1Mb are now stored in the
      lazyload database using xz compression: this for example halves
      the installed size of package Imap.

    * R CMD INSTALL now ensures that directories installed from inst
      have search permission for everyone.

      It no longer installs files inst/doc/Rplots.ps and
      inst/doc/Rplots.pdf.  These are almost certainly left-overs from
      Sweave runs, and are often large.

  DEPRECATED & DEFUNCT:

    * The 'experimental' alternative specification of a namespace via
      .Export() etc is now deprecated.

    * zip.file.extract() is now deprecated.

    * Zip-ing data sets in packages (and hence R CMD INSTALL
      --use-zip-data and the ZipData: yes field in a DESCRIPTION file)
      is deprecated: using efficiently compressed .rda images and
      lazy-loading of data has superseded it.

  BUG FIXES:

    * identical() could in rare cases generate a warning about
      non-pairlist attributes on CHARSXPs.  As these are used for
      internal purposes, the attribute check should be skipped.
      (Reported by Niels Richard Hansen).

    * If the filename extension (usually .Rnw) was not included in a
      call to Sweave(), source references would not work properly and
      the keep.source option failed.  (PR#14459)

    * format.data.frame() now keeps zero character column names.

    * pretty(x) no longer raises an error when x contains solely
      non-finite values. (PR#14468)

    * The plot.TukeyHSD() function now uses a line width of 0.5 for its
      reference lines rather than lwd = 0 (which caused problems for
      some PDF and PostScript viewers).

    * The big.mark argument to prettyNum(), format(), etc. was inserted
      reversed if it was more than one character long.

    * R CMD check failed to check the filenames under man for Windows'
      reserved names.

    * The "Date" and "POSIXt" methods for seq() could overshoot when to
      was supplied and by was specified in months or years.

    * The internal method of untar() now restores hard links as file
      copies rather than symbolic links (which did not work for
      cross-directory links).

    * unzip() did not handle zip files which contained filepaths with
      two or more leading directories which were not in the zipfile and
      did not already exist.  (It is unclear if such zipfiles are valid
      and the third-party C code used did not support them, but
      PR#14462 created one.)

    * combn(n, m) now behaves more regularly for the border case m = 0.
      (PR#14473)

    * The rendering of numbers in plotmath expressions (e.g.
      expression(10^2)) used the current settings for conversion to
      strings rather than setting the defaults, and so could be
      affected by what has been done before.  (PR#14477)

    * The methods of napredict() and naresid() for na.action =
      na.exclude fits did not work correctly in the very rare event
      that every case had been omitted in the fit.  (Reported by Simon
      Wood.)

    * weighted.residuals(drop0=TRUE) returned a vector when the
      residuals were a matrix (e.g. those of class "mlm").  (Reported
      by Bill Dunlap.)

    * Package HTML index files <pkg>/html/00Index.html were generated
      with a stylesheet reference that was not correct for static
      browsing in libraries.

    * ccf(na.action = na.pass) was not implemented.

    * The parser accepted some incorrect numeric constants, e.g. 20x2.
      (Reported by Olaf Mersmann.)

    * format(*, zero.print) did not always replace the full zero parts.

    * Fixes for subsetting or subassignment of "raster" objects when
      not both i and j are specified.

    * R CMD INSTALL was not always respecting the ZipData: yes field of
      a DESCRIPTION file (although this is frequently incorrectly
      specified for packages with no data or which specify lazy-loading
      of data).

      R CMD INSTALL --use-zip-data was incorrectly implemented as
      --use-zipdata since R 2.9.0.

    * source(file, echo=TRUE) could fail if the file contained #line
      directives.  It now recovers more gracefully, but may still
      display the wrong line if the directive gives incorrect
      information.

    * atan(1i) returned NaN+Infi (rather than 0+Infi) on platforms
      without C99 complex support.

    * library() failed to cache S4 metadata (unlike loadNamespace())
      causing failures in S4-using packages without a namespace (e.g.
      those using reference classes).

    * The function qlogis(lp, log.p=TRUE) no longer prematurely
      overflows to Inf when exp(lp) is close to 1.

    * Updating S4 methods for a group generic function requires
      resetting the methods tables for the members of the group (patch
      contributed by Martin Morgan).

    * In some circumstances (including for package XML), R CMD INSTALL
      installed version-control directories from source packages.

    * Added PROTECT calls to some constructed expressions used in C
      level eval calls.

    * utils:::create.post() (used by bug.report() and help.request())
      failed to quote arguments to the mailer, and so often failed.

    * bug.report() was naive about how to extract maintainer email
      addresses from package descriptions, so would often try mailing
      to incorrect addresses.

    * debugger() could fail to read the environment of a call to a
      function with a ... argument.  (Reported by Charlie Roosen.)

    * prettyNum(c(1i, NA), drop0=TRUE) or str(NA_complex_) now work
      correctly.

CHANGES IN R VERSION 2.12.1:

  NEW FEATURES:

    * The DVI/PDF reference manual now includes the help pages for all
      the standard packages: splines, stats4 and tcltk were previously
      omitted (intentionally).

    * <URL: http://www.rforge.net> has been added to the default set of
      repositories known to setRepositories().

    * xz-utils has been updated to version 5.0.0.

    * reshape() now makes use of sep when forming names during
      reshaping to wide format.  (PR#14435)

    * legend() allows the length of lines to be set by the end user
      _via_ the new argument seg.len.

    * New S4 reference class utility methods copy(), field(),
      getRefClass() and getClass() have been added to package methods.

    * When a character value is used for the EXPR argument in switch(),
      a warning is given if more than one unnamed alternative value is
      given.  This will become an error in R 2.13.0.

    * StructTS(type = "BSM") now allows series with just two seasons.
      (Reported by Birgit Erni.)

  INSTALLATION:

    * The PDF reference manual is now built as PDF version 1.5 with
      object compression, which on platforms for which this is not the
      default (notably MiKTeX) halves its size.

    * Variable FCLIBS can be set during configuration, for any
      additional library flags needed when linking a shared object with
      the Fortran 9x compiler.  (Needed with Solaris Studio 12.2.)

  BUG FIXES:

    * seq.int() no longer sometimes evaluates arguments twice.
      (PR#14388)

    * The data.frame method of format() failed if a column name was
      longer than 256 bytes (the maximum length allowed for an R name).

    * predict(<lm object>, type ="terms", ...) failed if both terms and
      interval were specified.  (Reported by Bill Dunlap.)

      Also, if se.fit = TRUE the standard errors were reported for all
      terms, not just those selected by a non-null terms.

    * The TRE regular expressions engine could terminate R rather than
      give an error when given certain invalid regular expressions.
      (PR#14398)

    * cmdscale(eig = TRUE) was documented to return n-1 eigenvalues but
      in fact only returned k.  It now returns all n eigenvalues.

      cmdscale(add = TRUE) failed to centre the return configuration
      and sometimes lost the labels on the points.  Its return value
      was described wrongly (it is always a list and contains component
      ac).

    * promptClass() in package methods now works for reference classes
      and gives a suitably specialized skeleton of documentation.

      Also, callSuper() now works via the methods() invocation as well
      as for initially specified methods.

    * download.file() could leave the destination file open if the URL
      was not able to be opened.  (PR#14414)

    * Assignment of an environment to functions or as an attribute to
      other objects now works for S4 subclasses of "environment".

    * Use of [[<- for S4 subclasses of "environment" generated an
      infinite recursion from the method.  The method has been replaced
      by internal code.

    * In a reference class S4 method, callSuper() now works in
      initialize() methods when there is no explicit superclass method.

    * ! dropped attributes such as names and dimensions from a
      length-zero argument.  (PR#14424)

    * When list2env() created an environment it was missing a PROTECT
      call and so was vulnerable to garbage collection.

    * Sweave() with keep.source=TRUE dropped comments at the start and
      end of code chunks.  It could also fail when \SweaveInput was
      combined with named chunks.

    * The Fortran code used by nls(algorithm = "port") could
      infinite-loop when compiled with high optimization on a modern
      version of gcc, and SAFE_FFLAGS is now used to make this less
      likely.  (PR#14427, seen with 32-bit Windows using gcc 4.5.0 used
      from R 2.12.0.)

    * sapply() with default simplify = TRUE and mapply() with default
      SIMPLIFY = TRUE wrongly simplified language-like results, as,
      e.g., in mapply(1:2, c(3,7), FUN = function(i,j) call(':',i,j)).

    * Backreferences to undefined patterns in [g]sub(pcre = TRUE) could
      cause a segfault.  (PR#14431)

    * The format() (and hence the print()) method for class "Date"
      rounded fractional dates towards zero: it now always rounds them
      down.

    * Reference S4 class creation could generate ambiguous inheritance
      patterns under very special circumstances.

    * [[<- turned S4 subclasses of "environment" into plain
      environments.

    * Long titles for help pages were truncated in package indices and
      a few other places.

    * Additional utilities now work correctly with S4 subclasses of
      "environment" (rm, locking tools and active bindings).

    * spec.ar() now also work for the "ols" method.  (Reported by
      Hans-Ruedi Kuensch.)

    * The initialization of objects from S4 subclasses of "environment"
      now allocates a new environment object.

    * R CMD check has more protection against (probably erroneous)
      example or test output which is invalid in the current locale.

    * qr.X() with column names and pivoting now also pivots the column
      names.  (PR#14438)

    * unit.pmax() and unit.pmin() in package grid gave incorrect
      results when all inputs were of length 1.  (PR#14443)

    * The parser for NAMESPACE files ignored misspelled directives,
      rather than signalling an error.  For 2.12.x a warning will be
      issued, but this will be correctly reported as an error in later
      releases. (Reported by Charles Berry.)

    * Fix for subsetting of "raster" objects when only one of i or j is
      specified.

    * grid.raster() in package grid did not accept "nativeRaster"
      objects (like rasterImage() does).

    * Rendering raster images in PDF output was resetting the clipping
      region.

    * Rendering of raster images on cairo X11 device was wrong,
      particularly when a small image was being scaled up using
      interpolation.

      With cairo < 1.6, will be better than before, though still a
      little clunky.  With cairo >= 1.6, should be sweet as.

    * Several bugs fixed in read.DIF(): single column inputs caused
      errors, cells marked as "character" could be converted to other
      types, and (in Windows) copying from the clipboard failed.

CHANGES IN R VERSION 2.12.0:

  NEW FEATURES:

    * Reading a package's CITATION file now defaults to ASCII rather
      than Latin-1: a package with a non-ASCII CITATION file should
      declare an encoding in its DESCRIPTION file and use that encoding
      for the CITATION file.

    * difftime() now defaults to the "tzone" attribute of "POSIXlt"
      objects rather than to the current timezone as set by the default
      for the tz argument.  (Wish of PR#14182.)

    * pretty() is now generic, with new methods for "Date" and "POSIXt"
      classes (based on code contributed by Felix Andrews).

    * unique() and match() are now faster on character vectors where
      all elements are in the global CHARSXP cache and have unmarked
      encoding (ASCII).  Thanks to Matthew Dowle for suggesting
      improvements to the way the hash code is generated in unique.c.

    * The enquote() utility, in use internally, is exported now.

    * .C() and .Fortran() now map non-zero return values (other than
      NA_LOGICAL) for logical vectors to TRUE: it has been an implicit
      assumption that they are treated as true.

    * The print() methods for "glm" and "lm" objects now insert
      linebreaks in long calls in the same way that the print() methods
      for "summary.[g]lm" objects have long done.  This does change the
      layout of the examples for a number of packages, e.g. MASS.
      (PR#14250)

    * constrOptim() can now be used with method "SANN".  (PR#14245)

      It gains an argument hessian to be passed to optim(), which
      allows all the ... arguments to be intended for f() and grad().
      (PR#14071)

    * curve() now allows expr to be an object of mode "expression" as
      well as "call" and "function".

    * The "POSIX[cl]t" methods for Axis() have been replaced by a
      single method for "POSIXt".

      There are no longer separate plot() methods for "POSIX[cl]t" and
      "Date": the default method has been able to handle those classes
      for a long time.  This _inter alia_ allows a single date-time
      object to be supplied, the wish of PR#14016.

      The methods had a different default ("") for xlab.

    * Classes "POSIXct", "POSIXlt" and "difftime" have generators
      .POSIXct(), .POSIXlt() and .difftime().  Package authors are
      advised to make use of them (they are available from R 2.11.0) to
      proof against planned future changes to the classes.

      The ordering of the classes has been changed, so "POSIXt" is now
      the second class.  See the document 'Updating packages for
      changes in R 2.12.x' on <URL: http://developer.r-project.org> for
      the consequences for a handful of CRAN packages.

    * The "POSIXct" method of as.Date() allows a timezone to be
      specified (but still defaults to UTC).

    * New list2env() utility function as an inverse of
      as.list(<environment>) and for fast multi-assign() to existing
      environment.  as.environment() is now generic and uses list2env()
      as list method.

    * There are several small changes to output which 'zap' small
      numbers, e.g. in printing quantiles of residuals in summaries
      from "lm" and "glm" fits, and in test statistics in
      print.anova().

    * Special names such as "dim", "names", etc, are now allowed as
      slot names of S4 classes, with "class" the only remaining
      exception.

    * File .Renviron can have architecture-specific versions such as
      .Renviron.i386 on systems with sub-architectures.

    * installed.packages() has a new argument subarch to filter on
      sub-architecture.

    * The summary() method for packageStatus() now has a separate
      print() method.

    * The default summary() method returns an object inheriting from
      class "summaryDefault" which has a separate print() method that
      calls zapsmall() for numeric/complex values.

    * The startup message now includes the platform and if used,
      sub-architecture: this is useful where different
      (sub-)architectures run on the same OS.

    * The getGraphicsEvent() mechanism now allows multiple windows to
      return graphics events, through the new functions
      setGraphicsEventHandlers(), setGraphicsEventEnv(), and
      getGraphicsEventEnv().  (Currently implemented in the windows()
      and X11() devices.)

    * tools::texi2dvi() gains an index argument, mainly for use by R
      CMD Rd2pdf.

      It avoids the use of texindy by texinfo's texi2dvi >= 1.157,
      since that does not emulate 'makeindex' well enough to avoid
      problems with special characters (such as (, {, !) in indices.

    * The ability of readLines() and scan() to re-encode inputs to
      marked UTF-8 strings on Windows since R 2.7.0 is extended to
      non-UTF-8 locales on other OSes.

    * scan() gains a fileEncoding argument to match read.table().

    * points() and lines() gain "table" methods to match plot().  (Wish
      of PR#10472.)

    * Sys.chmod() allows argument mode to be a vector, recycled along
      paths.

    * There are |, & and xor() methods for classes "octmode" and
      "hexmode", which work bitwise.

    * Environment variables R_DVIPSCMD, R_LATEXCMD, R_MAKEINDEXCMD,
      R_PDFLATEXCMD are no longer used nor set in an R session.  (With
      the move to tools::texi2dvi(), the conventional environment
      variables LATEX, MAKEINDEX and PDFLATEX will be used.
      options("dvipscmd") defaults to the value of DVIPS, then to
      "dvips".)

    * New function isatty() to see if terminal connections are
      redirected.

    * summaryRprof() returns the sampling interval in component
      sample.interval and only returns in by.self data for functions
      with non-zero self times.

    * print(x) and str(x) now indicate if an empty list x is named.

    * install.packages() and remove.packages() with lib unspecified and
      multiple libraries in .libPaths() inform the user of the library
      location used with a message rather than a warning.

    * There is limited support for multiple compressed streams on a
      file: all of [bgx]zfile() allow streams to be appended to an
      existing file, but bzfile() reads only the first stream.

    * Function person() in package utils now uses a given/family scheme
      in preference to first/middle/last, is vectorized to handle an
      arbitrary number of persons, and gains a role argument to specify
      person roles using a controlled vocabulary (the MARC relator
      terms).

    * Package utils adds a new "bibentry" class for representing and
      manipulating bibliographic information in enhanced BibTeX style,
      unifying and enhancing the previously existing mechanisms.

    * A bibstyle() function has been added to the tools package with
      default JSS style for rendering "bibentry" objects, and a
      mechanism for registering other rendering styles.

    * Several aspects of the display of text help are now customizable
      using the new Rd2txt_options() function.
      options("help_text_width") is no longer used.

    * Added \href tag to the Rd format, to allow hyperlinks to URLs
      without displaying the full URL.

    * Added \newcommand and \renewcommand tags to the Rd format, to
      allow user-defined macros.

    * New toRd() generic in the tools package to convert objects to
      fragments of Rd code, and added "fragment" argument to Rd2txt(),
      Rd2HTML(), and Rd2latex() to support it.

    * Directory R_HOME/share/texmf now follows the TDS conventions, so
      can be set as a texmf tree ('root directory' in MiKTeX parlance).

    * S3 generic functions now use correct S4 inheritance when
      dispatching on an S4 object.  See ?Methods, section on "Methods
      for S3 Generic Functions" for recommendations and details.

    * format.pval() gains a ... argument to pass arguments such as
      nsmall to format().  (Wish of PR#9574)

    * legend() supports title.adj.  (Wish of PR#13415)

    * Added support for subsetting "raster" objects, plus assigning to
      a subset, conversion to a matrix (of colour strings), and
      comparisons (== and !=).

    * Added a new parseLatex() function (and related functions
      deparseLatex() and latexToUtf8()) to support conversion of
      bibliographic entries for display in R.

    * Text rendering of \itemize in help uses a Unicode bullet in UTF-8
      and most single-byte Windows locales.

    * Added support for polygons with holes to the graphics engine.
      This is implemented for the pdf(), postscript(),
      x11(type="cairo"), windows(), and quartz() devices (and
      associated raster formats), but not for x11(type="Xlib") or
      xfig() or pictex().  The user-level interface is the polypath()
      function in graphics and grid.path() in grid.

    * File NEWS is now generated at installation with a slightly
      different format: it will be in UTF-8 on platforms using UTF-8,
      and otherwise in ASCII.  There is also a PDF version, NEWS.pdf,
      installed at the top-level of the R distribution.

    * kmeans(x, 1) now works.  Further, kmeans now returns between and
      total sum of squares.

    * arrayInd() and which() gain an argument useNames.  For arrayInd,
      the default is now false, for speed reasons.

    * As is done for closures, the default print method for the formula
      class now displays the associated environment if it is not the
      global environment.

    * A new facility has been added for inserting code into a package
      without re-installing it, to facilitate testing changes which can
      be selectively added and backed out.  See ?insertSource.

    * New function readRenviron to (re-)read files in the format of
      ~/.Renviron and Renviron.site.

    * require() will now return FALSE (and not fail) if loading the
      package or one of its dependencies fails.

    * aperm() now allows argument perm to be a character vector when
      the array has named dimnames (as the results of table() calls
      do).  Similarly, array() allows MARGIN to be a character vector.
      (Based on suggestions of Michael Lachmann.)

    * Package utils now exports and documents functions
      aspell_package_Rd_files() and aspell_package_vignettes() for
      spell checking package Rd files and vignettes using Aspell,
      Ispell or Hunspell.

    * Package news can now be given in Rd format, and news() prefers
      these inst/NEWS.Rd files to old-style plain text NEWS or
      inst/NEWS files.

    * New simple function packageVersion().

    * The PCRE library has been updated to version 8.10.

    * The standard Unix-alike terminal interface declares its name to
      readline as 'R', so that can be used for conditional sections in
      ~/.inputrc files.

    * 'Writing R Extensions' now stresses that the standard sections in
      .Rd files (other than \alias, \keyword and \note) are intended to
      be unique, and the conversion tools now drop duplicates with a
      warning.

      The .Rd conversion tools also warn about an unrecognized type in
      a \docType section.

    * ecdf() objects now have a quantile() method.

    * format() methods for date-time objects now attempt to make use of
      a "tzone" attribute with "%Z" and "%z" formats, but it is not
      always possible.  (Wish of PR#14358.)

    * tools::texi2dvi(file, clean = TRUE) now works in more cases (e.g.
      where emulation is used and when file is not in the current
      directory).

    * New function droplevels() to remove unused factor levels.

    * system(command, intern = TRUE) now gives an error on a Unix-alike
      (as well as on Windows) if command cannot be run.  It reports a
      non-success exit status from running command as a warning.

      On a Unix-alike an attempt is made to return the actual exit
      status of the command in system(intern = FALSE): previously this
      had been system-dependent but on POSIX-compliant systems the
      value return was 256 times the status.

    * system() has a new argument ignore.stdout which can be used to
      (portably) ignore standard output.

    * system(intern = TRUE) and pipe() connections are guaranteed to be
      available on all builds of R.

    * Sys.which() has been altered to return "" if the command is not
      found (even on Solaris).

    * A facility for defining reference-based S4 classes (in the OOP
      style of Java, C++, etc.) has been added experimentally to
      package methods; see ?ReferenceClasses.

    * The predict method for "loess" fits gains an na.action argument
      which defaults to na.pass rather than the previous default of
      na.omit.

      Predictions from "loess" fits are now named from the row names of
      newdata.

    * Parsing errors detected during Sweave() processing will now be
      reported referencing their original location in the source file.

    * New adjustcolor() utility, e.g., for simple translucent color
      schemes.

    * qr() now has a trivial lm method with a simple (fast) validity
      check.

    * An experimental new programming model has been added to package
      methods for reference (OOP-style) classes and methods.  See
      ?ReferenceClasses.

    * bzip2 has been updated to version 1.0.6 (bug-fix release).
      --with-system-bzlib now requires at least version 1.0.6.

    * R now provides jss.cls and jss.bst (the class and bib style file
      for the Journal of Statistical Software) as well as RJournal.bib
      and Rnews.bib, and R CMD ensures that the .bst and .bib files are
      found by BibTeX.

    * Functions using the TAR environment variable no longer quote the
      value when making system calls.  This allows values such as tar
      --force-local, but does require additional quotes in, e.g., TAR =
      "'/path with spaces/mytar'".

  DEPRECATED & DEFUNCT:

    * Supplying the parser with a character string containing both
      octal/hex and Unicode escapes is now an error.

    * File extension .C for C++ code files in packages is now defunct.

    * R CMD check no longer supports configuration files containing
      Perl configuration variables: use the environment variables
      documented in 'R Internals' instead.

    * The save argument of require() now defaults to FALSE and save =
      TRUE is now deprecated.  (This facility is very rarely actually
      used, and was superseded by the Depends field of the DESCRIPTION
      file long ago.)

    * R CMD check --no-latex is deprecated in favour of --no-manual.

    * R CMD Sd2Rd is formally deprecated and will be removed in R
      2.13.0.

  PACKAGE INSTALLATION:

    * install.packages() has a new argument libs_only to optionally
      pass --libs-only to R CMD INSTALL and works analogously for
      Windows binary installs (to add support for 64- or 32-bit
      Windows).

    * When sub-architectures are in use, the installed architectures
      are recorded in the Archs field of the DESCRIPTION file.  There
      is a new default filter, "subarch", in available.packages() to
      make use of this.

      Code is compiled in a copy of the src directory when a package is
      installed for more than one sub-architecture: this avoid problems
      with cleaning the sources between building sub-architectures.

    * R CMD INSTALL --libs-only no longer overrides the setting of
      locking, so a previous version of the package will be restored
      unless --no-lock is specified.

  UTILITIES:

    * R CMD Rprof|build|check are now based on R rather than Perl
      scripts.  The only remaining Perl scripts are the deprecated R
      CMD Sd2Rd and install-info.pl (used only if install-info is not
      found) as well as some maintainer-mode-only scripts.

      *NB:* because these have been completely rewritten, users should
      not expect undocumented details of previous implementations to
      have been duplicated.

      R CMD no longer manipulates the environment variables PERL5LIB
      and PERLLIB.

    * R CMD check has a new argument --extra-arch to confine tests to
      those needed to check an additional sub-architecture.

      Its check for "Subdirectory 'inst' contains no files" is more
      thorough: it looks for files, and warns if there are only empty
      directories.

      Environment variables such as R_LIBS and those used for
      customization can be set for the duration of checking _via_ a
      file ~/.R/check.Renviron (in the format used by .Renviron, and
      with sub-architecture specific versions such as
      ~/.R/check.Renviron.i386 taking precedence).

      There are new options --multiarch to check the package under all
      of the installed sub-architectures and --no-multiarch to confine
      checking to the sub-architecture under which check is invoked.
      If neither option is supplied, a test is done of installed
      sub-architectures and all those which can be run on the current
      OS are used.

      Unless multiple sub-architectures are selected, the install done
      by check for testing purposes is only of the current
      sub-architecture (_via_ R CMD INSTALL --no-multiarch).

      It will skip the check for non-ascii characters in code or data
      if the environment variables _R_CHECK_ASCII_CODE_ or
      _R_CHECK_ASCII_DATA_ are respectively set to FALSE.  (Suggestion
      of Vince Carey.)

    * R CMD build no longer creates an INDEX file (R CMD INSTALL does
      so), and --force removes (rather than overwrites) an existing
      INDEX file.

      It supports a file ~/.R/build.Renviron analogously to check.

      It now runs build-time \Sexpr expressions in help files.

    * R CMD Rd2dvi makes use of tools::texi2dvi() to process the
      package manual.  It is now implemented entirely in R (rather than
      partially as a shell script).

    * R CMD Rprof now uses utils::summaryRprof() rather than Perl.  It
      has new arguments to select one of the tables and to limit the
      number of entries printed.

    * R CMD Sweave now runs R with --vanilla so the environment setting
      of R_LIBS will always be used.

  C-LEVEL FACILITIES:

    * lang5() and lang6() (in addition to pre-existing lang[1-4]())
      convenience functions for easier construction of eval() calls.
      If you have your own definition, do wrap it inside #ifndef lang5
      .... #endif to keep it working with old and new R.

    * Header R.h now includes only the C headers it itself needs, hence
      no longer includes errno.h.  (This helps avoid problems when it
      is included from C++ source files.)

    * Headers Rinternals.h and R_ext/Print.h include the C++ versions
      of stdio.h and stdarg.h respectively if included from a C++
      source file.

  INSTALLATION:

    * A C99 compiler is now required, and more C99 language features
      will be used in the R sources.

    * Tcl/Tk >= 8.4 is now required (increased from 8.3).

    * System functions access, chdir and getcwd are now essential to
      configure R.  (In practice they have been required for some
      time.)

    * make check compares the output of the examples from several of
      the base packages to reference output rather than the previous
      output (if any).  Expect some differences due to differences in
      floating-point computations between platforms.

    * File NEWS is no longer in the sources, but generated as part of
      the installation.  The primary source for changes is now
      doc/NEWS.Rd.

    * The popen system call is now required to build R.  This ensures
      the availability of system(intern = TRUE), pipe() connections and
      printing from postscript().

    * The pkg-config file libR.pc now also works when R is installed
      using a sub-architecture.

    * R has always required a BLAS that conforms to IE60559 arithmetic,
      but after discovery of more real-world problems caused by a BLAS
      that did not, this is tested more thoroughly in this version.

  BUG FIXES:

    * Calls to selectMethod() by default no longer cache inherited
      methods.  This could previously corrupt methods used by as().

    * The densities of non-central chi-squared are now more accurate in
      some cases in the extreme tails, e.g. dchisq(2000, 2, 1000), as a
      series expansion was truncated too early.  (PR#14105)

    * pt() is more accurate in the left tail for ncp large, e.g.
      pt(-1000, 3, 200).  (PR#14069)

    * The default C function (R_binary) for binary ops now sets the S4
      bit in the result if either argument is an S4 object.  (PR#13209)

    * source(echo=TRUE) failed to echo comments that followed the last
      statement in a file.

    * S4 classes that contained one of "matrix", "array" or "ts" and
      also another class now accept superclass objects in new().  Also
      fixes failure to call validObject() for these classes.

    * Conditional inheritance defined by argument test in
      methods::setIs() will no longer be used in S4 method selection
      (caching these methods could give incorrect results).  See
      ?setIs.

    * The signature of an implicit generic is now used by setGeneric()
      when that does not use a definition nor explicitly set a
      signature.

    * A bug in callNextMethod() for some examples with "..." in the
      arguments has been fixed.  See file
      src/library/methods/tests/nextWithDots.R in the sources.

    * match(x, table) (and hence %in%) now treat "POSIXlt" consistently
      with, e.g., "POSIXct".

    * Built-in code dealing with environments (get(), assign(),
      parent.env(), is.environment() and others) now behave
      consistently to recognize S4 subclasses; is.name() also
      recognizes subclasses.

    * The abs.tol control parameter to nlminb() now defaults to 0.0 to
      avoid false declarations of convergence in objective functions
      that may go negative.

    * The standard Unix-alike termination dialog to ask whether to save
      the workspace takes a EOF response as n to avoid problems with a
      damaged terminal connection.  (PR#14332)

    * Added warn.unused argument to hist.default() to allow suppression
      of spurious warnings about graphical parameters used with
      plot=FALSE.  (PR#14341)

    * predict.lm(), summary.lm(), and indeed lm() itself had issues
      with residual DF in zero-weighted cases (the latter two only in
      connection with empty models). (Thanks to Bill Dunlap for
      spotting the predict() case.)

    * aperm() treated resize = NA as resize = TRUE.

    * constrOptim() now has an improved convergence criterion, notably
      for cases where the minimum was (very close to) zero; further,
      other tweaks inspired from code proposals by Ravi Varadhan.

    * Rendering of S3 and S4 methods in man pages has been corrected
      and made consistent across output formats.

    * Simple markup is now allowed in \title sections in .Rd files.

    * The behaviour of as.logical() on factors (to use the levels) was
      lost in R 2.6.0 and has been restored.

    * prompt() did not backquote some default arguments in the \usage
      section.  (Reported by Claudia Beleites.)

    * writeBin() disallows attempts to write 2GB or more in a single
      call. (PR#14362)

    * new() and getClass() will now work if Class is a subclass of
      "classRepresentation" and should also be faster in typical calls.

    * The summary() method for data frames makes a better job of names
      containing characters invalid in the current locale.

    * [[ sub-assignment for factors could create an invalid factor
      (reported by Bill Dunlap).

    * Negate(f) would not evaluate argument f until first use of
      returned function (reported by Olaf Mersmann).

    * quietly=FALSE is now also an optional argument of library(), and
      consequently, quietly is now propagated also for loading
      dependent packages, e.g., in require(*, quietly=TRUE).

    * If the loop variable in a for loop was deleted, it would be
      recreated as a global variable.  (Reported by Radford Neal; the
      fix includes his optimizations as well.)

    * Task callbacks could report the wrong expression when the task
      involved parsing new code. (PR#14368)

    * getNamespaceVersion() failed; this was an accidental change in
      2.11.0. (PR#14374)

    * identical() returned FALSE for external pointer objects even when
      the pointer addresses were the same.

    * L$a@x[] <- val did not duplicate in a case it should have.

    * tempfile() now always gives a random file name (even if the
      directory is specified) when called directly after startup and
      before the R RNG had been used.  (PR#14381)

    * quantile(type=6) behaved inconsistently.  (PR#14383)

    * backSpline(.) behaved incorrectly when the knot sequence was
      decreasing.  (PR#14386)

    * The reference BLAS included in R was assuming that 0*x and x*0
      were always zero (whereas they could be NA or NaN in IEC 60559
      arithmetic).  This was seen in results from tcrossprod, and for
      example that log(0) %*% 0 gave 0.

    * The calculation of whether text was completely outside the device
      region (in which case, you draw nothing) was wrong for screen
      devices (which have [0, 0] at top-left).  The symptom was (long)
      text disappearing when resizing a screen window (to make it
      smaller).  (PR#14391)

    * model.frame(drop.unused.levels = TRUE) did not take into account
      NA values of factors when deciding to drop levels. (PR#14393)

    * library.dynam.unload required an absolute path for libpath.
      (PR#14385)

      Both library() and loadNamespace() now record absolute paths for
      use by searchpaths() and getNamespaceInfo(ns, "path").

    * The self-starting model NLSstClosestX failed if some deviation
      was exactly zero.  (PR#14384)

    * X11(type = "cairo") (and other devices such as png using
      cairographics) and which use Pango font selection now work around
      a bug in Pango when very small fonts (those with sizes between 0
      and 1 in Pango's internal units) are requested.  (PR#14369)

    * Added workaround for the font problem with X11(type = "cairo")
      and similar on Mac OS X whereby italic and bold styles were
      interchanged.  (PR#13463 amongst many other reports.)

    * source(chdir = TRUE) failed to reset the working directory if it
      could not be determined - that is now an error.

    * Fix for crash of example(rasterImage) on x11(type="Xlib").

    * Force Quartz to bring the on-screen display up-to-date
      immediately before the snapshot is taken by grid.cap() in the
      Cocoa implementation. (PR#14260)

    * model.frame had an unstated 500 byte limit on variable names.
      (Example reported by Terry Therneau.)

    * The 256-byte limit on names is now documented.

    * Subassignment by [, [[ or $ on an expression object with value
      NULL coerced the object to a list.

CHANGES IN R VERSION 2.11.1 patched:

  NEW FEATURES:

    * install.packages() has a new optional argument INSTALL_opts which
      can be used to pass options to R CMD INSTALL for source-package
      installs.

    * R CMD check now runs the package-specific tests with LANGUAGE=en
      to facilitate comparison to .Rout.save files.

    * sessionInfo() gives more detailed platform information, including
      32/64-bit and the sub-architecture if one is used.

  DEPRECATED & DEFUNCT:

    * The use of Perl configuration variables for R CMD check (as
      previously documented in 'Writing R Extensions') is deprecated
      and will be removed in R 2.12.0.  Use the environment variables
      documented in 'R Internals' instead.

  BUG FIXES:

    * R CMD Rd2dvi failed if run from a path containing space(s).  This
      also affected R CMD check, which calls Rd2dvi.

    * stripchart() could fail with an empty factor level.  (PR#14317)

    * Text help rendering of \tabular{} has been improved: under some
      circumstances leading blank columns were not rendered.

    * strsplit(x, fixed=TRUE) marked UTF-8 strings with the local
      encoding when no splits were found.

    * weighted.mean(NA, na.rm=TRUE) and similar now returns NaN again,
      as it did prior to R 2.10.0.

    * R CMD had a typo in its detection of whether the environment
      variable TEXINPUTS was set (reported by Martin Morgan).

    * The command-line parser could mistake --file=size... for one of
      the options for setting limits for Ncells or Vcells.

    * The internal strptime() could corrupt its copy of the timezone
      which would then lead to spurious warnings. (PR#14338)

    * dir.create(recursive = TRUE) could fail if one of the components
      existed but was a directory on a read-only file system.  (Seen on
      Solaris, where the error code returned is not even listed as
      possible on the man page.)

    * The postscript() and pdf() devices will now allow lwd values less
      than 1 (they used to force such values to be 1).

    * Fixed font face for CID fonts in pdf() graphics output.
      (PR#14326)

    * GERaster() now checks for width or height of zero and does
      nothing in those cases; previously the behaviour was undefined,
      probably device-specific, and possibly dangerous.

    * wilcox.test(x, y, conf.int = TRUE) failed with an unhelpful
      message if x and y were constant vectors, and similarly in the
      one-sample case.  (PR#14329)

    * Improperly calling Recall() from outside a function could cause a
      segfault.  (Reported by Robert McGehee.)

    * \Sexpr[result=rd] in an Rd file added a spurious newline, which
      was displayed as extra whitespace when rendered.

    * require(save = TRUE) recorded the names of packages it failed to
      load.

    * packageStatus() could return a data frame with duplicate row
      names which could then not be printed.

    * txtProgressBar(style = 2) did not work correctly.

      txtProgressBar(style = 3) did not display until a non-minimum
      value was set.

    * contour() did not display dashed line types properly when contour
      lines were labelled. (Reported by David B. Thompson.)

    * tools::undoc() again detects undocumented data objects.  Of
      course, this also affects R CMD check.

    * ksmooth(x,NULL) no longer segfaults.

    * approxfun(), approx(), splinefun() and spline() could be confused
      by x values that were different but so close as to print
      identically.  (PR#14377)

CHANGES IN R VERSION 2.11.1:

  NEW FEATURES:

    * R CMD INSTALL checks if dependent packages are available early on
      in the installation of source packages, thereby giving clearer
      error messages.

    * R CMD INSTALL --build now names the file in the format used for
      Mac OS X binary files on that platform.

    * BIC() in package stats4 now also works with multiple fitted
      models, analogously to AIC().

  DEPRECATED & DEFUNCT:

    * Use of file extension .C for C++ code in packages is now
      deprecated: it has caused problems for some makes on
      case-insensitive file systems (although it currently works with
      the recommended toolkits).

  INSTALLATION:

    * Command gnutar is preferred to tar when configure sets TAR.  This
      is needed on Mac OS 10.6, where the default tar, bsdtar 2.6.2,
      has been reported to produce archives with illegal extensions to
      tar (according to the POSIX standard).

  BUG FIXES:

    * The C function mkCharLenCE now no longer reads past len bytes
      (unlikely to be a problem except in user code).  (PR#14246)

    * On systems without any default LD_LIBRARY_PATH (not even
      /usr/local/lib), [DY]LIB_LIBRARY_PATH is now set without a
      trailing colon.  (PR#13637)

    * More efficient implementation of utf8ToInt() on long multi-byte
      strings with many multi-byte characters.  (PR#14262)

    * aggregate.ts() gave platform-dependent results due to rounding
      error for ndeltat != 1.

    * package.skeleton() sometimes failed to fix filenames for .R or
      .Rd files to start with an alphanumeric.  (PR#14253)

      It also failed when only an S4 class without any methods was
      defined.  (PR#14280)

    * splinefun(method = "monoH.FC") was not quite monotone in rare
      cases.  (PR#14215)

    * Rhttpd no longer crashes due to SIGPIPE when the client closes
      the connection prematurely.  (PR#14266)

    * format.POSIXlt() could cause a stack overflow and crash when used
      on very long vectors.  (PR#14267)

    * Rd2latex() incorrectly escaped special characters in \usage
      sections.

    * mcnemar.test() could alter the levels (dropping unused levels) if
      passed x and y as factors (reported by Greg Snow).

    * Rd2pdf sometimes needed a further pdflatex pass to get
      hyperlinked pages correct.

    * interaction() produced malformed results when levels were
      duplicated, causing segfaults in split().

    * cut(d, breaks = <n>) now also works for "Date" or "POSIXt"
      argument d.  (PR#14288)

    * memDecompress() could decompress incompletely rare xz-compressed
      input due to incorrect documentation of xz utils.  (Report and
      patch from Olaf Mersmann.)

    * The S4 initialize() methods for "matrix", "array", and "ts" have
      been fixed to call validObject().  (PR#14284)

    * R CMD INSTALL now behaves the same way with or without
      --no-multiarch on platforms with only one installed architecture.
      (It used to clean the src directory without --no-multiarch.)

    * [<-.data.frame was not quite careful enough in assigning (and
      potentially deleting) columns right-to-left.  (PR#14263)

    * rbeta(n, a, b) no longer occasionally returns NaN for a >> 1 > b.
      (PR#14291)

    * pnorm(x, log.p = TRUE) could return NaN not -Inf for x near
      (minus for lower.tail=TRUE) the largest representable number.

    * Compressed data files *.(txt|tab|csv).(gz|bz2|xz) were not
      recognized for the list of data topics and hence for packages
      using LazyData.  (PR#14273)

    * textConnection() did an unnecessary translation on strings in a
      foreign encoding (e.g. UTF-8 strings on Windows) and so was
      slower than it could have been on very long input strings.
      (PR#14286)

    * tools::Rd2txt() did not render poorly written Rd files
      consistently with other renderers.

      It computed widths of strings that would be print()ed with
      escapes incorrectly, for example in the computation of column
      width for \tabular.

    * na.action() did not extract the na.action component as
      documented.

    * do.call()ing NextMethod in erroneous ways no longer segfaults.
      (PR#13487)

CHANGES IN R VERSION 2.11.0:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * Packages must have been installed under R >= 2.10.0, as the
      current help system is the only one now supported.

    * A port to 64-bit Windows is now available as well as binary
      package repositories: see the 'R Administration and Installation
      Manual'.

    * Argument matching for primitive functions is now done in the same
      way as for interpreted functions except for the deliberate
      exceptions

      
      
               call switch .C .Fortran .Call .External
             

      all of which use positional matching for their first argument,
      and also some internal-use-only primitives.

    * The default device for command-line R at the console on Mac OS X
      is now quartz() and not X11().

  NEW FEATURES:

    * The open modes for connections are now interpreted more
      consistently.  open = "r" is now equivalent to open = "rt" for
      all connections.  The default open = "" now means "rt" for all
      connections except the compressed-file connections gzfile(),
      bzfile() and xzfile() for which it means "rb".

    * R CMD INSTALL now uses the internal untar() function in package
      utils: this ensures that all platforms can install bzip2- and
      xz-compressed tarballs.  In case this causes problems (as it has
      on some Windows file systems when run from Cygwin tools) it can
      be overridden by the environment variable R_INSTALL_TAR: setting
      this to a modern external tar program will speed up unpacking of
      large (tens of Mb or more) tarballs.

    * help(try.all.packages = TRUE) is much faster (although the time
      taken by the OS to find all the packages the first time it is
      used can dominate the time).

    * R CMD check has a new option --timings to record per-example
      timings in file <pkg>.Rcheck/<pkg>-Ex.timings.

    * The TRE library has been updated to version 0.8.0 (minor
      bugfixes).

    * grep[l], [g]sub and [g]regexpr now work in bytes in an 8-bit
      locales if there is no marked UTF-8 input string: this will be
      somewhat faster, and for [g]sub() give the result in the native
      encoding rather than in UTF-8 (which returns to the behaviour
      prior to R 2.10.0).

    * A new argument skipCalls has been added to browser() so that it
      can report the original context when called by other debugging
      functions.

    * More validity checking of UTF-8 and MBCS strings is done by
      agrep() and the regular-expression matching functions.

    * The undocumented restriction on gregexpr() to length(text) > 0
      has been removed.

    * Package tcltk now sends strings to Tcl in UTF-8: this means that
      strings with a marked UTF-8 encoding are supported in non-UTF-8
      locales.

    * The graphics engine now supports rendering of raster (bitmap)
      images, though not all graphics devices can provide (full)
      support.  Packages providing graphics devices (e.g., Cairo,
      RSvgDevice, cairoDevice) will need to be reinstalled.

      There is also support in the graphics engine for capturing raster
      images from graphics devices (again not supported on all graphics
      devices).

    * R CMD check now also checks if the package and namespace can be
      unloaded: this provides a check of the .Last.lib() and
      .onUnload() hook functions (unless --install=fake).

    * prop.table(x) now accepts a one-dimensional table for x.

    * A new function vapply() has been added, based on a suggestion
      from Bill Dunlap.  It requires that a template for the function
      value be specified, and uses it to determine the output type and
      to check for consistency in the function values.

    * The main HTML help page now links to a reformatted copy of this
      NEWS file.  (Suggested by Henrik Bengtsson.)  Package index files
      link to the package DESCRIPTION and NEWS files and a list of
      demos when using dynamic help.

    * The [ method for class "AsIs" allows the next method to change
      the underlying class.  (Wish of Jens Oehlschlagel.)

    * write.csv[2] no longer allow argument append to be changed: as
      ever, direct calls to write.table() give more flexibility as well
      as more room for error.

    * The index page for HTML help for a package now collapses multiple
      signatures for S4 methods into a single entry.

    * The use of .required by require() and detach() has been replaced
      by .Depends which is set from the Depends field of a package
      (even in packages with namespaces).  By default detach() prevents
      such dependencies from being detached: this can be overridden by
      the argument force.

    * bquote() has been extended to work on function definitions.
      (Wish of PR#14031).

    * detach() when applied to an object other than a package returns
      the environment that has been detached, to parallel attach().

    * readline() in non-interactive use returns "" and does not attempt
      to read from the 'terminal'.

    * New function file_ext() in package tools.

    * xtfrm() is now primitive and internally generic, as this allows
      S4 methods to be set on it without name-space scoping issues.

      There are now "AsIs" and "difftime" methods, and the default
      method uses unclass(x) if is.numeric(x) is true (which will be
      faster but relies on is.numeric() having been set correctly for
      the class).

    * is.numeric(x) is now false for a "difftime" object
      (multiplication and division make no sense for such objects).

    * The default method of weighted.mean(x, w) coerces w to be numeric
      (aka double); previously only integer weights were coerced.  Zero
      weights are handled specially so an infinite value with zero
      weight does not force an NaN result.

      There is now a "difftime" method.

    * bug.report() now has arguments package and lib.loc to generate
      bug reports about packages.  When this is used, it looks for a
      BugReports field in the package DESCRIPTION file, which will be
      assumed to be a URL at which to submit the report, and otherwise
      generates an email to the package maintainer.  (Suggested by
      Barry Rowlingson.)

    * quantile() now has a method for the date-time class "POSIXt", and
      types 1 and 3 (which never interpolate) work for Dates and
      ordered factors.

    * length(<POSIXlt>) now returns the length of the corresponding
      abstract timedate-vector rather than always 9 (the length of the
      underlying list structure).  (Wish of PR#14073 and PR#10507.)

    * The readline completion backend no longer sorts possible
      completions alphabetically (e.g., function argument names) if R
      was built with readline >= 6.

    * select.list() gains a graphics argument to allow Windows/Mac
      users to choose the text interface.  This changes the behaviour
      of new.packages(ask=TRUE) to be like update.packages(ask=TRUE) on
      those platforms in using a text menu: use ask="graphics" for a
      graphical menu.

    * New function chooseBioCmirror() to set the "BioC_mirror" option.

    * The R grammar now prevents using the argument name in signatures
      of S4 methods for $ and $<-, since they will always be called
      with a character string value for name.  The implicit S4 generic
      functions have been changed to reflect this: packages which
      included name in the signature of their methods need to be
      updated and re-installed.

    * The handling of the method argument of glm() has been refined
      following suggestions by Ioannis Kosmidis and Heather Turner.

    * str() gains a new argument list.len with default 99, limiting the
      number of list() items (per level), thanks to suggestions from
      David Winsenius.

    * Having formal arguments of an S4 method in a different order from
      the generic is now an error (the warning having been ignored by
      some package maintainers for a long time).

    * New functions enc2native() and enc2utf8() convert character
      vectors with possibly marked encodings to the current locale and
      UTF-8 respectively.

    * Unrecognized escapes and embedded nuls in character strings are
      now an error, not just a warning.  Thus option "warnEscapes" is
      no longer needed.  rawToChar() now removes trailing nuls
      silently, but other embedded nuls become errors.

    * Informational messages about masked objects displayed when a
      package is attached are now more compact, using strwrap() instead
      of one object per line.

    * print.rle() gains argument prefix.

    * download.file() gains a "curl" method, mainly for use on
      platforms which have curl but not wget, but also for some
      hard-to-access URLs.

    * In Rd, \eqn and \deqn will render in HTML (and convert to text)
      upper- and lower-case Greek letters (entered as \alpha ...),
      \ldots, ..., \ge and \le.

    * utf8ToInt() and intToUtf8() now map NA inputs to NA outputs.

    * file() has a new argument raw which may help if it is used with
      something other than a regular file, e.g. a character device.

    * New function strtoi(), a wrapper for the C function strtol.

    * as.octmode() and as.hexmode() now allow inputs of length other
      than one.

      The format() and print() methods for "octmode" now preserve names
      and dimensions (as those for "hexmode" did).

      The format() methods for classes "octmode" and "hexmode" gain a
      width argument.

    * seq.int() returns an integer result in some further cases where
      seq() does, e.g. seq.int(1L, 9L, by = 2L).

    * Added \subsection{}{} macro to Rd syntax, for subsections within
      sections.

    * n-dimensional arrays with dimension names can now be indexed by
      an n-column character matrix.  The indices are matched against
      the dimension names.  NA indices are propagated to the result.
      Unmatched values and "" are not allowed and result in an error.

    * interaction(drop=TRUE) uses less memory (related to PR#14121).

    * summary() methods have been added to the "srcref" and "srcfile"
      classes, and various encoding issues have been cleaned up.

    * If option "checkPackageLicense" is set to TRUE (not currently the
      default), users will be asked to agree to non-known-to-be-FOSS
      package licences at first use.

    * Checking setAs(a, b) methods only gives a message instead of a
      warning, when one of a or b is unknown.

    * New function norm() to compute a matrix norm.  norm() and also
      backsolve() and sample() have implicit S4 generics.

    * Files Renviron.site and Rprofile.site can have
      architecture-specific versions on systems with sub-architectures.

    * R CMD check now (by default) also checks Rd files for
      auto-generated content in need of editing, and missing argument
      descriptions.

    * aggregate() gains a formula method thanks to a contribution by
      Arni Magnusson.  The data frame method now allows summary
      functions to return arbitrarily many values.

    * path.expand() now propagates NA values rather than converting
      them to "NA".

    * file.show() now disallows NA values for file names, headers, and
      pager.

    * The 'fuzz' used by seq() and seq.int() has been reduced from 1e-7
      to 1e-10, which should be ample for the double-precision
      calculations used in R.  It ensures that the fuzz never comes
      into play with sequences of integers (wish of PR#14169).

    * The default value of RSiteSearch(restrict=) has been changed to
      include vignettes but to exclude R-help.  The R-help archives
      available have been split, with a new option of "Rhelp10" for
      those from 2010.

    * New function rasterImage() in the graphics package for drawing
      raster images.

    * stats:::extractAIC.coxph() now omits aliased terms when computing
      the degrees of freedom (suggestion of Terry Therneau).

    * cor() and cov() now test for misuse with non-numeric arguments,
      such as the non-bug report PR#14207.

    * pchisq(ncp =, log.p = TRUE) is more accurate for probabilities
      near one.  E.g. pchisq(80, 4, ncp=1, log.p=TRUE).  (Maybe what
      was meant in PR#14216.)

    * maintainer() has been added, to give convenient access to the
      name of the maintainer of a package (contributed by David Scott).

    * sample() and sample.int() allow zero items to be sampled from a
      zero-length input.  sample.int() gains a default value size=n to
      be more similar to sample().

    * switch() returned NULL on error (not previously documented on the
      help page): it now does so invisibly, analogously to
      if-without-else.

      It is now primitive: this means that argument EXPR is always
      matched to the first argument and there is no danger of partial
      matching to later named arguments.

    * Primitive functions UseMethod(), attr(), attr<-(), on.exit(),
      retracemem() and substitute() now use standard argument matching
      (rather than positional matching).  This means that all
      multi-argument primitives which are not internal now use standard
      argument matching except where positional matching is desirable
      (as for switch(), call(), .C() ...).

    * All the one-argument primitives now check that any name supplied
      for their first argument is a partial match to the argument name
      as documented on the help page: this also applies to replacement
      functions of two arguments.

    * base::which() uses a new .Internal function when arr.ind is FALSE
      resulting in a 10x speedup.  Thanks to Patrick Aboyoun for
      implementation suggestions.

    * Help conversion to text now uses the first part of \enc{}{}
      markup if it is representable in the current output encoding.  On
      the other hand, conversion to LaTeX with the default
      outputEncoding = "ASCII" uses the second part.

    * A new class "listOfMethods" has been introduced to represent the
      methods in a methods table, to replace the deprecated class
      "MethodsList".

    * any() and all() return early if possible.  This may speed up
      operations on long vectors.

    * strptime() now accepts "%z" (for the offset from UTC in the
      RFC822 format of +/-hhmm).

    * The PCRE library has been updated to version 8.02, a bug-fix
      release which also updates tables to Unicode 5.02.

    * Functions which may use a graphical select.list() (including
      menu() and install.packages()) now check on a Unix-alike that Tk
      can be started (and not just capabilities("tcltk") &&
      capabilities("X11")).

    * The parser no longer marks strings containing octal or hex
      escapes as being in UTF-8 when entered in a UTF-8 locale.

    * On platforms with cairo but not Pango (notably Mac OS X) the
      initial default X11() type is set to "Xlib": this avoids several
      problems with font selection when done by cairo rather than Pango
      (at least on Mac OS X).

    * New function arrayInd() such that which(x, arr.ind = TRUE) for an
      array 'x' is now equivalent to arrayInd(which(x), dim(x),
      dimnames(x)).

  DEPRECATED & DEFUNCT:

    * Bundles of packages are defunct.

    * stats::clearNames() is defunct: use unname().

    * Basic regular expressions are defunct, and strsplit(), grep(),
      grepl(), sub(), gsub(), regexpr() and gregexpr() no longer have
      an extended argument.

    * methods::trySilent() is defunct.

    * index.search() (which was deprecated in 2.10.0) is no longer
      exported and has a different argument list.

    * Use of multiple arguments to return() is now defunct.

    * The use of UseMethod() with more than two arguments is now
      defunct.

    * In the methods package, the "MethodsList" metadata objects which
      had been superseded by hash tables (environments) since R 2.8.0
      are being phased out.  Objects of this class are no longer
      assigned or used as metadata by the package.

      getMethods() is now deprecated, with its internal use replaced by
      findMethods() and other changes.  Creating objects from the
      "MethodsList" class is also deprecated.

    * Parsing strings containing both octal/hex and Unicode escapes now
      gives a warning and will become an error in R 2.12.0.

  INSTALLATION:

    * UTF-8 is now used for the reference manual and package manuals.
      This requires LaTeX '2005/12/01' or later.

    * configure looks for a POSIX compliant tr, Solaris's /usr/ucb/tr
      having been found to cause Rdiff to malfunction.

    * configure is now generated with autoconf 2.65, which works better
      on recent systems and on Mac OS X.

  PACKAGE INSTALLATION:

    * Characters in R source which are not translatable to the current
      locale are now handled more tolerantly: these will be converted
      to hex codes with a warning.  Such characters are only really
      portable if they appear in comments.

    * R CMD INSTALL now tests that the installed package can be loaded
      (and backs out the installation if it cannot): this can be
      suppressed by --no-test-load.  This avoids installing/updating a
      package that cannot be used: common causes of failures to load
      are missing/incompatible external software and missing/broken
      dependent packages.

    * Package installation on Windows for a package with a src
      directory now checks if a DLL is created unless there is a
      src/Makefile.win file: this helps catch broken installations
      where the toolchain has not reported problems in building the
      DLL.  (Note: this can be any DLL, not just one named
      <pkg-name>.dll.)

  BUG FIXES:

    * Using with(), eval() etc with a list with some unnamed elements
      now works.  (PR#14035)

    * The "quick" dispatch of S4 methods for primitive functions was
      not happening, forcing a search each time.  (Dispatch for
      closures was not affected.)  A side effect is that default values
      for arguments in a method that do not have defaults in the
      generic will now be ignored.

    * Trying to dispatch S4 methods for primitives during the search
      for inherited methods slows that search down and potentially
      could cause an infinite recursion.  An internal switch was added
      to turn off all such methods from findInheritedMethods().

    * R framework installation (on Mac OS X) would not work properly if
      a rogue Resources directory was present at the top level.  Such a
      non-symlink will now be renamed to Resources.old (and anything
      previously named Resources.old removed) as part of the framework
      installation process.

    * The checks for conforming S4 method arguments could fail when the
      signature of the generic function omitted some of the formal
      arguments (in addition to ...).  Arguments omitted from the
      method definition but conforming (per the documentation) should
      now be ignored (treated as "ANY") in dispatching.

    * The computations for S4 method evaluation when ...  was in the
      signature could fail, treating ... as an ordinary symbol.  This
      has been fixed, for the known cases.

    * Various ar() fitting methods have more protection for singular
      fits.

    * callNextMethod now works again with the drop= argument in [

    * parse() and parse_Rd() miscounted columns when multibyte UTF-8
      characters were present.

    * Formatting of help pages has had minor improvements: extra blank
      lines have been removed from the text format, and empty package
      labels removed from HTML.

    * cor(A, B) where A is n x 1 and B a 1-dimensional array segfaulted
      or gave an internal error.  (The case cor(B, A) was PR#7116.)

    * cut.POSIXt() applied to a start value after the DST transition on
      a DST-change day could give the wrong time for argument breaks in
      units of days or longer.  (PR#14208)

    * do_par() UNPROTECTed too early (PR#14214)

    * Subassignment x[[....]] <- y didn't check for a zero-length right
      hand side, and inserted a rubbish value.  (PR#14217)

    * fisher.test() no longer gives a P-value *very* slightly > 1, in
      some borderline cases.

    * Internal function matchArgs() no longer modifies the general
      purpose bits of the SEXPs that make up the formals list of R
      functions.  This fixes an invalid error message that would occur
      when a garbage collection triggered a second call to matchArgs
      for the same function _via_ a finalizer.

    * gsub() in 2.10.x could fail from stack overflow for extremely
      long strings due to temporary data being allocated on the stack.
      Also, gsub() with fixed=TRUE is in some circumstances
      considerably faster.

    * Several primitives, including attributes(), attr<-()
      interactive(), nargs() and proc.time(), did not check that they
      were called with the correct number of arguments.

    * A potential race condition in list.files() when other processes
      are operating on the directory has been fixed; the code now
      dynamically allocates memory for file listings in a single pass
      instead of making an initial count pass.

    * mean(x, trim=, na.rm = FALSE) failed to return NA if x contained
      missing values.  (Reported by Bill Dunlap.)

    * Extreme tail behavior of, pbeta() {and hence pf()}, e.g.,
      pbeta(x, 3, 2200, lower.tail=FALSE, log.p=TRUE) now returns
      finite values instead of jumping to -Inf too early.  (PR#14230).

    * parse(text=x) misbehaved for objects x that were not coerced
      internally to character, notably symbols.  (Reported to R-devel
      by Bill Dunlap.)

    * The internal C function coerceSymbol now handles coercion to
      character, and warns if coercion fails (rather than silently
      returning NULL).  This allows a name to be given where a
      character vector is required in functions which coerce
      internally.

    * The interpretation by strptime() of "%c" was non-standard (not
      that it is ever advisable to use locale- and system-specific
      input formats).

    * capabilities("X11") now works the same way on Mac OS X as on
      other platforms (and as documented: it was always true for R
      built with --with-aqua, as the CRAN builds are).

    * The X11() device with cairo but not Pango (notably Mac OS X) now
      checks validity of text strings in UTF-8 locales (since Pango
      does but cairo it seems does not).

    * read.fwf() misread multi-line records when n was specified.
      (PR#14241)

    * all.equal(tolerance = e) passes the numeric tolerance also to the
      comparison of the attributes.

    * pgamma(0, 0), a boundary case, now returns 0, its limit from the
      left, rather than the limit from the right.

    * Issuing POST requests to the internal web server could stall the
      request under certain circumstances.

    * gzcon( <textConnection> ), an error, no longer damages the
      connection (in a way to have it segfault).  (PR#14237)

    * All the results from hist() now use the nominal breaks not those
      adjusted by the numeric 'fuzz': in recent versions the nominal
      breaks were reported but the 'density' referred to the intervals
      used in the calculation - which mattered very slightly for one of
      the extreme bins.  (Based on a report by Martin Becker.)

    * If xy[z].coords (used internally by many graphics functions) are
      given a list as x, they now check that the list has suitable
      names and give a more informative error message.  (PR#13936)

CHANGES IN R VERSION 2.10.1 patched:

  NEW FEATURES:

    * The handling of line textures in the postscript() and pdf()
      devices was set up for round end caps (the only type which
      existed at the time): it has now been adjusted for butt endcaps.

    * lchoose(a, k) is now defined as log(abs(choose(a,k))),
      analogously to lfactorial().

    * Although \eqn{} in Rd files is defined as a 'verbatim' macro,
      many packages expected ... and \ldots to be interpreted there (as
      was the case in R < 2.10.0), so this is now done (using an
      ellipsis in HTML rendering).

    * Escaping of braces in quoted strings in R-code sections of Rd
      files is allowed again.  This had been changed for the new Rd
      format in R 2.10.0 but was only documented on the developer site
      and was handled inconsistently by the converters: text and
      example conversion removed the escapes but HTML conversion did
      not.

    * The PCRE library has been updated to version 8.01, a bug-fix
      release.

    * tools::readNEWS() now accepts a digit as the first character of a
      news section.

  BUG FIXES:

    * Using read.table(header=TRUE) on a header with an embedded new
      line would copy part of the header into the data.  (PR#14103)

    * qpois(p = 1, lambda = 0) now gives 0 as for all other p.
      (PR#14135)

    * Functions related to string comparison (e.g. unique(), match())
      could cause crashes when used with strings not in the native
      encoding, e.g. UTF-8 strings on Windows.  (PR#14114 and PR#14125)

    * x[ , drop=TRUE] dropped an NA level even if it was in use.

    * The dynamic HTML help system reported the wrong MIME type for the
      style sheet.

    * tools::codoc() (used by R CMD check) was missing cases where the
      function had no arguments but was documented to have some.

    * Help links containing special characters (e.g. "?") were not
      generated correctly when rendered in HTML.  (PR#14155)

    * lchoose(a, k) no longer wrongly gives NaN for negative a.

    * ks.test() could give a p-value that was off by one observation
      due to rounding error.  (PR#14145)

    * readBin()/readChar() when reading millions of character strings
      in a single call used excessive amounts of memory (which also
      slowed them down).

    * R CMD SHLIB could fail if used with paths that were not
      alphanumeric, e.g. contained +.  (PR#14168)

    * sprintf() was not re-entrant, which potentially caused problems
      if an as.character() method called it.

    * The quartz() device did not restore the clipping region when
      filling the background for a new page.  This could be observed in
      multi-page bitmap output as stale outer regions of the plot.

    * p.adjust(method, n) now works correctly for the rare case n >
      length(p), also when method differs from "bonferroni" or "none",
      thanks to a patch from Gordon Smyth.

    * tools::showNonASCII() failed to detect non-ASCII characters if
      iconv() (incorrectly) converted them to different ASCII
      characters.  (Seen on Windows only.)

    * tcrossprod() wrongly failed in some cases when one of the
      arguments was a vector and the other a matrix.

    * [cr]bind(..., deparse.level=2) was not always giving names when
      documented to do so.  (Discovered whilst investigating PR#14189.)

    * match(incomparables=<non-NULL>) could in rare cases
      infinite-loop.

    * poisson.test() needed to pass argument conf.level to
      binom.test().  (PR#14195)

    * The "nls" method for df.residual() gave incorrect results for
      models fitted with na.action = na.exclude.  (PR#14194)

    * A change to options(scipen=) was only implemented when printing
      next occurred, even though it should have affected intervening
      calls to axis(), contour() and filledcontour().

    * prettyNum(drop0trailing=TRUE) did not handle signs of imaginary
      parts of complex numbers correctly (and this was used by str():
      PR#14201).

    * system.time() had the sys.child component wrong (copied
      user.child instead) on systems with HAVE_GETRUSAGE.  (PR#14210)

    * Changing both line texture and line cap (end) resulted in the
      latter to be omitted form the PDF code.  In addition, line cap
      (end) and join are now set explicitly in PDF output to ensure
      correct defaults.

    * The suppression of auto-rotation in bitmap() and dev2bitmap()
      with the "pdfwrite" device was not working correctly.

    * plot(ecdf(), log="x") no longer gives an incorrect warning.

    * read.fwf() works again when argument file is a connection.

    * Startup files will now be found if their paths exceed 255 bytes.
      (PR#14228)

    * contrasts<- (in the stats package) no longer has an undeclared
      dependence on methods (introduced in 2.10.0).

CHANGES IN R VERSION 2.10.1:

  NEW FEATURES:

    * The PCRE library has been updated to version 8.00.

    * R CMD INSTALL has new options --no-R, --no-libs, --no-data,
      --no-help, --no-demo, --no-exec, and --no-inst to suppress
      installation of the specified part of the package.  These are
      intended for special purposes (e.g. building a database of help
      pages without fully installing all packages).

    * The documented line-length limit of 4095 bytes when reading from
      the console now also applies also to parse(file="") (which
      previously had a limit of around 1024 bytes).

    * A Bioconductor mirror can be set for use by setRepositories()
      _via_ the option "BioC_mirror", e.g. the European mirror can be
      selected by
      options(BioC_mirror="http://bioconductor.statistik.tu-dortmund.de").

    * Double-clicking in a tk_select.list() list box now selects the
      item and closes the list box (as happens on the Windows
      select.list() widget).

  INSTALLATION:

    * configure will be able to find a usable libtiff in some rare
      circumstances where it did not previously (where libtiff needed
      to be linked explicitly against -ljpeg).

    * Making refman.pdf works around a problem with the indexing with
      hyperref 6.79d and later.

  DEPRECATED & DEFUNCT:

    * The extended argument is deprecated in strsplit(), grep(),
      grepl(), sub(), gsub(), regexpr() and gregexpr() (not just the
      value extended = FALSE) and will be removed in R 2.11.0.

  BUG FIXES:

    * trigamma(x) and other psigamma(x, n) calls are now accurate for
      very large abs(x).  (PR#14020)

    * [g]sub(perl=FALSE, fixed=FALSE) could use excessive stack space
      when used with a very long vector containing some non-ASCII
      strings.

    * The default method of weighted.mean(na.rm = TRUE) did not omit
      weights for NA observations in 2.10.0.  (PR#14032)

    * [g]regexpr(pattern, fixed = TRUE) returned match positions in
      bytes (not characters) in an MBCS locale if pattern was a single
      byte.

      [g]sub(fixed = TRUE) with a single-byte pattern could conceivably
      have matched part of a multibyte character in a non-UTF-8 MBCS.

    * findLineNum() and setBreakpoint() would sometimes fail if the
      specified file was not in the current directory.

    * Package tcltk's demo(tkdensity) was broken in 2.9.0 when demo()
      was changed to set par(ask = TRUE).

    * gsub() with backrefs could fail on extremely long strings
      (hundreds of thousands of characters) due to integer overflow in
      a length calculation.

    * abline(untf=TRUE) now uses a better x-grid in log-scale, e.g.,
      for plot(c(1,300), c(1,300), log="xy"); abline(4,1, untf=TRUE).

    * detach()/unloadNamespace() arrange to flush the package's
      lazyload cache of R objects once the package/namespace is no
      longer needed.

    * There have been small fixes to the rendering of help, e.g.
      \command is now rendered verbatim (so e.g. -- is not interpreted,
      PR#14045).

      Also, there are many small changes to help files where the new
      converters were not rendering them in the same way as before.

    * available.packages() would fail when run on a repository with no
      packages meeting the filtering conditions.  (PR#14042)

    * rep(x, times, each = 2) gave invalid results when the times
      argument was a vector longer than x.  Reported by Bill Dunlap.

    * An error when unloadNamespace() attempted to run the .onUnload()
      function gave an error in the reporting function and so was not
      reported properly.

    * Text help rendering did not handle very long input lines
      properly.

    * promptMethods() generated signature documentation improperly.

    * pgamma(x, a, lower.tail=FALSE) and qgamma(...) are now
      considerably more accurate in some regions for very small a.
      qgamma() now correctly returns 0 instead of NaN in similar
      extreme cases, and qgamma() no longer warns in the case of small
      a, see (PR#12324).

    * unname() now also removes names from a zero length vector.

    * Printing results from ls.str() no longer evaluates unevaluated
      calls.

    * complete.cases() failed on a 0-column data frame argument.
      (Underlies PR#14066.)

      It could return nonsensical results if no input determined the
      number of cases (seen in the no-segfault tests).

    * An error in nls() with a long formula could cause a segfault.
      (PR#14059)

    * qchisq(p, df, ncp, lower.tail = FALSE) with ncp >= 80 was
      inaccurate for small p (as the help page said): it is now less
      inaccurate.  (In part, PR#13999.)

      For ncp less than but close to 80, pchisq() and qchisq() are more
      accurate for probabilities very close to 1 (a series expansion
      was truncated slightly too early).

      pchisq(x, df, ncp) can no longer return values just larger than
      one for large values of ncp.

    * intToUtf8() could fail when asked to produce 10Mb or more
      strings, something it was never intended to do: unfortunately
      Windows crashed R (other OSes reported a lack of resources).
      (PR#14068)

    * chisq.test() could fail when given argument x or y which deparsed
      to more than one line.  (Reported by Laurent Gauthier.)

    * S4 methods are uncached whenever the namespace containing them is
      unloaded (by unloadNamespace() as well as by detach(unload =
      TRUE)).

    * The internal record-keeping by dyn.load/dyn.unload was
      incomplete, which could crash R if a DLL that registered
      .External routines had earlier been unloaded.

    * bessel[JY](x, nu) with nu a negative integer (a singular case) is
      now correct, analogously to besselI(), see PR#13556.

    * tools::file_path_as_absolute() doubled the file separator when
      applied to a file such as "/vmunix" or (on Windows) "d:/afile" in
      a directory for which getwd() would return a path with a trailing
      separator (largely cosmetic, as reasonable file systems handle
      such a path correctly).  (Perhaps what was meant by PR#14078.)

    * unsplit(drop = TRUE) applied to a data frame failed to pass drop
      to the computation of row names.  (PR#14084)

    * The "difftime" method of mean() ignored its na.rm argument.

    * tcltk::tk_select.list() is now more likely to remove the widget
      immediately after selection is complete.

    * Adding/subtracting a "difftime" object to/from a "POSIXt" or
      "Date" object works again (it was broken by the addition of
      Ops.difftime).

    * Conversion to latex of an Rd file with no aliases failed.

    * wilcox.test(conf.int=TRUE) has achieved.level corrected and, for
      exact=FALSE, now returns a estimate component which does not
      depend on the alternative used.

    * help.search() failed when the package argument was specified.
      (PR#14113)

    * switch(EXPR = "A") now returns NULL, as does switch(1) (which
      used to signal an error).

CHANGES IN R VERSION 2.10.0:

  SIGNIFICANT USER-VISIBLE CHANGES:

    * Package help is now converted from Rd by the R-based converters
      that were first introduced in 2.9.0.  This means

        * Packages that were installed by R-devel after 2009-08-09
          should not be used with earlier versions of R, and most
          aspects of package help (including the runnable examples)
          will be missing if they are so used.

        * Text, HTML and latex help and examples for packages installed
          under the new system are converted on-demand from stored
          parsed Rd files.  (Conversions stored in packages installed
          under R < 2.10.0 are used if no parsed Rd files are found.
          It is recommended that such packages be re-installed.)

    * HTML help is now generated dynamically using an HTTP server
      running in the R process and listening on the loopback interface.

        * Those worried about security implications of such a server
          can disable it by setting the environment variable
          R_DISABLE_HTTPD to a non-empty value.  This disables
          help.start() and HTML help (so text help is shown instead).

        * The Java/Javascript search engine has been replaced by an
          HTML interface to help.search().  help.start() no longer has
          an argument searchEngine as it is no longer needed.

        * The HTML help can now locate cross-references of the form
          \link[pkg]{foo} and \link[pkg:foo]{bar} where foo is an alias
          in the package, rather than the documented (basename of a)
          filename (since the documentation has been much ignored).

  NEW FEATURES:

    * polygon(), pdf() and postscript() now have an argument
      fillOddEven (default FALSE), which controls the mode used for
      polygon fills of self-intersecting shapes.

    * New debugonce() function; further, getOption("deparse.max.lines")
      is now observed when debugging, from a code suggestion by John
      Brzustowski.  (PR#13647/8)

    * plot() methods for "stepfun" and hence "ecdf" no longer plot
      points by default for n >= 1000.

    * [g]sub(perl=TRUE) now also supports "\E" in order to *end* "\U"
      and "\L" case changes, thanks to a patch from Bill Dunlap.

    * factor(), levels()<-, etc, now ensure that the resulting factor
      levels are unique (as was always the implied intention).  Factors
      with duplicated levels are still constructible by low-level
      means, but are now declared illegal.

    * New print() (S3) method for class "function", also used for
      auto-printing.  Further, .Primitive functions now print and
      auto-print identically.  The new method is based on code
      suggestions by Romain Francois.

    * The print() and toLatex() methods for class "sessionInfo" now
      show the locale in a nicer format and have arguments to suppress
      locale information.

    * In addition to previously only round(), there are other Math
      group (S3) methods for "difftime", such as floor(), signif(),
      abs(), etc.

    * For completeness, old.packages() and available.packages() allow
      arguments type to be specified (you could always specify
      arguments available or contriburl).

    * available.packages() by default only returns information on the
      latest versions of packages whose version requirements are
      satisfied by the currently running R.

    * tools::write_PACKAGES() has a new argument latestOnly, which
      defaults to TRUE when only the latest versions in the repository
      will be listed in the index.

    * getOption() has a new argument default that is returned if the
      specified option is not set.  This simplifies querying a value
      and checking whether it is NULL or not.

    * parse() now warns if the requested encoding is not supported.

    * The "table" method of as.data.frame() gains a stringsAsFactors
      argument to allow the classifying factors to be returned as
      character vectors rather than the default factor type.

    * If model.frame.default() encounters a character variable where
      xlev indicates a factor, it now converts the variable to a factor
      (with a warning).

    * curve() now returns a list containing the points that w?ere
      drawn.

    * spineplot() now accepts axes = FALSE, for consistency with other
      functions called by plot.factor().

    * The Kendall and Spearman methods of cor.test() can optionally use
      continuity correction when not computing exact p-values.  (The
      Kendall case is the wish of PR#13691.)

    * R now keeps track of line numbers during execution for code
      sourced with options(keep.source = TRUE).  The source reference
      is displayed by debugging functions such as traceback(),
      browser(), recover(), and dump.frames(), and is stored as an
      attribute on each element returned by sys.calls().

    * More functions now have an implicit (S4) generic definition.

    * quantile.default() now disallows factors (wish of PR#13631) and
      its help documents what numeric-like properties its input need to
      have to work correctly.

    * weighted.mean() is now generic and has "Date", "POSIXct" and
      "POSIXlt" methods.

    * Naming subscripts (e.g. x[i=1, j=2]) in data.frame methods for [
      and [[ now gives a warning.  (Names are ignored in the default
      method, but could have odd semantics for other methods, and do
      for the data.frame ones.)

    * as.data.frame() has an "aovproj" method.  (Wish of PR#13505)

    * as.character(x) for numeric x no longer produces strings such as
      "0.30", i.e., with trailing zeros.  This change also renders
      levels construction in factor() more consistent.

    * codocClasses(), which checks consistency of the documentation of
      S4 class slots, now does so in considerably more cases.  The
      documentation of inherited slots (from superclasses) is now
      optional.  This affects R CMD check <pkg> when the package
      defines S4 classes.

    * codoc() now also checks S4 methods for code/documentation
      mismatches.

    * for(), while(), and repeat() loops now always return NULL as
      their (invisible) value.  This change was needed to address a
      reference counting bug without creating performance penalties for
      some common use cases.

    * The print() method for ls.str() results now obeys an optional
      digits argument.

    * The method argument of glm() now allows user-contributed methods.

    * More general reorder.default() replaces functionality of
      reorder.factor() and reorder.character().

    * The function aspell() has been added to provide an interface to
      the Aspell spell-checker.

    * Filters RdTextFilter() and SweaveTeXFilter() have been added to
      the tools package to provide support for aspell() or other spell
      checkers.

    * xtabs() with the new argument sparse = TRUE now returns a sparse
      Matrix, using package Matrix.

    * contr.sum() etc gain an argument sparse which allows sparse
      matrices to be returned.

      contrasts() also gains a sparse argument which it passes to the
      actual contrast function if that has a formal argument sparse.

      contrasts(f, .) <- val now also works when val is a sparse
      Matrix.  It is planned that model.matrix() will work with such
      factors f in the future.

    * readNEWS() will recognize a UTF-8 byte-order mark (BOM) in the
      NEWS file.  However, it is safer to use only ASCII code there
      because not all editors recognize BOMs.

    * New utility function inheritedSlotNames() for S4 class
      programming.

    * tabulate() now allows NAs to pass through (and be ignored).

    * If debug() is called on an S3 generic function then all methods
      are debugged as well.

    * Outlier symbols drawn by boxplot() now obey the outlwd argument.
      Reported by Jurgen Kluge.

    * svd(x) and eigen(x) now behave analogously to qr(x) in accepting
      logical matrices x.

    * File NEWS is now in UTF-8, and has a BOM (often invisible) on the
      first line, and Emacs local variables set for UTF-8 at the end.
      RShowDoc("NEWS") should display this correctly, given suitable
      fonts.

    * terms.formula(simplify = TRUE) now does not deparse the LHS and
      so preserves non-standard responses such as `a: b` (requested by
      Sundar Dorai-Raj).

    * New function news() for building and querying R or package news
      information.

    * z^n for integer n and complex z is more accurate now if |n| <=
      65536.

    * factor(NULL) now returns the same as factor(character(0)) instead
      of an error, and table(NULL) consequently does analogously.

    * as.data.frame.vector() (and its copies) is slightly faster by
      avoiding a copy if there are no names (following a suggestion of
      Tim Hesterberg).

    * writeLines(), writeBin() and writeChar() have a new argument
      useBytes.  If false, character strings with marked encodings are
      translated to the current locale (as before) but if true they are
      written byte-by-byte.

    * iconv() has a new argument mark which can be used (by experts) to
      suppress the declaration of encodings.

    * DESCRIPTION file's LinkingTo specs are now recognized as
      installation dependencies, and included in package management
      computations.

    * Standardized DESCRIPTION file License specs are now available for
      package management computations.

    * "\uxxxx" and "\Uxxxxxxxx" escapes can now be parsed to a UTF-8
      encoded string even in non-UTF-8 locales (this has been
      implemented on Windows since R 2.7.0).  The semantics have been
      changed slightly: a string containing such escapes is always
      stored in UTF-8 (and hence is suitable for portably including
      Unicode text in packages).

    * New as.raw() method for "tclObj" objects (wish of PR#13758).

    * Rd.sty now makes a better job of setting email addresses,
      including using a monospaced font.

    * textConnection() gains an encoding argument to determine how
      input strings with marked encodings will be handled.

    * R CMD Rd2pdf is available as a shortcut for R CMD Rd2dvi --pdf.

    * R CMD check now checks links where a package is specified
      (\link[pkg]{file} or \link[pkg:file]{topic}), if the package is
      available.  It notes if the package is not available, as in many
      cases this is an error in the link.

    * identical() gains three logical arguments, which allow for even
      more differentiation, notably -0 and 0.

    * legend() now can specify the border color of filled boxes, thanks
      to a patch from Frederic Schutz.

    * Indexing with a vector index to [[ ]] has now been extended to
      all recursive types.

    * Pairlists may now be assigned as elements of lists.  (Lists could
      always be created with pairlist elements, but [[<- didn't support
      assigning them.)

    * The parser now supports C-preprocessor-like #line directives, so
      error messages and source references may refer to the original
      file rather than an intermediate one.

    * New functions findLineNum() and setBreakpoint() work with the
      source references to find the location of source lines and set
      breakpoints (using trace()) at those lines.

    * Namespace importing is more careful about warning on masked
      generics, thanks to a patch by Yohan Chalabi.

    * detach() now has an argument character.only with the same meaning
      as for library() or require().

    * available.packages() gains a filters argument for specifying the
      filtering operations performed on the packages found in the
      repositories.  A new built-in "license/FOSS" filter only retains
      packages for which installation can proceed solely based on
      packages which can be verified as Free or Open Source Software
      (FOSS) employing the available license specifications.

    * In registering an S3 class by a call to setOldClass(), the data
      part (e.g., the object type) required for the class can be
      included as one of the superclasses in the Classes argument.

    * The argument f to showMethods() can be an expression evaluating
      to a generic function, allowing methods to be shown for
      non-exported generics and other nonstandard cases.

    * sprintf() now supports %o for octal conversions.

    * New function Sys.readlink() for information about symbolic links,
      including if a file is a symbolic link.

    * Package tools has new functions checkRdaFiles() and
      resaveRdaFiles() to report on the format of .rda/.RData data
      files, and to re-save them in a different compressed format,
      including choosing the most compact format available.

      A new INSTALL option, --resave-data, makes use of this.

    * File ~/.R/config is used in preference to ~/.Rconfig, and these
      are now documented in 'R Installation and Administration'.

    * Logic operations with complex numbers now work, as they were
      always documented to, and as in S.

    * arrows() and segments() allow one of x1 or y1 to be omitted to
      simplify the specification of vertical or horizontal lines
      (suggestion of Tim Hesterberg).

    * approxfun() is faster by avoiding repeated NA checks (diagnosis
      and patch by Karline Soetaert & Thomas Petzoldt).

    * There are the beginnings of a Nynorsk translation by Karl Ove
      Hufthammer.

    * stripchart() allows par bg to be passed in for the background
      colour for pch = 21 (wish of PR#13984).

    * New generic function .DollarNames() to enable class authors to
      customize completion after the $ extractor.

    * load(), save(), dput() and dump() now open a not-yet-open
      connection in the appropriate mode (as other functions using
      connections directly already did).

  REGULAR EXPRESSIONS:

    * A different regular expression engine is used for basic and
      extended regexps and is also for approximate matching.  This is
      based on the TRE library of Ville Laurikari, a modified copy of
      which is included in the R sources.

      This is often faster, especially in a MBCS locale.

      Some known differences are that it is less tolerant of invalid
      inputs in MBCS locales, and in its interpretation of undefined
      (extended) regexps such as "^*".  Also, the interpretation of
      ranges such as [W-z] in caseless matching is no longer to map the
      range to lower case.

      This engine may in future be used in 'literal' mode for fixed =
      TRUE, and there is a compile-time option in src/main/grep.c to do
      so.

    * The use of repeated boundary regexps in gsub() and gregexpr() as
      warned about in the help page does not work in this engine (it
      did in the previous one since 2005).

    * Extended (and basic) regexps now support same set of options as
      for fixed = TRUE and perl = TRUE, including useBytes and support
      for UTF-8-encoded strings in non-UTF-8 locales.

    * agrep() now has full support for MBCS locales with a modest speed
      penalty.  This enables help.search() to use approximate matching
      character-wise rather than byte-wise.

    * [g]sub use a single-pass algorithm instead of matching twice and
      so is usually faster.

    * The perl = TRUE versions now work correctly in a non-UTF-8 MBCS
      locale, by translating the inputs to UTF-8.

    * useBytes = TRUE now inhibits the translation of inputs with
      marked encodings.

    * strsplit() gains a useBytes argument.

    * The algorithm used by strsplit() has been reordered to batch by
      elements of split: this can be much faster for fixed = FALSE (as
      multiple compilation of regexps is avoided).

    * The help pages, including ?regexp, have been updated and should
      be consulted for details of the new implementations.

  HELP & Rd FILE CHANGES:

    * A new dynamic HTML help system is used by default, and may be
      controlled using tools::startDynamicHelp().  With this enabled,
      HTML help pages will be generated on request, resolving links by
      searching through the current .libPaths().  The user may set
      options("help.ports") to control which IP port is used by the
      server.

    * help.start() no longer sets options(htmlhelp = TRUE) (it used to
      on Unix but not on Windows).  Nor does it on Unix reset the
      "browser" option if given an argument of that name.

      Arguments update and remote are now available on all platforms:
      the default is update = FALSE since the http server will update
      the package index at first use.

    * help() has a new argument help_type (with default set by the
      option of that name) to supersede arguments offline, htmlhelp and
      chmhelp (although for now they still work if help_type is unset).
      There is a new type, "PDF" to allow offline PDF (rather than
      PostScript).

      A function offline_help_helper() will be used if this exists in
      the workspace or further down the search path, otherwise the
      function of that name in the utils namespace is used.

    * Plain text help is now used as the fallback for HTML help (as it
      always was for Compiled HTML help on Windows).

    * It is possible to ask for static HTML pages to be prebuilt _via_
      the configure option --enable-prebuilt-html.  This may be useful
      for those who wish to make HTML help available outside R, e.g. on
      a local web site.

    * An experimental tag \Sexpr has been added to Rd files, to
      evaluate expressions at build, install, or render time.
      Currently install time and render time evaluation are supported.

    * Tags \if, \ifelse and \out have been added to allow
      format-specific (or more general, using \Sexpr) conditional text
      in man pages.

    * The parse_Rd() parser has been made more tolerant of coding
      errors in Rd files: now all syntax errors are reported as
      warnings, and an attempt is made to continue parsing.

    * parse_Rd() now has an argument fragment (default FALSE) to accept
      small fragments of Rd files (so that \Sexpr can output Rd code
      which is then parsed).

    * parse_Rd() now always converts its input to UTF-8.  The Rd2*
      rendering functions have a new argument, outputEncoding, which
      controls how their output is encoded.

    * parse_Rd() no longer includes the newline as part of a "%"-style
      comment.

    * There have been various bug fixes and code reorganization in the
      Rd renderers Rd2HTML, Rd2latex, Rd2txt, and Rd2ex.

      All example files are now created with either ASCII or UTF-8
      encoding, and the encoding is only marked in the file if there is
      any non-UTF-8 code (previously it was marked if the help file had
      non-ASCII contents, possibly in other sections).

    * print.Rd() now adds necessary escape characters so that printing
      and re-parsing an Rd object should produce an equivalent object.

    * parse_Rd() was incorrectly handling multiple backslashes in R
      code strings, converting 4n+3 backslashes to 2n+1 instead of
      2n+2.

    * parse_Rd() now recognizes the \var tag within a quoted string in
      R-like text.

    * parse_Rd() now treats the argument of \command as LaTeX-like,
      rather than verbatim.

  COMPRESSION:

    * New function untar() to list or unpack tar archives, possibly
      compressed.  This uses either an external tar command or an
      internal implementation.

    * New function tar() to create (possibly compressed) tar archives.

    * New functions memCompress() and memDecompress() for in-memory
      compression and decompression.

    * bzfile() has a compress argument to select the amount of effort
      put into compression when writing.

    * New function xzfile() for use with xz-compressed files.  (This
      can also read files compressed by some versions of lzma.)

    * gzfile() looks at the file header and so can now also read
      bzip2-ed files and xz-compressed files.

    * There are the new options of save(compress = "bzip2") and "xz" to
      use bzip2 or xz compression (which will be slower, but can give
      substantially smaller files).  Argument compression_level gives
      finer control over the space/time tradeoffs.

      load() can read such saves (but only as from this version of R).

    * R CMD INSTALL/check and tools::writePACKAGES accept a wider range
      of compressed tar archives.  Precisely how wide depends on the
      capabilities of the host system's tar command: they almost always
      include .tar.bz2 archives, and with modern versions of tar other
      forms of compression such as lzma and xz, and arbitrary
      extensions.

    * R CMD INSTALL has a new option --data-compress to control the
      compression used when lazy-loading data.  New possibilities are
      --data-compress=bzip2 which will give ca 15% better compression
      at the expense of slower installation times, and
      --data-compress=xz, often giving even better compression on large
      datasets at the expense of much longer installation times.  (The
      latter is used for the recommended packages: it is particularly
      effective for survival.)

    * file() for open = "", "r" or "rt" will automagically detect
      compressed files (from gzip, bzip2 or xz).  This means that
      compressed files can be specified by file name (rather than _via_
      a gzfile() connection) to read.table(), readlines(), scan() and
      so on.

    * data() can handle compressed text files with extensions
      .{txt,tab,csv}.{gz,bz2,xz} .

  DEPRECATED & DEFUNCT:

    * png(type="cairo1") is defunct: the value is no longer recognized.

    * tools::Rd_parse() is defunct (as this version of R uses only Rd
      version 2).

    * Use of file ~/.Rconf (which was deprecated in favour of
      ~/.Rconfig in 2004) has finally been removed.

    * Bundles of packages are deprecated.  See 'Writing R Extensions'
      for the steps needed to unbundle a bundle.

    * help() arguments offline, htmlhelp and chmhelp are deprecated in
      favour of help_type.

    * clearNames() (in package stats) is deprecated for unname().

    * Basic regular expressions (extended = FALSE) are deprecated in
      strsplit, grep and friends.  There is a precise POSIX standard
      for them, but it is not what recent RE engines implement, and it
      seems that in almost all cases package authors intended fixed =
      TRUE when using extended = FALSE.

    * methods::trySilent() is deprecated in favour of try(silent=TRUE)
      or - more efficiently and flexibly - something like
      tryCatch(error = function(e) e).

    * index.search() is deprecated: there are no longer directories of
      types other than help.

  INSTALLATION:

    * cairo >= 1.2 is now required (1.2.0 was released in July 2006)
      for cairo-based graphics devices (which remain optional).

    * A suitable iconv() is now required: support for configure option
      --without-iconv has been withdrawn (it was deprecated in R
      2.5.0).

    * Perl is no longer 'essential'.  R can be built without it, but
      scripts R CMD build, check, Rprof and Sd2d currently require it.

    * A system glob function is now essential (a working Sys.glob() has
      been assumed since R 2.9.0 at least).

    * C99 support for MBCS is now required, and configure option
      --disable-mbcs has been withdrawn.

    * Having a version of tar capable of automagically detecting
      compressed archives is useful for utils::untar(), and so gtar (a
      common name for GNU tar) is preferred to tar: set environment
      variable TAR to specify a particular tar command.

  INTERNATIONALIZATION:

    * There is some makefile support for adding/updating translations
      in packages: see po/README and 'Writing R Extensions'.

      There is support for the use of dngettext for C-level
      translations in packages: see 'Writing R Extensions'.

  BUG FIXES:

    * Assigning an extra 0-length column to a data frame by DF[, "foo"]
      <- value now works in most cases (by filling with NAs) or fails.
      (It used to give a corrupt data frame.)

    * validObject() avoids an error during evaluation in the case of
      various incorrect slot definitions.

    * n:m now returns a result of type "integer" in a few more boundary
      cases.

    * The zap.ind argument to printCoefmat() did not usually work as
      other code attempted to ensure that non-zero values had a
      non-zero representation.

    * printCoefmat() formatted groups of columns together, not just the
      cs.ind group but also the zap.ind group and a residual group.  It
      now formats all columns except the cs.ind group separately (and
      zaps the zap.ind group column-by-column).  The main effect will
      be see in the output from print.anova(), as this grouped SS-like
      columns in the zap.ind group.

    * R_ReplDLLinit() initializes the top-level jump so that some
      embedded applications on Windows no longer crash on error.

    * identical() failed to take the encoding of character strings into
      account, so identical byte patterns are not necessarily identical
      strings, and similarly Latin-1 and UTF-8 versions of the same
      string differ in byte pattern.

    * methods(f) used to warn unnecessarily for an S4 generic f which
      had been created based on an existing S3 generic.

    * The check for consistent ordering of superclasses was not
      ignoring all conditional relations (the symptom was usually
      spurious warnings for classes extending "array").

    * Trying to assign into a raw vector with an index vector
      containing NAs could cause a segfault.  Reported by Herve Pages.

    * Rscript could segfault if (by user error) its filename argument
      was missing.  Reported by Martin Morgan.

    * getAnywhere() (and functions that use it, including argument
      completion in the console) did not handle special built-in
      functions.  Reported by Romain Francois.

    * order() was missing a PROTECT() call and so could segfault when
      called on character data under certain (rare) circumstances
      involving marked non-native encodings.

    * prettyNum(z, drop0trailing=TRUE) did not work correctly when z
      was a complex vector.  Consequently, str(z, ...) also did not.
      (PR#13985)

    * make distclean removed too many files in etc/ if builddir =
      srcdir.

    * R CMD replaced TEXINPUTS rather than appending to it (as
      documented and intended).

    * help.start() no longer fails on unix when "browser" is a
      function.

    * pbeta(x, ..., log.p = TRUE) is sometimes more accurate, e.g., for
      very small x.

    * Unserializing a pre-2.8 workspace containing pure ASCII character
      objects with a Latin-1 or UTF-8 encoding would corrupt the
      CHARSXP cache.

